<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Project_Portfolio_Request_ReferencesType StructType
 * Meta information extracted from the WSDL
 * - documentation: Project Portfolio Request Reference Element
 * @subpackage Structs
 */
class Project_Portfolio_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Project_Portfolio_Reference
     * Meta information extracted from the WSDL
     * - documentation: Project Portfolio Request Reference Element
     * - maxOccurs: unbounded
     * @var \StructType\Project_PortfolioObjectType[]
     */
    public $Project_Portfolio_Reference;
    /**
     * Constructor method for Project_Portfolio_Request_ReferencesType
     * @uses Project_Portfolio_Request_ReferencesType::setProject_Portfolio_Reference()
     * @param \StructType\Project_PortfolioObjectType[] $project_Portfolio_Reference
     */
    public function __construct(array $project_Portfolio_Reference = array())
    {
        $this
            ->setProject_Portfolio_Reference($project_Portfolio_Reference);
    }
    /**
     * Get Project_Portfolio_Reference value
     * @return \StructType\Project_PortfolioObjectType[]|null
     */
    public function getProject_Portfolio_Reference()
    {
        return $this->Project_Portfolio_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setProject_Portfolio_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProject_Portfolio_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProject_Portfolio_ReferenceForArrayConstraintsFromSetProject_Portfolio_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $project_Portfolio_Request_ReferencesTypeProject_Portfolio_ReferenceItem) {
            // validation for constraint: itemType
            if (!$project_Portfolio_Request_ReferencesTypeProject_Portfolio_ReferenceItem instanceof \StructType\Project_PortfolioObjectType) {
                $invalidValues[] = is_object($project_Portfolio_Request_ReferencesTypeProject_Portfolio_ReferenceItem) ? get_class($project_Portfolio_Request_ReferencesTypeProject_Portfolio_ReferenceItem) : sprintf('%s(%s)', gettype($project_Portfolio_Request_ReferencesTypeProject_Portfolio_ReferenceItem), var_export($project_Portfolio_Request_ReferencesTypeProject_Portfolio_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Project_Portfolio_Reference property can only contain items of type \StructType\Project_PortfolioObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Project_Portfolio_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Project_PortfolioObjectType[] $project_Portfolio_Reference
     * @return \StructType\Project_Portfolio_Request_ReferencesType
     */
    public function setProject_Portfolio_Reference(array $project_Portfolio_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($project_Portfolio_ReferenceArrayErrorMessage = self::validateProject_Portfolio_ReferenceForArrayConstraintsFromSetProject_Portfolio_Reference($project_Portfolio_Reference))) {
            throw new \InvalidArgumentException($project_Portfolio_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Project_Portfolio_Reference = $project_Portfolio_Reference;
        return $this;
    }
    /**
     * Add item to Project_Portfolio_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Project_PortfolioObjectType $item
     * @return \StructType\Project_Portfolio_Request_ReferencesType
     */
    public function addToProject_Portfolio_Reference(\StructType\Project_PortfolioObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Project_PortfolioObjectType) {
            throw new \InvalidArgumentException(sprintf('The Project_Portfolio_Reference property can only contain items of type \StructType\Project_PortfolioObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Project_Portfolio_Reference[] = $item;
        return $this;
    }
}
