<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Project_TemplateType StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains all project template references and data.
 * @subpackage Structs
 */
class Project_TemplateType extends AbstractStructBase
{
    /**
     * The Project_Template_Reference
     * Meta information extracted from the WSDL
     * - documentation: The instance of a project template.
     * - minOccurs: 0
     * @var \StructType\Project_TemplateObjectType
     */
    public $Project_Template_Reference;
    /**
     * The Project_Template_Data
     * Meta information extracted from the WSDL
     * - documentation: Contains the detailed information about a project template.
     * - minOccurs: 0
     * @var \StructType\Project_Template_DataType
     */
    public $Project_Template_Data;
    /**
     * Constructor method for Project_TemplateType
     * @uses Project_TemplateType::setProject_Template_Reference()
     * @uses Project_TemplateType::setProject_Template_Data()
     * @param \StructType\Project_TemplateObjectType $project_Template_Reference
     * @param \StructType\Project_Template_DataType $project_Template_Data
     */
    public function __construct(\StructType\Project_TemplateObjectType $project_Template_Reference = null, \StructType\Project_Template_DataType $project_Template_Data = null)
    {
        $this
            ->setProject_Template_Reference($project_Template_Reference)
            ->setProject_Template_Data($project_Template_Data);
    }
    /**
     * Get Project_Template_Reference value
     * @return \StructType\Project_TemplateObjectType|null
     */
    public function getProject_Template_Reference()
    {
        return $this->Project_Template_Reference;
    }
    /**
     * Set Project_Template_Reference value
     * @param \StructType\Project_TemplateObjectType $project_Template_Reference
     * @return \StructType\Project_TemplateType
     */
    public function setProject_Template_Reference(\StructType\Project_TemplateObjectType $project_Template_Reference = null)
    {
        $this->Project_Template_Reference = $project_Template_Reference;
        return $this;
    }
    /**
     * Get Project_Template_Data value
     * @return \StructType\Project_Template_DataType|null
     */
    public function getProject_Template_Data()
    {
        return $this->Project_Template_Data;
    }
    /**
     * Set Project_Template_Data value
     * @param \StructType\Project_Template_DataType $project_Template_Data
     * @return \StructType\Project_TemplateType
     */
    public function setProject_Template_Data(\StructType\Project_Template_DataType $project_Template_Data = null)
    {
        $this->Project_Template_Data = $project_Template_Data;
        return $this;
    }
}
