<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Credit_Card_Code_Mapping_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Put Credit Card Code Mapping Request
 * @subpackage Structs
 */
class Put_Credit_Card_Code_Mapping_RequestType extends AbstractStructBase
{
    /**
     * The Expense_Item_Reference
     * Meta information extracted from the WSDL
     * - documentation: Expense Item Reference
     * - minOccurs: 0
     * @var \StructType\Expense_ItemObjectType
     */
    public $Expense_Item_Reference;
    /**
     * The Credit_Card_Code_Mapping_Data
     * @var \StructType\Credit_Card_Code_Mapping_DataType
     */
    public $Credit_Card_Code_Mapping_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Credit_Card_Code_Mapping_RequestType
     * @uses Put_Credit_Card_Code_Mapping_RequestType::setExpense_Item_Reference()
     * @uses Put_Credit_Card_Code_Mapping_RequestType::setCredit_Card_Code_Mapping_Data()
     * @uses Put_Credit_Card_Code_Mapping_RequestType::setVersion()
     * @param \StructType\Expense_ItemObjectType $expense_Item_Reference
     * @param \StructType\Credit_Card_Code_Mapping_DataType $credit_Card_Code_Mapping_Data
     * @param string $version
     */
    public function __construct(\StructType\Expense_ItemObjectType $expense_Item_Reference = null, \StructType\Credit_Card_Code_Mapping_DataType $credit_Card_Code_Mapping_Data = null, $version = null)
    {
        $this
            ->setExpense_Item_Reference($expense_Item_Reference)
            ->setCredit_Card_Code_Mapping_Data($credit_Card_Code_Mapping_Data)
            ->setVersion($version);
    }
    /**
     * Get Expense_Item_Reference value
     * @return \StructType\Expense_ItemObjectType|null
     */
    public function getExpense_Item_Reference()
    {
        return $this->Expense_Item_Reference;
    }
    /**
     * Set Expense_Item_Reference value
     * @param \StructType\Expense_ItemObjectType $expense_Item_Reference
     * @return \StructType\Put_Credit_Card_Code_Mapping_RequestType
     */
    public function setExpense_Item_Reference(\StructType\Expense_ItemObjectType $expense_Item_Reference = null)
    {
        $this->Expense_Item_Reference = $expense_Item_Reference;
        return $this;
    }
    /**
     * Get Credit_Card_Code_Mapping_Data value
     * @return \StructType\Credit_Card_Code_Mapping_DataType|null
     */
    public function getCredit_Card_Code_Mapping_Data()
    {
        return $this->Credit_Card_Code_Mapping_Data;
    }
    /**
     * Set Credit_Card_Code_Mapping_Data value
     * @param \StructType\Credit_Card_Code_Mapping_DataType $credit_Card_Code_Mapping_Data
     * @return \StructType\Put_Credit_Card_Code_Mapping_RequestType
     */
    public function setCredit_Card_Code_Mapping_Data(\StructType\Credit_Card_Code_Mapping_DataType $credit_Card_Code_Mapping_Data = null)
    {
        $this->Credit_Card_Code_Mapping_Data = $credit_Card_Code_Mapping_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Credit_Card_Code_Mapping_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
