<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Internal_Service_Provider_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing Put Internal Service Provider Response Data.
 * @subpackage Structs
 */
class Put_Internal_Service_Provider_ResponseType extends AbstractStructBase
{
    /**
     * The Internal_Service_Provider_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Internal Service Provider for update only purposes
     * - minOccurs: 0
     * @var \StructType\Internal_Service_ProviderObjectType
     */
    public $Internal_Service_Provider_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Internal_Service_Provider_ResponseType
     * @uses Put_Internal_Service_Provider_ResponseType::setInternal_Service_Provider_Reference()
     * @uses Put_Internal_Service_Provider_ResponseType::setVersion()
     * @param \StructType\Internal_Service_ProviderObjectType $internal_Service_Provider_Reference
     * @param string $version
     */
    public function __construct(\StructType\Internal_Service_ProviderObjectType $internal_Service_Provider_Reference = null, $version = null)
    {
        $this
            ->setInternal_Service_Provider_Reference($internal_Service_Provider_Reference)
            ->setVersion($version);
    }
    /**
     * Get Internal_Service_Provider_Reference value
     * @return \StructType\Internal_Service_ProviderObjectType|null
     */
    public function getInternal_Service_Provider_Reference()
    {
        return $this->Internal_Service_Provider_Reference;
    }
    /**
     * Set Internal_Service_Provider_Reference value
     * @param \StructType\Internal_Service_ProviderObjectType $internal_Service_Provider_Reference
     * @return \StructType\Put_Internal_Service_Provider_ResponseType
     */
    public function setInternal_Service_Provider_Reference(\StructType\Internal_Service_ProviderObjectType $internal_Service_Provider_Reference = null)
    {
        $this->Internal_Service_Provider_Reference = $internal_Service_Provider_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Internal_Service_Provider_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
