<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Item_Identifier_Type_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: The element containing put item identifier type response.
 * @subpackage Structs
 */
class Put_Item_Identifier_Type_ResponseType extends AbstractStructBase
{
    /**
     * The Item_Identifier_Type_Reference
     * Meta information extracted from the WSDL
     * - documentation: The reference to item identifier type.
     * - minOccurs: 0
     * @var \StructType\Item_Identifier_TypeObjectType
     */
    public $Item_Identifier_Type_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Item_Identifier_Type_ResponseType
     * @uses Put_Item_Identifier_Type_ResponseType::setItem_Identifier_Type_Reference()
     * @uses Put_Item_Identifier_Type_ResponseType::setVersion()
     * @param \StructType\Item_Identifier_TypeObjectType $item_Identifier_Type_Reference
     * @param string $version
     */
    public function __construct(\StructType\Item_Identifier_TypeObjectType $item_Identifier_Type_Reference = null, $version = null)
    {
        $this
            ->setItem_Identifier_Type_Reference($item_Identifier_Type_Reference)
            ->setVersion($version);
    }
    /**
     * Get Item_Identifier_Type_Reference value
     * @return \StructType\Item_Identifier_TypeObjectType|null
     */
    public function getItem_Identifier_Type_Reference()
    {
        return $this->Item_Identifier_Type_Reference;
    }
    /**
     * Set Item_Identifier_Type_Reference value
     * @param \StructType\Item_Identifier_TypeObjectType $item_Identifier_Type_Reference
     * @return \StructType\Put_Item_Identifier_Type_ResponseType
     */
    public function setItem_Identifier_Type_Reference(\StructType\Item_Identifier_TypeObjectType $item_Identifier_Type_Reference = null)
    {
        $this->Item_Identifier_Type_Reference = $item_Identifier_Type_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Item_Identifier_Type_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
