<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Project_Worker_Role_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing Put Project Worker Role Response Data
 * @subpackage Structs
 */
class Put_Project_Worker_Role_ResponseType extends AbstractStructBase
{
    /**
     * The Project_Worker_Role_Reference
     * Meta information extracted from the WSDL
     * - documentation: Project Worker Role Reference
     * - minOccurs: 0
     * @var \StructType\Project_RoleObjectType
     */
    public $Project_Worker_Role_Reference;
    /**
     * The Project_Worker_Role_Data
     * Meta information extracted from the WSDL
     * - documentation: Project Worker Role Data
     * - minOccurs: 0
     * @var \StructType\Project_Worker_Role_DataType
     */
    public $Project_Worker_Role_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Project_Worker_Role_ResponseType
     * @uses Put_Project_Worker_Role_ResponseType::setProject_Worker_Role_Reference()
     * @uses Put_Project_Worker_Role_ResponseType::setProject_Worker_Role_Data()
     * @uses Put_Project_Worker_Role_ResponseType::setVersion()
     * @param \StructType\Project_RoleObjectType $project_Worker_Role_Reference
     * @param \StructType\Project_Worker_Role_DataType $project_Worker_Role_Data
     * @param string $version
     */
    public function __construct(\StructType\Project_RoleObjectType $project_Worker_Role_Reference = null, \StructType\Project_Worker_Role_DataType $project_Worker_Role_Data = null, $version = null)
    {
        $this
            ->setProject_Worker_Role_Reference($project_Worker_Role_Reference)
            ->setProject_Worker_Role_Data($project_Worker_Role_Data)
            ->setVersion($version);
    }
    /**
     * Get Project_Worker_Role_Reference value
     * @return \StructType\Project_RoleObjectType|null
     */
    public function getProject_Worker_Role_Reference()
    {
        return $this->Project_Worker_Role_Reference;
    }
    /**
     * Set Project_Worker_Role_Reference value
     * @param \StructType\Project_RoleObjectType $project_Worker_Role_Reference
     * @return \StructType\Put_Project_Worker_Role_ResponseType
     */
    public function setProject_Worker_Role_Reference(\StructType\Project_RoleObjectType $project_Worker_Role_Reference = null)
    {
        $this->Project_Worker_Role_Reference = $project_Worker_Role_Reference;
        return $this;
    }
    /**
     * Get Project_Worker_Role_Data value
     * @return \StructType\Project_Worker_Role_DataType|null
     */
    public function getProject_Worker_Role_Data()
    {
        return $this->Project_Worker_Role_Data;
    }
    /**
     * Set Project_Worker_Role_Data value
     * @param \StructType\Project_Worker_Role_DataType $project_Worker_Role_Data
     * @return \StructType\Put_Project_Worker_Role_ResponseType
     */
    public function setProject_Worker_Role_Data(\StructType\Project_Worker_Role_DataType $project_Worker_Role_Data = null)
    {
        $this->Project_Worker_Role_Data = $project_Worker_Role_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Project_Worker_Role_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
