<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Resource_Category_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing Put Spend Category Response Data
 * @subpackage Structs
 */
class Put_Resource_Category_ResponseType extends AbstractStructBase
{
    /**
     * The Resource_Category_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Spend Category
     * - minOccurs: 0
     * @var \StructType\Spend_CategoryObjectType
     */
    public $Resource_Category_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Resource_Category_ResponseType
     * @uses Put_Resource_Category_ResponseType::setResource_Category_Reference()
     * @uses Put_Resource_Category_ResponseType::setVersion()
     * @param \StructType\Spend_CategoryObjectType $resource_Category_Reference
     * @param string $version
     */
    public function __construct(\StructType\Spend_CategoryObjectType $resource_Category_Reference = null, $version = null)
    {
        $this
            ->setResource_Category_Reference($resource_Category_Reference)
            ->setVersion($version);
    }
    /**
     * Get Resource_Category_Reference value
     * @return \StructType\Spend_CategoryObjectType|null
     */
    public function getResource_Category_Reference()
    {
        return $this->Resource_Category_Reference;
    }
    /**
     * Set Resource_Category_Reference value
     * @param \StructType\Spend_CategoryObjectType $resource_Category_Reference
     * @return \StructType\Put_Resource_Category_ResponseType
     */
    public function setResource_Category_Reference(\StructType\Spend_CategoryObjectType $resource_Category_Reference = null)
    {
        $this->Resource_Category_Reference = $resource_Category_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Resource_Category_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
