<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for
 * Put_Supplier_Invoice_System_Validation_Configuration_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing the Supplier Invoice System Validation Configuration references that was updated.
 * @subpackage Structs
 */
class Put_Supplier_Invoice_System_Validation_Configuration_ResponseType extends AbstractStructBase
{
    /**
     * The Supplier_Invoice_System_Validation_Configuration_Reference
     * Meta information extracted from the WSDL
     * - documentation: References to the updated Supplier Invoice System Validation Configurations.
     * - minOccurs: 0
     * @var \StructType\Supplier_Invoice_System_Validation_ConfigurationObjectType
     */
    public $Supplier_Invoice_System_Validation_Configuration_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for
     * Put_Supplier_Invoice_System_Validation_Configuration_ResponseType
     * @uses Put_Supplier_Invoice_System_Validation_Configuration_ResponseType::setSupplier_Invoice_System_Validation_Configuration_Reference()
     * @uses Put_Supplier_Invoice_System_Validation_Configuration_ResponseType::setVersion()
     * @param \StructType\Supplier_Invoice_System_Validation_ConfigurationObjectType $supplier_Invoice_System_Validation_Configuration_Reference
     * @param string $version
     */
    public function __construct(\StructType\Supplier_Invoice_System_Validation_ConfigurationObjectType $supplier_Invoice_System_Validation_Configuration_Reference = null, $version = null)
    {
        $this
            ->setSupplier_Invoice_System_Validation_Configuration_Reference($supplier_Invoice_System_Validation_Configuration_Reference)
            ->setVersion($version);
    }
    /**
     * Get Supplier_Invoice_System_Validation_Configuration_Reference value
     * @return \StructType\Supplier_Invoice_System_Validation_ConfigurationObjectType|null
     */
    public function getSupplier_Invoice_System_Validation_Configuration_Reference()
    {
        return $this->Supplier_Invoice_System_Validation_Configuration_Reference;
    }
    /**
     * Set Supplier_Invoice_System_Validation_Configuration_Reference value
     * @param \StructType\Supplier_Invoice_System_Validation_ConfigurationObjectType $supplier_Invoice_System_Validation_Configuration_Reference
     * @return \StructType\Put_Supplier_Invoice_System_Validation_Configuration_ResponseType
     */
    public function setSupplier_Invoice_System_Validation_Configuration_Reference(\StructType\Supplier_Invoice_System_Validation_ConfigurationObjectType $supplier_Invoice_System_Validation_Configuration_Reference = null)
    {
        $this->Supplier_Invoice_System_Validation_Configuration_Reference = $supplier_Invoice_System_Validation_Configuration_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Supplier_Invoice_System_Validation_Configuration_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
