<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Transfer_Pricing_Rate_Sheet_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Root element for the Request on the Put operation.
 * @subpackage Structs
 */
class Put_Transfer_Pricing_Rate_Sheet_RequestType extends AbstractStructBase
{
    /**
     * The Transfer_Pricing_Rate_Sheet_Reference
     * Meta information extracted from the WSDL
     * - documentation: Contains transfer pricing rate sheet instances.
     * - minOccurs: 0
     * @var \StructType\Transfer_Pricing_Rate_SheetObjectType
     */
    public $Transfer_Pricing_Rate_Sheet_Reference;
    /**
     * The Transfer_Pricing_Rate_Sheet_Data
     * Meta information extracted from the WSDL
     * - documentation: Contains transfer pricing rate sheet data.
     * @var \StructType\Transfer_Pricing_Rate_Sheet_DataType
     */
    public $Transfer_Pricing_Rate_Sheet_Data;
    /**
     * The Add_Only
     * Meta information extracted from the WSDL
     * - documentation: Add Only
     * @var bool
     */
    public $Add_Only;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Transfer_Pricing_Rate_Sheet_RequestType
     * @uses Put_Transfer_Pricing_Rate_Sheet_RequestType::setTransfer_Pricing_Rate_Sheet_Reference()
     * @uses Put_Transfer_Pricing_Rate_Sheet_RequestType::setTransfer_Pricing_Rate_Sheet_Data()
     * @uses Put_Transfer_Pricing_Rate_Sheet_RequestType::setAdd_Only()
     * @uses Put_Transfer_Pricing_Rate_Sheet_RequestType::setVersion()
     * @param \StructType\Transfer_Pricing_Rate_SheetObjectType $transfer_Pricing_Rate_Sheet_Reference
     * @param \StructType\Transfer_Pricing_Rate_Sheet_DataType $transfer_Pricing_Rate_Sheet_Data
     * @param bool $add_Only
     * @param string $version
     */
    public function __construct(\StructType\Transfer_Pricing_Rate_SheetObjectType $transfer_Pricing_Rate_Sheet_Reference = null, \StructType\Transfer_Pricing_Rate_Sheet_DataType $transfer_Pricing_Rate_Sheet_Data = null, $add_Only = null, $version = null)
    {
        $this
            ->setTransfer_Pricing_Rate_Sheet_Reference($transfer_Pricing_Rate_Sheet_Reference)
            ->setTransfer_Pricing_Rate_Sheet_Data($transfer_Pricing_Rate_Sheet_Data)
            ->setAdd_Only($add_Only)
            ->setVersion($version);
    }
    /**
     * Get Transfer_Pricing_Rate_Sheet_Reference value
     * @return \StructType\Transfer_Pricing_Rate_SheetObjectType|null
     */
    public function getTransfer_Pricing_Rate_Sheet_Reference()
    {
        return $this->Transfer_Pricing_Rate_Sheet_Reference;
    }
    /**
     * Set Transfer_Pricing_Rate_Sheet_Reference value
     * @param \StructType\Transfer_Pricing_Rate_SheetObjectType $transfer_Pricing_Rate_Sheet_Reference
     * @return \StructType\Put_Transfer_Pricing_Rate_Sheet_RequestType
     */
    public function setTransfer_Pricing_Rate_Sheet_Reference(\StructType\Transfer_Pricing_Rate_SheetObjectType $transfer_Pricing_Rate_Sheet_Reference = null)
    {
        $this->Transfer_Pricing_Rate_Sheet_Reference = $transfer_Pricing_Rate_Sheet_Reference;
        return $this;
    }
    /**
     * Get Transfer_Pricing_Rate_Sheet_Data value
     * @return \StructType\Transfer_Pricing_Rate_Sheet_DataType|null
     */
    public function getTransfer_Pricing_Rate_Sheet_Data()
    {
        return $this->Transfer_Pricing_Rate_Sheet_Data;
    }
    /**
     * Set Transfer_Pricing_Rate_Sheet_Data value
     * @param \StructType\Transfer_Pricing_Rate_Sheet_DataType $transfer_Pricing_Rate_Sheet_Data
     * @return \StructType\Put_Transfer_Pricing_Rate_Sheet_RequestType
     */
    public function setTransfer_Pricing_Rate_Sheet_Data(\StructType\Transfer_Pricing_Rate_Sheet_DataType $transfer_Pricing_Rate_Sheet_Data = null)
    {
        $this->Transfer_Pricing_Rate_Sheet_Data = $transfer_Pricing_Rate_Sheet_Data;
        return $this;
    }
    /**
     * Get Add_Only value
     * @return bool|null
     */
    public function getAdd_Only()
    {
        return $this->Add_Only;
    }
    /**
     * Set Add_Only value
     * @param bool $add_Only
     * @return \StructType\Put_Transfer_Pricing_Rate_Sheet_RequestType
     */
    public function setAdd_Only($add_Only = null)
    {
        // validation for constraint: boolean
        if (!is_null($add_Only) && !is_bool($add_Only)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($add_Only, true), gettype($add_Only)), __LINE__);
        }
        $this->Add_Only = $add_Only;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Transfer_Pricing_Rate_Sheet_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
