<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Resource_Plan_Template_Request_ReferencesType StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains the request references to retrieve a specific instance(s) of resource plan template and its associated data.
 * @subpackage Structs
 */
class Resource_Plan_Template_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Resource_Plan_Template_Reference
     * Meta information extracted from the WSDL
     * - documentation: Contains the request references to retrieve a specific instance(s) of resource plan template and its associated data.
     * - maxOccurs: unbounded
     * @var \StructType\Project_Resource_Plan_TemplateObjectType[]
     */
    public $Resource_Plan_Template_Reference;
    /**
     * Constructor method for Resource_Plan_Template_Request_ReferencesType
     * @uses Resource_Plan_Template_Request_ReferencesType::setResource_Plan_Template_Reference()
     * @param \StructType\Project_Resource_Plan_TemplateObjectType[] $resource_Plan_Template_Reference
     */
    public function __construct(array $resource_Plan_Template_Reference = array())
    {
        $this
            ->setResource_Plan_Template_Reference($resource_Plan_Template_Reference);
    }
    /**
     * Get Resource_Plan_Template_Reference value
     * @return \StructType\Project_Resource_Plan_TemplateObjectType[]|null
     */
    public function getResource_Plan_Template_Reference()
    {
        return $this->Resource_Plan_Template_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setResource_Plan_Template_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setResource_Plan_Template_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateResource_Plan_Template_ReferenceForArrayConstraintsFromSetResource_Plan_Template_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $resource_Plan_Template_Request_ReferencesTypeResource_Plan_Template_ReferenceItem) {
            // validation for constraint: itemType
            if (!$resource_Plan_Template_Request_ReferencesTypeResource_Plan_Template_ReferenceItem instanceof \StructType\Project_Resource_Plan_TemplateObjectType) {
                $invalidValues[] = is_object($resource_Plan_Template_Request_ReferencesTypeResource_Plan_Template_ReferenceItem) ? get_class($resource_Plan_Template_Request_ReferencesTypeResource_Plan_Template_ReferenceItem) : sprintf('%s(%s)', gettype($resource_Plan_Template_Request_ReferencesTypeResource_Plan_Template_ReferenceItem), var_export($resource_Plan_Template_Request_ReferencesTypeResource_Plan_Template_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Resource_Plan_Template_Reference property can only contain items of type \StructType\Project_Resource_Plan_TemplateObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Resource_Plan_Template_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Project_Resource_Plan_TemplateObjectType[] $resource_Plan_Template_Reference
     * @return \StructType\Resource_Plan_Template_Request_ReferencesType
     */
    public function setResource_Plan_Template_Reference(array $resource_Plan_Template_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($resource_Plan_Template_ReferenceArrayErrorMessage = self::validateResource_Plan_Template_ReferenceForArrayConstraintsFromSetResource_Plan_Template_Reference($resource_Plan_Template_Reference))) {
            throw new \InvalidArgumentException($resource_Plan_Template_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Resource_Plan_Template_Reference = $resource_Plan_Template_Reference;
        return $this;
    }
    /**
     * Add item to Resource_Plan_Template_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Project_Resource_Plan_TemplateObjectType $item
     * @return \StructType\Resource_Plan_Template_Request_ReferencesType
     */
    public function addToResource_Plan_Template_Reference(\StructType\Project_Resource_Plan_TemplateObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Project_Resource_Plan_TemplateObjectType) {
            throw new \InvalidArgumentException(sprintf('The Resource_Plan_Template_Reference property can only contain items of type \StructType\Project_Resource_Plan_TemplateObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Resource_Plan_Template_Reference[] = $item;
        return $this;
    }
}
