<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Submit_Advanced_Ship_Notice_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Submit Advanced Ship Notice Response.
 * @subpackage Structs
 */
class Submit_Advanced_Ship_Notice_ResponseType extends AbstractStructBase
{
    /**
     * The Advanced_Ship_Notice_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to an existing Advanced Ship Notice.
     * - minOccurs: 0
     * @var \StructType\Advanced_Ship_NoticeObjectType
     */
    public $Advanced_Ship_Notice_Reference;
    /**
     * The Exceptions_Response_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Application_Instance_Related_Exceptions_DataType
     */
    public $Exceptions_Response_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Submit_Advanced_Ship_Notice_ResponseType
     * @uses Submit_Advanced_Ship_Notice_ResponseType::setAdvanced_Ship_Notice_Reference()
     * @uses Submit_Advanced_Ship_Notice_ResponseType::setExceptions_Response_Data()
     * @uses Submit_Advanced_Ship_Notice_ResponseType::setVersion()
     * @param \StructType\Advanced_Ship_NoticeObjectType $advanced_Ship_Notice_Reference
     * @param \StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data
     * @param string $version
     */
    public function __construct(\StructType\Advanced_Ship_NoticeObjectType $advanced_Ship_Notice_Reference = null, \StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data = null, $version = null)
    {
        $this
            ->setAdvanced_Ship_Notice_Reference($advanced_Ship_Notice_Reference)
            ->setExceptions_Response_Data($exceptions_Response_Data)
            ->setVersion($version);
    }
    /**
     * Get Advanced_Ship_Notice_Reference value
     * @return \StructType\Advanced_Ship_NoticeObjectType|null
     */
    public function getAdvanced_Ship_Notice_Reference()
    {
        return $this->Advanced_Ship_Notice_Reference;
    }
    /**
     * Set Advanced_Ship_Notice_Reference value
     * @param \StructType\Advanced_Ship_NoticeObjectType $advanced_Ship_Notice_Reference
     * @return \StructType\Submit_Advanced_Ship_Notice_ResponseType
     */
    public function setAdvanced_Ship_Notice_Reference(\StructType\Advanced_Ship_NoticeObjectType $advanced_Ship_Notice_Reference = null)
    {
        $this->Advanced_Ship_Notice_Reference = $advanced_Ship_Notice_Reference;
        return $this;
    }
    /**
     * Get Exceptions_Response_Data value
     * @return \StructType\Application_Instance_Related_Exceptions_DataType|null
     */
    public function getExceptions_Response_Data()
    {
        return $this->Exceptions_Response_Data;
    }
    /**
     * Set Exceptions_Response_Data value
     * @param \StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data
     * @return \StructType\Submit_Advanced_Ship_Notice_ResponseType
     */
    public function setExceptions_Response_Data(\StructType\Application_Instance_Related_Exceptions_DataType $exceptions_Response_Data = null)
    {
        $this->Exceptions_Response_Data = $exceptions_Response_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Submit_Advanced_Ship_Notice_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
