<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Supplier_ContractType StructType
 * Meta information extracted from the WSDL
 * - documentation: Wrapper element for Supplier Contract Reference and Hotel Data
 * @subpackage Structs
 */
class Supplier_ContractType extends AbstractStructBase
{
    /**
     * The Supplier_Contract_Reference
     * Meta information extracted from the WSDL
     * - documentation: Supplier Contract Reference
     * - minOccurs: 0
     * @var \StructType\Supplier_ContractObjectType
     */
    public $Supplier_Contract_Reference;
    /**
     * The Supplier_Contract_Data
     * Meta information extracted from the WSDL
     * - documentation: Supplier Contract Data
     * - minOccurs: 0
     * @var \StructType\Supplier_Contract_DataType
     */
    public $Supplier_Contract_Data;
    /**
     * Constructor method for Supplier_ContractType
     * @uses Supplier_ContractType::setSupplier_Contract_Reference()
     * @uses Supplier_ContractType::setSupplier_Contract_Data()
     * @param \StructType\Supplier_ContractObjectType $supplier_Contract_Reference
     * @param \StructType\Supplier_Contract_DataType $supplier_Contract_Data
     */
    public function __construct(\StructType\Supplier_ContractObjectType $supplier_Contract_Reference = null, \StructType\Supplier_Contract_DataType $supplier_Contract_Data = null)
    {
        $this
            ->setSupplier_Contract_Reference($supplier_Contract_Reference)
            ->setSupplier_Contract_Data($supplier_Contract_Data);
    }
    /**
     * Get Supplier_Contract_Reference value
     * @return \StructType\Supplier_ContractObjectType|null
     */
    public function getSupplier_Contract_Reference()
    {
        return $this->Supplier_Contract_Reference;
    }
    /**
     * Set Supplier_Contract_Reference value
     * @param \StructType\Supplier_ContractObjectType $supplier_Contract_Reference
     * @return \StructType\Supplier_ContractType
     */
    public function setSupplier_Contract_Reference(\StructType\Supplier_ContractObjectType $supplier_Contract_Reference = null)
    {
        $this->Supplier_Contract_Reference = $supplier_Contract_Reference;
        return $this;
    }
    /**
     * Get Supplier_Contract_Data value
     * @return \StructType\Supplier_Contract_DataType|null
     */
    public function getSupplier_Contract_Data()
    {
        return $this->Supplier_Contract_Data;
    }
    /**
     * Set Supplier_Contract_Data value
     * @param \StructType\Supplier_Contract_DataType $supplier_Contract_Data
     * @return \StructType\Supplier_ContractType
     */
    public function setSupplier_Contract_Data(\StructType\Supplier_Contract_DataType $supplier_Contract_Data = null)
    {
        $this->Supplier_Contract_Data = $supplier_Contract_Data;
        return $this;
    }
}
