<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Supplier_Invoice_Line_Additional_DataType StructType
 * Meta information extracted from the WSDL
 * - documentation: Wrapper element containing the Supplier Invoice Line additional data for requested references or criteria.
 * @subpackage Structs
 */
class Supplier_Invoice_Line_Additional_DataType extends AbstractStructBase
{
    /**
     * The Supplier_Invoice_Line_Reference
     * Meta information extracted from the WSDL
     * - documentation: The Supplier Invoice Line reference
     * - minOccurs: 0
     * @var \StructType\Supplier_Invoice_LineObjectType
     */
    public $Supplier_Invoice_Line_Reference;
    /**
     * The Business_Object_Additional_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Non_Effective_Dated_Web_Service_Additional_DataType
     */
    public $Business_Object_Additional_Data;
    /**
     * Constructor method for Supplier_Invoice_Line_Additional_DataType
     * @uses Supplier_Invoice_Line_Additional_DataType::setSupplier_Invoice_Line_Reference()
     * @uses Supplier_Invoice_Line_Additional_DataType::setBusiness_Object_Additional_Data()
     * @param \StructType\Supplier_Invoice_LineObjectType $supplier_Invoice_Line_Reference
     * @param \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data
     */
    public function __construct(\StructType\Supplier_Invoice_LineObjectType $supplier_Invoice_Line_Reference = null, \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data = null)
    {
        $this
            ->setSupplier_Invoice_Line_Reference($supplier_Invoice_Line_Reference)
            ->setBusiness_Object_Additional_Data($business_Object_Additional_Data);
    }
    /**
     * Get Supplier_Invoice_Line_Reference value
     * @return \StructType\Supplier_Invoice_LineObjectType|null
     */
    public function getSupplier_Invoice_Line_Reference()
    {
        return $this->Supplier_Invoice_Line_Reference;
    }
    /**
     * Set Supplier_Invoice_Line_Reference value
     * @param \StructType\Supplier_Invoice_LineObjectType $supplier_Invoice_Line_Reference
     * @return \StructType\Supplier_Invoice_Line_Additional_DataType
     */
    public function setSupplier_Invoice_Line_Reference(\StructType\Supplier_Invoice_LineObjectType $supplier_Invoice_Line_Reference = null)
    {
        $this->Supplier_Invoice_Line_Reference = $supplier_Invoice_Line_Reference;
        return $this;
    }
    /**
     * Get Business_Object_Additional_Data value
     * @return \StructType\Non_Effective_Dated_Web_Service_Additional_DataType|null
     */
    public function getBusiness_Object_Additional_Data()
    {
        return $this->Business_Object_Additional_Data;
    }
    /**
     * Set Business_Object_Additional_Data value
     * @param \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data
     * @return \StructType\Supplier_Invoice_Line_Additional_DataType
     */
    public function setBusiness_Object_Additional_Data(\StructType\Non_Effective_Dated_Web_Service_Additional_DataType $business_Object_Additional_Data = null)
    {
        $this->Business_Object_Additional_Data = $business_Object_Additional_Data;
        return $this;
    }
}
