<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Supplier_Invoice_Line_Request_CriteriaType StructType
 * Meta information extracted from the WSDL
 * - documentation: This element is the wrapper around a list of elements representing the supplier invoice-specific criteria needed to search for instances.
 * @subpackage Structs
 */
class Supplier_Invoice_Line_Request_CriteriaType extends AbstractStructBase
{
    /**
     * The Supplier_Invoice_Reference
     * Meta information extracted from the WSDL
     * - documentation: The Supplier Invoice reference
     * - maxOccurs: unbounded
     * @var \StructType\Supplier_Invoice_DocumentObjectType[]
     */
    public $Supplier_Invoice_Reference;
    /**
     * Constructor method for Supplier_Invoice_Line_Request_CriteriaType
     * @uses Supplier_Invoice_Line_Request_CriteriaType::setSupplier_Invoice_Reference()
     * @param \StructType\Supplier_Invoice_DocumentObjectType[] $supplier_Invoice_Reference
     */
    public function __construct(array $supplier_Invoice_Reference = array())
    {
        $this
            ->setSupplier_Invoice_Reference($supplier_Invoice_Reference);
    }
    /**
     * Get Supplier_Invoice_Reference value
     * @return \StructType\Supplier_Invoice_DocumentObjectType[]|null
     */
    public function getSupplier_Invoice_Reference()
    {
        return $this->Supplier_Invoice_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setSupplier_Invoice_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSupplier_Invoice_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSupplier_Invoice_ReferenceForArrayConstraintsFromSetSupplier_Invoice_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $supplier_Invoice_Line_Request_CriteriaTypeSupplier_Invoice_ReferenceItem) {
            // validation for constraint: itemType
            if (!$supplier_Invoice_Line_Request_CriteriaTypeSupplier_Invoice_ReferenceItem instanceof \StructType\Supplier_Invoice_DocumentObjectType) {
                $invalidValues[] = is_object($supplier_Invoice_Line_Request_CriteriaTypeSupplier_Invoice_ReferenceItem) ? get_class($supplier_Invoice_Line_Request_CriteriaTypeSupplier_Invoice_ReferenceItem) : sprintf('%s(%s)', gettype($supplier_Invoice_Line_Request_CriteriaTypeSupplier_Invoice_ReferenceItem), var_export($supplier_Invoice_Line_Request_CriteriaTypeSupplier_Invoice_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Supplier_Invoice_Reference property can only contain items of type \StructType\Supplier_Invoice_DocumentObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Supplier_Invoice_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Supplier_Invoice_DocumentObjectType[] $supplier_Invoice_Reference
     * @return \StructType\Supplier_Invoice_Line_Request_CriteriaType
     */
    public function setSupplier_Invoice_Reference(array $supplier_Invoice_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($supplier_Invoice_ReferenceArrayErrorMessage = self::validateSupplier_Invoice_ReferenceForArrayConstraintsFromSetSupplier_Invoice_Reference($supplier_Invoice_Reference))) {
            throw new \InvalidArgumentException($supplier_Invoice_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Supplier_Invoice_Reference = $supplier_Invoice_Reference;
        return $this;
    }
    /**
     * Add item to Supplier_Invoice_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Supplier_Invoice_DocumentObjectType $item
     * @return \StructType\Supplier_Invoice_Line_Request_CriteriaType
     */
    public function addToSupplier_Invoice_Reference(\StructType\Supplier_Invoice_DocumentObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Supplier_Invoice_DocumentObjectType) {
            throw new \InvalidArgumentException(sprintf('The Supplier_Invoice_Reference property can only contain items of type \StructType\Supplier_Invoice_DocumentObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Supplier_Invoice_Reference[] = $item;
        return $this;
    }
}
