<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Travel_Booking_Record_Request_ReferencesType StructType
 * Meta information extracted from the WSDL
 * - documentation: Travel Booking Record Reference element contains the specific instance set containing the requested Travel Booking Record
 * @subpackage Structs
 */
class Travel_Booking_Record_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Travel_Booking_Record_Reference
     * Meta information extracted from the WSDL
     * - documentation: Travel Booking Record Request References.
     * - maxOccurs: unbounded
     * @var \StructType\Travel_Booking_RecordObjectType[]
     */
    public $Travel_Booking_Record_Reference;
    /**
     * Constructor method for Travel_Booking_Record_Request_ReferencesType
     * @uses Travel_Booking_Record_Request_ReferencesType::setTravel_Booking_Record_Reference()
     * @param \StructType\Travel_Booking_RecordObjectType[] $travel_Booking_Record_Reference
     */
    public function __construct(array $travel_Booking_Record_Reference = array())
    {
        $this
            ->setTravel_Booking_Record_Reference($travel_Booking_Record_Reference);
    }
    /**
     * Get Travel_Booking_Record_Reference value
     * @return \StructType\Travel_Booking_RecordObjectType[]|null
     */
    public function getTravel_Booking_Record_Reference()
    {
        return $this->Travel_Booking_Record_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setTravel_Booking_Record_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTravel_Booking_Record_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTravel_Booking_Record_ReferenceForArrayConstraintsFromSetTravel_Booking_Record_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $travel_Booking_Record_Request_ReferencesTypeTravel_Booking_Record_ReferenceItem) {
            // validation for constraint: itemType
            if (!$travel_Booking_Record_Request_ReferencesTypeTravel_Booking_Record_ReferenceItem instanceof \StructType\Travel_Booking_RecordObjectType) {
                $invalidValues[] = is_object($travel_Booking_Record_Request_ReferencesTypeTravel_Booking_Record_ReferenceItem) ? get_class($travel_Booking_Record_Request_ReferencesTypeTravel_Booking_Record_ReferenceItem) : sprintf('%s(%s)', gettype($travel_Booking_Record_Request_ReferencesTypeTravel_Booking_Record_ReferenceItem), var_export($travel_Booking_Record_Request_ReferencesTypeTravel_Booking_Record_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Travel_Booking_Record_Reference property can only contain items of type \StructType\Travel_Booking_RecordObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Travel_Booking_Record_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Travel_Booking_RecordObjectType[] $travel_Booking_Record_Reference
     * @return \StructType\Travel_Booking_Record_Request_ReferencesType
     */
    public function setTravel_Booking_Record_Reference(array $travel_Booking_Record_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($travel_Booking_Record_ReferenceArrayErrorMessage = self::validateTravel_Booking_Record_ReferenceForArrayConstraintsFromSetTravel_Booking_Record_Reference($travel_Booking_Record_Reference))) {
            throw new \InvalidArgumentException($travel_Booking_Record_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Travel_Booking_Record_Reference = $travel_Booking_Record_Reference;
        return $this;
    }
    /**
     * Add item to Travel_Booking_Record_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Travel_Booking_RecordObjectType $item
     * @return \StructType\Travel_Booking_Record_Request_ReferencesType
     */
    public function addToTravel_Booking_Record_Reference(\StructType\Travel_Booking_RecordObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Travel_Booking_RecordObjectType) {
            throw new \InvalidArgumentException(sprintf('The Travel_Booking_Record_Reference property can only contain items of type \StructType\Travel_Booking_RecordObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Travel_Booking_Record_Reference[] = $item;
        return $this;
    }
}
