<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Supplier_Category_DataType' => '\\StructType\\Supplier_Category_DataType',
            'Supplier_Group_DataType' => '\\StructType\\Supplier_Group_DataType',
            'Purchase_Item_Group_DataType' => '\\StructType\\Purchase_Item_Group_DataType',
            'Purchase_Item_DataType' => '\\StructType\\Purchase_Item_DataType',
            'External_Integration_ID_DataType' => '\\StructType\\External_Integration_ID_DataType',
            'IDType' => '\\StructType\\IDType',
            'Supplier_DataType' => '\\StructType\\Supplier_DataType',
            'Financials_Attachment_DataType' => '\\StructType\\Financials_Attachment_DataType',
            'Expense_Item_Group_DataType' => '\\StructType\\Expense_Item_Group_DataType',
            'Expense_Item_DataType' => '\\StructType\\Expense_Item_DataType',
            'Business_Entity_Contact_DataType' => '\\StructType\\Business_Entity_Contact_DataType',
            'Business_Entity_Contact_Personal_DataType' => '\\StructType\\Business_Entity_Contact_Personal_DataType',
            'Response_FilterType' => '\\StructType\\Response_FilterType',
            'Response_ResultsType' => '\\StructType\\Response_ResultsType',
            'Worker_iData_ReferenceType' => '\\StructType\\Worker_iData_ReferenceType',
            'Business_Process_Comment_DataType' => '\\StructType\\Business_Process_Comment_DataType',
            'Business_Sub_Process_ParametersType' => '\\StructType\\Business_Sub_Process_ParametersType',
            'Legal_Name_DataType' => '\\StructType\\Legal_Name_DataType',
            'Person_Name_Detail_DataType' => '\\StructType\\Person_Name_Detail_DataType',
            'Person_Name_Prefix_DataType' => '\\StructType\\Person_Name_Prefix_DataType',
            'Person_Name_Suffix_DataType' => '\\StructType\\Person_Name_Suffix_DataType',
            'Contact_Information_DataType' => '\\StructType\\Contact_Information_DataType',
            'Address_Information_DataType' => '\\StructType\\Address_Information_DataType',
            'Phone_Information_DataType' => '\\StructType\\Phone_Information_DataType',
            'Email_Address_Information_DataType' => '\\StructType\\Email_Address_Information_DataType',
            'Instant_Messenger_Information_DataType' => '\\StructType\\Instant_Messenger_Information_DataType',
            'Web_Address_Information_DataType' => '\\StructType\\Web_Address_Information_DataType',
            'Address_Line_Information_DataType' => '\\StructType\\Address_Line_Information_DataType',
            'Submunicipality_Information_DataType' => '\\StructType\\Submunicipality_Information_DataType',
            'Subregion_Information_DataType' => '\\StructType\\Subregion_Information_DataType',
            'Communication_Method_Usage_Information_DataType' => '\\StructType\\Communication_Method_Usage_Information_DataType',
            'Communication_Usage_Type_DataType' => '\\StructType\\Communication_Usage_Type_DataType',
            'Corporate_Credit_Card_Account_DataType' => '\\StructType\\Corporate_Credit_Card_Account_DataType',
            'Expense_Credit_Card_DataType' => '\\StructType\\Expense_Credit_Card_DataType',
            'Supplier_Invoice_DataType' => '\\StructType\\Supplier_Invoice_DataType',
            'Submit_Supplier_Invoice_RequestType' => '\\StructType\\Submit_Supplier_Invoice_RequestType',
            'Submit_Supplier_Invoice_ResponseType' => '\\StructType\\Submit_Supplier_Invoice_ResponseType',
            'Supplier_Invoice_Line_Replacement_DataType' => '\\StructType\\Supplier_Invoice_Line_Replacement_DataType',
            'Financials_Business_Process_ParametersType' => '\\StructType\\Financials_Business_Process_ParametersType',
            'Spend_Category_Request_ReferencesType' => '\\StructType\\Spend_Category_Request_ReferencesType',
            'Spend_Category_Request_CriteriaType' => '\\StructType\\Spend_Category_Request_CriteriaType',
            'Spend_Category_Response_GroupType' => '\\StructType\\Spend_Category_Response_GroupType',
            'Get_Resource_Categories_RequestType' => '\\StructType\\Get_Resource_Categories_RequestType',
            'Spend_CategoryType' => '\\StructType\\Spend_CategoryType',
            'Spend_Category_Response_DataType' => '\\StructType\\Spend_Category_Response_DataType',
            'Get_Resource_Categories_ResponseType' => '\\StructType\\Get_Resource_Categories_ResponseType',
            'Spend_Category_DataType' => '\\StructType\\Spend_Category_DataType',
            'Put_Resource_Category_RequestType' => '\\StructType\\Put_Resource_Category_RequestType',
            'Put_Resource_Category_ResponseType' => '\\StructType\\Put_Resource_Category_ResponseType',
            'Purchase_Item_Group_Request_ReferencesType' => '\\StructType\\Purchase_Item_Group_Request_ReferencesType',
            'Purchase_Item_Group_Request_CriteriaType' => '\\StructType\\Purchase_Item_Group_Request_CriteriaType',
            'Purchase_Item_Group_Response_GroupType' => '\\StructType\\Purchase_Item_Group_Response_GroupType',
            'Get_Purchase_Item_Groups_RequestType' => '\\StructType\\Get_Purchase_Item_Groups_RequestType',
            'Purchase_Item_GroupType' => '\\StructType\\Purchase_Item_GroupType',
            'Purchase_Item_Group_Response_DataType' => '\\StructType\\Purchase_Item_Group_Response_DataType',
            'Get_Purchase_Item_Groups_ResponseType' => '\\StructType\\Get_Purchase_Item_Groups_ResponseType',
            'Put_Purchase_Item_Group_RequestType' => '\\StructType\\Put_Purchase_Item_Group_RequestType',
            'Put_Purchase_Item_Group_ResponseType' => '\\StructType\\Put_Purchase_Item_Group_ResponseType',
            'Expense_Item_Request_ReferencesType' => '\\StructType\\Expense_Item_Request_ReferencesType',
            'Expense_Item_Request_CriteriaType' => '\\StructType\\Expense_Item_Request_CriteriaType',
            'Expense_Item_Response_GroupType' => '\\StructType\\Expense_Item_Response_GroupType',
            'Get_Expense_Items_RequestType' => '\\StructType\\Get_Expense_Items_RequestType',
            'Expense_ItemType' => '\\StructType\\Expense_ItemType',
            'Expense_Item_Response_DataType' => '\\StructType\\Expense_Item_Response_DataType',
            'Get_Expense_Items_ResponseType' => '\\StructType\\Get_Expense_Items_ResponseType',
            'Put_Expense_Item_RequestType' => '\\StructType\\Put_Expense_Item_RequestType',
            'Put_Expense_Item_ResponseType' => '\\StructType\\Put_Expense_Item_ResponseType',
            'Purchase_Item_Request_ReferencesType' => '\\StructType\\Purchase_Item_Request_ReferencesType',
            'Purchase_Item_Request_CriteriaType' => '\\StructType\\Purchase_Item_Request_CriteriaType',
            'Purchase_Item_Response_GroupType' => '\\StructType\\Purchase_Item_Response_GroupType',
            'Get_Purchase_Items_RequestType' => '\\StructType\\Get_Purchase_Items_RequestType',
            'Purchase_ItemType' => '\\StructType\\Purchase_ItemType',
            'Purchase_Item_Response_DataType' => '\\StructType\\Purchase_Item_Response_DataType',
            'Get_Purchase_Items_ResponseType' => '\\StructType\\Get_Purchase_Items_ResponseType',
            'Put_Purchase_Item_RequestType' => '\\StructType\\Put_Purchase_Item_RequestType',
            'Put_Purchase_Item_ResponseType' => '\\StructType\\Put_Purchase_Item_ResponseType',
            'Supplier_Request_ReferencesType' => '\\StructType\\Supplier_Request_ReferencesType',
            'Supplier_Request_CriteriaType' => '\\StructType\\Supplier_Request_CriteriaType',
            'Supplier_Response_GroupType' => '\\StructType\\Supplier_Response_GroupType',
            'Get_Suppliers_RequestType' => '\\StructType\\Get_Suppliers_RequestType',
            'SupplierType' => '\\StructType\\SupplierType',
            'Supplier_Response_DataType' => '\\StructType\\Supplier_Response_DataType',
            'Get_Suppliers_ResponseType' => '\\StructType\\Get_Suppliers_ResponseType',
            'Put_Supplier_RequestType' => '\\StructType\\Put_Supplier_RequestType',
            'Put_Supplier_ResponseType' => '\\StructType\\Put_Supplier_ResponseType',
            'Supplier_Invoice_Adjustment_DataType' => '\\StructType\\Supplier_Invoice_Adjustment_DataType',
            'Submit_Supplier_Invoice_Adjustment_RequestType' => '\\StructType\\Submit_Supplier_Invoice_Adjustment_RequestType',
            'Submit_Supplier_Invoice_Adjustment_ResponseType' => '\\StructType\\Submit_Supplier_Invoice_Adjustment_ResponseType',
            'Expense_Item_Group_Request_ReferencesType' => '\\StructType\\Expense_Item_Group_Request_ReferencesType',
            'Expense_Item_Group_Request_CriteriaType' => '\\StructType\\Expense_Item_Group_Request_CriteriaType',
            'Expense_Item_Group_Response_GroupType' => '\\StructType\\Expense_Item_Group_Response_GroupType',
            'Get_Expense_Item_Groups_RequestType' => '\\StructType\\Get_Expense_Item_Groups_RequestType',
            'Expense_Item_GroupType' => '\\StructType\\Expense_Item_GroupType',
            'Expense_Item_Group_Response_DataType' => '\\StructType\\Expense_Item_Group_Response_DataType',
            'Get_Expense_Item_Groups_ResponseType' => '\\StructType\\Get_Expense_Item_Groups_ResponseType',
            'Put_Expense_Item_Group_RequestType' => '\\StructType\\Put_Expense_Item_Group_RequestType',
            'Put_Expense_Item_Group_ResponseType' => '\\StructType\\Put_Expense_Item_Group_ResponseType',
            'Cancel_Supplier_Invoice_RequestType' => '\\StructType\\Cancel_Supplier_Invoice_RequestType',
            'Cancel_Supplier_Invoice_ResponseType' => '\\StructType\\Cancel_Supplier_Invoice_ResponseType',
            'Cancel_Supplier_Invoice_Adjustment_RequestType' => '\\StructType\\Cancel_Supplier_Invoice_Adjustment_RequestType',
            'Cancel_Supplier_Invoice_Adjustment_ResponseType' => '\\StructType\\Cancel_Supplier_Invoice_Adjustment_ResponseType',
            'Issue_Purchase_Order_OutboundType' => '\\StructType\\Issue_Purchase_Order_OutboundType',
            'Requestor_for_Issue_Purchase_Order_Outbound_Sub_ViewType' => '\\StructType\\Requestor_for_Issue_Purchase_Order_Outbound_Sub_ViewType',
            'Company_for_Issue_Purchase_Order_Outbound_Sub_ViewType' => '\\StructType\\Company_for_Issue_Purchase_Order_Outbound_Sub_ViewType',
            'Bill_To_Address_for_Issue_Purchase_Order_Outbound_Sub_ViewType' => '\\StructType\\Bill_To_Address_for_Issue_Purchase_Order_Outbound_Sub_ViewType',
            'Ship_To_Address_for_Issue_Purchase_Order_Outbound_Sub_ViewType' => '\\StructType\\Ship_To_Address_for_Issue_Purchase_Order_Outbound_Sub_ViewType',
            'Purchase_Order_Line_for_Issue_Purchase_Order_Outbound_Sub_ViewType' => '\\StructType\\Purchase_Order_Line_for_Issue_Purchase_Order_Outbound_Sub_ViewType',
            'Project-Based_Order_Line_for_Issue_Purchase_Order_Outbound_Sub_ViewType' => '\\StructType\\Project_Based_Order_Line_for_Issue_Purchase_Order_Outbound_Sub_ViewType',
            'Resource_Order__Line_for_Issue_Purchase_Order_Outbound_Sub_ViewType' => '\\StructType\\Resource_Order__Line_for_Issue_Purchase_Order_Outbound_Sub_ViewType',
            'Exception_DataType' => '\\StructType\\Exception_DataType',
            'Get_PO_Outbound_RequestType' => '\\StructType\\Get_PO_Outbound_RequestType',
            'Supplier_Category_Request_ReferencesType' => '\\StructType\\Supplier_Category_Request_ReferencesType',
            'Supplier_Category_Request_CriteriaType' => '\\StructType\\Supplier_Category_Request_CriteriaType',
            'Supplier_Category_Response_GroupType' => '\\StructType\\Supplier_Category_Response_GroupType',
            'Get_Supplier_Categories_RequestType' => '\\StructType\\Get_Supplier_Categories_RequestType',
            'Supplier_CategoryType' => '\\StructType\\Supplier_CategoryType',
            'Supplier_Category_Response_DataType' => '\\StructType\\Supplier_Category_Response_DataType',
            'Get_Supplier_Categories_ResponseType' => '\\StructType\\Get_Supplier_Categories_ResponseType',
            'Put_Supplier_Category_RequestType' => '\\StructType\\Put_Supplier_Category_RequestType',
            'Put_Supplier_Category_ResponseType' => '\\StructType\\Put_Supplier_Category_ResponseType',
            'Put_Supplier_Group_RequestType' => '\\StructType\\Put_Supplier_Group_RequestType',
            'Put_Supplier_Group_ResponseType' => '\\StructType\\Put_Supplier_Group_ResponseType',
            'Supplier_Group_Request_ReferencesType' => '\\StructType\\Supplier_Group_Request_ReferencesType',
            'Supplier_Group_Request_CriteriaType' => '\\StructType\\Supplier_Group_Request_CriteriaType',
            'Supplier_Group_Response_GroupType' => '\\StructType\\Supplier_Group_Response_GroupType',
            'Get_Supplier_Groups_RequestType' => '\\StructType\\Get_Supplier_Groups_RequestType',
            'Supplier_GroupType' => '\\StructType\\Supplier_GroupType',
            'Supplier_Group_Response_DataType' => '\\StructType\\Supplier_Group_Response_DataType',
            'Get_Supplier_Groups_ResponseType' => '\\StructType\\Get_Supplier_Groups_ResponseType',
            'Business_Entity_WWS_DataType' => '\\StructType\\Business_Entity_WWS_DataType',
            'Catalog_Load_Item_DataType' => '\\StructType\\Catalog_Load_Item_DataType',
            'Submit_Catalog_Load_RequestType' => '\\StructType\\Submit_Catalog_Load_RequestType',
            'Submit_Catalog_Load_ResponseType' => '\\StructType\\Submit_Catalog_Load_ResponseType',
            'Catalog_LoadType' => '\\StructType\\Catalog_LoadType',
            'Timesheet_Request_ReferencesType' => '\\StructType\\Timesheet_Request_ReferencesType',
            'Timesheet_Request_CriteriaType' => '\\StructType\\Timesheet_Request_CriteriaType',
            'Timesheet_Response_GroupType' => '\\StructType\\Timesheet_Response_GroupType',
            'Get_Timesheets_RequestType' => '\\StructType\\Get_Timesheets_RequestType',
            'TimesheetType' => '\\StructType\\TimesheetType',
            'Timesheet_Response_DataType' => '\\StructType\\Timesheet_Response_DataType',
            'Get_Timesheets_ResponseType' => '\\StructType\\Get_Timesheets_ResponseType',
            'Worker_Time_Card_WWS_DataType' => '\\StructType\\Worker_Time_Card_WWS_DataType',
            'Corporate_Credit_Card_Account_Request_ReferencesType' => '\\StructType\\Corporate_Credit_Card_Account_Request_ReferencesType',
            'Corporate_Credit_Card_Account_Request_CriteriaType' => '\\StructType\\Corporate_Credit_Card_Account_Request_CriteriaType',
            'Corporate_Credit_Card_Account_Response_GroupType' => '\\StructType\\Corporate_Credit_Card_Account_Response_GroupType',
            'Get_Corporate_Credit_Card_Billing_Accounts_RequestType' => '\\StructType\\Get_Corporate_Credit_Card_Billing_Accounts_RequestType',
            'Corporate_Credit_Card_AccountType' => '\\StructType\\Corporate_Credit_Card_AccountType',
            'Corporate_Credit_Card_Account_Response_DataType' => '\\StructType\\Corporate_Credit_Card_Account_Response_DataType',
            'Get_Corporate_Credit_Card_Billing_Accounts_ResponseType' => '\\StructType\\Get_Corporate_Credit_Card_Billing_Accounts_ResponseType',
            'Put_Corporate_Credit_Card_Billing_Account_RequestType' => '\\StructType\\Put_Corporate_Credit_Card_Billing_Account_RequestType',
            'Put_Corporate_Credit_Card_Billing_Account_ResponseType' => '\\StructType\\Put_Corporate_Credit_Card_Billing_Account_ResponseType',
            'Timesheet_Daily_WWS_DataType' => '\\StructType\\Timesheet_Daily_WWS_DataType',
            'Expense_Credit_Card_Request_ReferencesType' => '\\StructType\\Expense_Credit_Card_Request_ReferencesType',
            'Expense_Credit_Card_Request_CriteriaType' => '\\StructType\\Expense_Credit_Card_Request_CriteriaType',
            'Expense_Credit_Card_Response_GroupType' => '\\StructType\\Expense_Credit_Card_Response_GroupType',
            'Get_Expense_Credit_Cards_RequestType' => '\\StructType\\Get_Expense_Credit_Cards_RequestType',
            'Expense_Credit_CardType' => '\\StructType\\Expense_Credit_CardType',
            'Expense_Credit_Card_Response_DataType' => '\\StructType\\Expense_Credit_Card_Response_DataType',
            'Get_Expense_Credit_Cards_ResponseType' => '\\StructType\\Get_Expense_Credit_Cards_ResponseType',
            'Put_Expense_Credit_Card_RequestType' => '\\StructType\\Put_Expense_Credit_Card_RequestType',
            'Put_Expense_Credit_Card_ResponseType' => '\\StructType\\Put_Expense_Credit_Card_ResponseType',
            'UNSPSC_Code_RangeType' => '\\StructType\\UNSPSC_Code_RangeType',
            'Settlement_Account_WWS_DataType' => '\\StructType\\Settlement_Account_WWS_DataType',
            'Business_Entity_Logo_Image_DataType' => '\\StructType\\Business_Entity_Logo_Image_DataType',
            'Business_Entity_Contact_Request_ReferencesType' => '\\StructType\\Business_Entity_Contact_Request_ReferencesType',
            'Business_Entity_Contact_Request_CriteriaType' => '\\StructType\\Business_Entity_Contact_Request_CriteriaType',
            'Business_Entity_Contact_Response_GroupType' => '\\StructType\\Business_Entity_Contact_Response_GroupType',
            'Get_Business_Entity_Contacts_RequestType' => '\\StructType\\Get_Business_Entity_Contacts_RequestType',
            'Business_Entity_ContactType' => '\\StructType\\Business_Entity_ContactType',
            'Business_Entity_Contact_Response_DataType' => '\\StructType\\Business_Entity_Contact_Response_DataType',
            'Get_Business_Entity_Contacts_ResponseType' => '\\StructType\\Get_Business_Entity_Contacts_ResponseType',
            'Put_Business_Entity_Contact_RequestType' => '\\StructType\\Put_Business_Entity_Contact_RequestType',
            'Put_Business_Entity_Contact_ResponseType' => '\\StructType\\Put_Business_Entity_Contact_ResponseType',
            'Application_Instance_Exceptions_DataType' => '\\StructType\\Application_Instance_Exceptions_DataType',
            'Application_Instance_Related_Exceptions_DataType' => '\\StructType\\Application_Instance_Related_Exceptions_DataType',
            'Supplier_Invoice_Request_ReferencesType' => '\\StructType\\Supplier_Invoice_Request_ReferencesType',
            'Supplier_Invoice_Request_CriteriaType' => '\\StructType\\Supplier_Invoice_Request_CriteriaType',
            'Supplier_Invoice_Response_GroupType' => '\\StructType\\Supplier_Invoice_Response_GroupType',
            'Get_Supplier_Invoices_RequestType' => '\\StructType\\Get_Supplier_Invoices_RequestType',
            'Supplier_InvoiceType' => '\\StructType\\Supplier_InvoiceType',
            'Supplier_Invoice_Response_DataType' => '\\StructType\\Supplier_Invoice_Response_DataType',
            'Get_Supplier_Invoices_ResponseType' => '\\StructType\\Get_Supplier_Invoices_ResponseType',
            'Supplier_Invoice_Adjustment_Request_ReferencesType' => '\\StructType\\Supplier_Invoice_Adjustment_Request_ReferencesType',
            'Supplier_Invoice_Adjustment_Request_CriteriaType' => '\\StructType\\Supplier_Invoice_Adjustment_Request_CriteriaType',
            'Supplier_Invoice_Adjustment_Response_GroupType' => '\\StructType\\Supplier_Invoice_Adjustment_Response_GroupType',
            'Get_Supplier_Invoice_Adjustments_RequestType' => '\\StructType\\Get_Supplier_Invoice_Adjustments_RequestType',
            'Supplier_Invoice_AdjustmentType' => '\\StructType\\Supplier_Invoice_AdjustmentType',
            'Supplier_Invoice_Adjustment_Response_DataType' => '\\StructType\\Supplier_Invoice_Adjustment_Response_DataType',
            'Get_Supplier_Invoice_Adjustments_ResponseType' => '\\StructType\\Get_Supplier_Invoice_Adjustments_ResponseType',
            'Business_Entity_Alternate_Name_DataType' => '\\StructType\\Business_Entity_Alternate_Name_DataType',
            'Catalog_Load_DataType' => '\\StructType\\Catalog_Load_DataType',
            'Catalog_Load_Request_ReferencesType' => '\\StructType\\Catalog_Load_Request_ReferencesType',
            'Catalog_Load_Request_CriteriaType' => '\\StructType\\Catalog_Load_Request_CriteriaType',
            'Catalog_Load_Response_GroupType' => '\\StructType\\Catalog_Load_Response_GroupType',
            'Get_Catalog_Loads_RequestType' => '\\StructType\\Get_Catalog_Loads_RequestType',
            'Catalog_Load_Response_DataType' => '\\StructType\\Catalog_Load_Response_DataType',
            'Get_Catalog_Loads_ResponseType' => '\\StructType\\Get_Catalog_Loads_ResponseType',
            'Supplier_Invoice_History_Request_ReferencesType' => '\\StructType\\Supplier_Invoice_History_Request_ReferencesType',
            'Supplier_Invoice_History_Request_CriteriaType' => '\\StructType\\Supplier_Invoice_History_Request_CriteriaType',
            'Supplier_Invoice_History_Response_GroupType' => '\\StructType\\Supplier_Invoice_History_Response_GroupType',
            'Get_Supplier_Invoice_Histories_RequestType' => '\\StructType\\Get_Supplier_Invoice_Histories_RequestType',
            'Supplier_Invoice_HistoryType' => '\\StructType\\Supplier_Invoice_HistoryType',
            'Supplier_Invoice_History_Response_DataType' => '\\StructType\\Supplier_Invoice_History_Response_DataType',
            'Get_Supplier_Invoice_Histories_ResponseType' => '\\StructType\\Get_Supplier_Invoice_Histories_ResponseType',
            'Supplier_Invoice_History_DataType' => '\\StructType\\Supplier_Invoice_History_DataType',
            'Put_Supplier_Invoice_History_RequestType' => '\\StructType\\Put_Supplier_Invoice_History_RequestType',
            'Put_Supplier_Invoice_History_ResponseType' => '\\StructType\\Put_Supplier_Invoice_History_ResponseType',
            'Supplier_Status_DataType' => '\\StructType\\Supplier_Status_DataType',
            'Supplier_Invoice_Intercompany_Sub_ProcessType' => '\\StructType\\Supplier_Invoice_Intercompany_Sub_ProcessType',
            'Expense_Item_Attribute_and_Type_Subedit_Web_ServiceType' => '\\StructType\\Expense_Item_Attribute_and_Type_Subedit_Web_ServiceType',
            'Project_Phase_Name_DataType' => '\\StructType\\Project_Phase_Name_DataType',
            'Project_Task_Name_DataType' => '\\StructType\\Project_Task_Name_DataType',
            'Project_Worker_Role_Request_ReferencesType' => '\\StructType\\Project_Worker_Role_Request_ReferencesType',
            'Project_Worker_Role_Request_CriteriaType' => '\\StructType\\Project_Worker_Role_Request_CriteriaType',
            'Project_Worker_Role_Response_GroupType' => '\\StructType\\Project_Worker_Role_Response_GroupType',
            'Get_Project_Worker_Roles_RequestType' => '\\StructType\\Get_Project_Worker_Roles_RequestType',
            'Project_Worker_RoleType' => '\\StructType\\Project_Worker_RoleType',
            'Project_Worker_Role_Response_DataType' => '\\StructType\\Project_Worker_Role_Response_DataType',
            'Get_Project_Worker_Roles_ResponseType' => '\\StructType\\Get_Project_Worker_Roles_ResponseType',
            'Project_Worker_Role_DataType' => '\\StructType\\Project_Worker_Role_DataType',
            'Put_Project_Worker_Role_RequestType' => '\\StructType\\Put_Project_Worker_Role_RequestType',
            'Put_Project_Worker_Role_ResponseType' => '\\StructType\\Put_Project_Worker_Role_ResponseType',
            'Condition_Rule_Data_WWSType' => '\\StructType\\Condition_Rule_Data_WWSType',
            'Condition_Item_Data_WWSType' => '\\StructType\\Condition_Item_Data_WWSType',
            'Project_Plan_Template_DataType' => '\\StructType\\Project_Plan_Template_DataType',
            'Project_Plan_Phase_Template_DataType' => '\\StructType\\Project_Plan_Phase_Template_DataType',
            'Project_Plan_Task_Template_DataType' => '\\StructType\\Project_Plan_Task_Template_DataType',
            'Project_Plan_Template_Request_ReferencesType' => '\\StructType\\Project_Plan_Template_Request_ReferencesType',
            'Project_Plan_Template_Request_CriteriaType' => '\\StructType\\Project_Plan_Template_Request_CriteriaType',
            'Project_Plan_Template_Response_GroupType' => '\\StructType\\Project_Plan_Template_Response_GroupType',
            'Get_Project_Plan_Templates_RequestType' => '\\StructType\\Get_Project_Plan_Templates_RequestType',
            'Project_Plan_TemplateType' => '\\StructType\\Project_Plan_TemplateType',
            'Project_Plan_Template_Response_DataType' => '\\StructType\\Project_Plan_Template_Response_DataType',
            'Get_Project_Plan_Templates_ResponseType' => '\\StructType\\Get_Project_Plan_Templates_ResponseType',
            'Project_Template_Request_ReferencesType' => '\\StructType\\Project_Template_Request_ReferencesType',
            'Project_Template_Request_CriteriaType' => '\\StructType\\Project_Template_Request_CriteriaType',
            'Project_Template_Response_GroupType' => '\\StructType\\Project_Template_Response_GroupType',
            'Get_Project_Templates_RequestType' => '\\StructType\\Get_Project_Templates_RequestType',
            'Project_TemplateType' => '\\StructType\\Project_TemplateType',
            'Project_Template_Response_DataType' => '\\StructType\\Project_Template_Response_DataType',
            'Get_Project_Templates_ResponseType' => '\\StructType\\Get_Project_Templates_ResponseType',
            'Project_Template_DataType' => '\\StructType\\Project_Template_DataType',
            'Project_Task_Request_ReferencesType' => '\\StructType\\Project_Task_Request_ReferencesType',
            'Project_Task_Request_CriteriaType' => '\\StructType\\Project_Task_Request_CriteriaType',
            'Project_Task_Response_GroupType' => '\\StructType\\Project_Task_Response_GroupType',
            'Get_Project_Tasks_RequestType' => '\\StructType\\Get_Project_Tasks_RequestType',
            'Project_TaskType' => '\\StructType\\Project_TaskType',
            'Project_Task_Response_DataType' => '\\StructType\\Project_Task_Response_DataType',
            'Get_Project_Tasks_ResponseType' => '\\StructType\\Get_Project_Tasks_ResponseType',
            'Put_Project_Task_RequestType' => '\\StructType\\Put_Project_Task_RequestType',
            'Put_Project_Task_ResponseType' => '\\StructType\\Put_Project_Task_ResponseType',
            'Project_Task_DataType' => '\\StructType\\Project_Task_DataType',
            'Project_Phase_Request_ReferencesType' => '\\StructType\\Project_Phase_Request_ReferencesType',
            'Project_Phase_Request_CriteriaType' => '\\StructType\\Project_Phase_Request_CriteriaType',
            'Project_Phase_Response_GroupType' => '\\StructType\\Project_Phase_Response_GroupType',
            'Get_Project_Phases_RequestType' => '\\StructType\\Get_Project_Phases_RequestType',
            'Project_PhaseType' => '\\StructType\\Project_PhaseType',
            'Project_Phase_Response_DataType' => '\\StructType\\Project_Phase_Response_DataType',
            'Get_Project_Phases_ResponseType' => '\\StructType\\Get_Project_Phases_ResponseType',
            'Project_Phase_DataType' => '\\StructType\\Project_Phase_DataType',
            'Put_Project_Phase_RequestType' => '\\StructType\\Put_Project_Phase_RequestType',
            'Put_Project_Phase_ResponseType' => '\\StructType\\Put_Project_Phase_ResponseType',
            'Taxable_Code_Application_DataType' => '\\StructType\\Taxable_Code_Application_DataType',
            'Tax_Rate_Application_DataType' => '\\StructType\\Tax_Rate_Application_DataType',
            'Submit_Expense_Report_RequestType' => '\\StructType\\Submit_Expense_Report_RequestType',
            'Submit_Expense_Report_ResponseType' => '\\StructType\\Submit_Expense_Report_ResponseType',
            'Expense_Report_Request_ReferencesType' => '\\StructType\\Expense_Report_Request_ReferencesType',
            'Expense_Report_Request_CriteriaType' => '\\StructType\\Expense_Report_Request_CriteriaType',
            'Expense_Report_Response_GroupType' => '\\StructType\\Expense_Report_Response_GroupType',
            'Get_Expense_Reports_RequestType' => '\\StructType\\Get_Expense_Reports_RequestType',
            'Expense_Report_Response_DataType' => '\\StructType\\Expense_Report_Response_DataType',
            'Get_Expense_Reports_ResponseType' => '\\StructType\\Get_Expense_Reports_ResponseType',
            'Expense_Report_WWS_DataType' => '\\StructType\\Expense_Report_WWS_DataType',
            'Expense_Report_WWSType' => '\\StructType\\Expense_Report_WWSType',
            'Expense_Report_Line_WWS_DataType' => '\\StructType\\Expense_Report_Line_WWS_DataType',
            'Expense_Report_Line_Detail_DataType' => '\\StructType\\Expense_Report_Line_Detail_DataType',
            'Taxable_Code_Application_NO_INPUT_DataType' => '\\StructType\\Taxable_Code_Application_NO_INPUT_DataType',
            'Cancel_Expense_Report_RequestType' => '\\StructType\\Cancel_Expense_Report_RequestType',
            'Cancel_Expense_Report_ResponseType' => '\\StructType\\Cancel_Expense_Report_ResponseType',
            'Time_In_Time_Out_WWS_DataType' => '\\StructType\\Time_In_Time_Out_WWS_DataType',
            'Attendee_DataType' => '\\StructType\\Attendee_DataType',
            'Submit_Purchase_Order_RequestType' => '\\StructType\\Submit_Purchase_Order_RequestType',
            'Purchase_Order_WWS_DataType' => '\\StructType\\Purchase_Order_WWS_DataType',
            'Item_Order_Line_Replacement_DataType' => '\\StructType\\Item_Order_Line_Replacement_DataType',
            'Submit_Purchase_Order_ResponseType' => '\\StructType\\Submit_Purchase_Order_ResponseType',
            'Project_Hierarchy_Request_ReferencesType' => '\\StructType\\Project_Hierarchy_Request_ReferencesType',
            'Project_Hierarchy_Request_CriteriaType' => '\\StructType\\Project_Hierarchy_Request_CriteriaType',
            'Project_Hierarchy_Response_GroupType' => '\\StructType\\Project_Hierarchy_Response_GroupType',
            'Supplier_Order_Contract_Request_ReferencesType' => '\\StructType\\Supplier_Order_Contract_Request_ReferencesType',
            'Supplier_Order_Contract_Request_CriteriaType' => '\\StructType\\Supplier_Order_Contract_Request_CriteriaType',
            'Supplier_Order_Contract_Response_GroupType' => '\\StructType\\Supplier_Order_Contract_Response_GroupType',
            'Get_Supplier_Order_Contracts_RequestType' => '\\StructType\\Get_Supplier_Order_Contracts_RequestType',
            'Supplier_Order_ContractType' => '\\StructType\\Supplier_Order_ContractType',
            'Supplier_Order_Contract_Response_DataType' => '\\StructType\\Supplier_Order_Contract_Response_DataType',
            'Get_Supplier_Order_Contracts_ResponseType' => '\\StructType\\Get_Supplier_Order_Contracts_ResponseType',
            'Supplier_Order_Contract_Data_for_Put_and_GetType' => '\\StructType\\Supplier_Order_Contract_Data_for_Put_and_GetType',
            'Purchase_Order_Request_ReferencesType' => '\\StructType\\Purchase_Order_Request_ReferencesType',
            'Purchase_Order_Request_CriteriaType' => '\\StructType\\Purchase_Order_Request_CriteriaType',
            'Purchase_Order_Response_GroupType' => '\\StructType\\Purchase_Order_Response_GroupType',
            'Get_Purchase_Orders_RequestType' => '\\StructType\\Get_Purchase_Orders_RequestType',
            'Purchase_Order_Response_DataType' => '\\StructType\\Purchase_Order_Response_DataType',
            'Get_Purchase_Orders_ResponseType' => '\\StructType\\Get_Purchase_Orders_ResponseType',
            'Purchase_Order_OutboundType' => '\\StructType\\Purchase_Order_OutboundType',
            'Purchase_Order_Outbound_DataType' => '\\StructType\\Purchase_Order_Outbound_DataType',
            'Project-Based_Order_Line_Replacement_DataType' => '\\StructType\\Project_Based_Order_Line_Replacement_DataType',
            'Contingent_Worker_Order_Line_DataType' => '\\StructType\\Contingent_Worker_Order_Line_DataType',
            'Project_Plan_Phase_PO_DataType' => '\\StructType\\Project_Plan_Phase_PO_DataType',
            'Project_Plan_Task_PO_DataType' => '\\StructType\\Project_Plan_Task_PO_DataType',
            'Project_Subtask_DataType' => '\\StructType\\Project_Subtask_DataType',
            'Time_Card_Factor_DataType' => '\\StructType\\Time_Card_Factor_DataType',
            'Itemized_Expense_Report_Line_WWS_DataType' => '\\StructType\\Itemized_Expense_Report_Line_WWS_DataType',
            'Recipient_DataType' => '\\StructType\\Recipient_DataType',
            'Local_Person_Name_Detail_DataType' => '\\StructType\\Local_Person_Name_Detail_DataType',
            'Expense_Policy_Group_Request_ReferencesType' => '\\StructType\\Expense_Policy_Group_Request_ReferencesType',
            'Expense_Policy_Group_Request_CriteriaType' => '\\StructType\\Expense_Policy_Group_Request_CriteriaType',
            'Expense_Policy_Group_Response_GroupType' => '\\StructType\\Expense_Policy_Group_Response_GroupType',
            'Get_Expense_Policy_Groups_RequestType' => '\\StructType\\Get_Expense_Policy_Groups_RequestType',
            'Expense_Policy_GroupType' => '\\StructType\\Expense_Policy_GroupType',
            'Expense_Policy_Group_Response_DataType' => '\\StructType\\Expense_Policy_Group_Response_DataType',
            'Get_Expense_Policy_Groups_ResponseType' => '\\StructType\\Get_Expense_Policy_Groups_ResponseType',
            'Expense_Policy_Group_DataType' => '\\StructType\\Expense_Policy_Group_DataType',
            'Put_Expense_Policy_Group_RequestType' => '\\StructType\\Put_Expense_Policy_Group_RequestType',
            'Put_Expense_Policy_Group_ResponseType' => '\\StructType\\Put_Expense_Policy_Group_ResponseType',
            'Expense_Rate_Table_Rule_Request_ReferencesType' => '\\StructType\\Expense_Rate_Table_Rule_Request_ReferencesType',
            'Expense_Rate_Table_Rule_Request_CriteriaType' => '\\StructType\\Expense_Rate_Table_Rule_Request_CriteriaType',
            'Expense_Rate_Table_Rule_Response_GroupType' => '\\StructType\\Expense_Rate_Table_Rule_Response_GroupType',
            'Get_Expense_Rate_Table_Rules_RequestType' => '\\StructType\\Get_Expense_Rate_Table_Rules_RequestType',
            'Expense_Rate_Table_RuleType' => '\\StructType\\Expense_Rate_Table_RuleType',
            'Expense_Rate_Table_Rule_Response_DataType' => '\\StructType\\Expense_Rate_Table_Rule_Response_DataType',
            'Get_Expense_Rate_Table_Rules_ResponseType' => '\\StructType\\Get_Expense_Rate_Table_Rules_ResponseType',
            'Put_Expense_Rate_Table_Rule_RequestType' => '\\StructType\\Put_Expense_Rate_Table_Rule_RequestType',
            'Put_Expense_Rate_Table_Rule_ResponseType' => '\\StructType\\Put_Expense_Rate_Table_Rule_ResponseType',
            'Expense_Rate_Table_Rule_DataType' => '\\StructType\\Expense_Rate_Table_Rule_DataType',
            'Expense_Rate_Table_Request_ReferencesType' => '\\StructType\\Expense_Rate_Table_Request_ReferencesType',
            'Expense_Rate_Table_Request_CriteriaType' => '\\StructType\\Expense_Rate_Table_Request_CriteriaType',
            'Expense_Rate_Table_Response_GroupType' => '\\StructType\\Expense_Rate_Table_Response_GroupType',
            'Get_Expense_Rate_Tables_RequestType' => '\\StructType\\Get_Expense_Rate_Tables_RequestType',
            'Expense_Rate_TableType' => '\\StructType\\Expense_Rate_TableType',
            'Expense_Rate_Table_Response_DataType' => '\\StructType\\Expense_Rate_Table_Response_DataType',
            'Get_Expense_Rate_Tables_ResponseType' => '\\StructType\\Get_Expense_Rate_Tables_ResponseType',
            'Expense_Rate_Table_DataType' => '\\StructType\\Expense_Rate_Table_DataType',
            'Expense_Rate_Table_Line_DataType' => '\\StructType\\Expense_Rate_Table_Line_DataType',
            'Graduated_Expense_Rate_DataType' => '\\StructType\\Graduated_Expense_Rate_DataType',
            'Expense_Adjustment_Calculation_Method_DataType' => '\\StructType\\Expense_Adjustment_Calculation_Method_DataType',
            'Passenger_DataType' => '\\StructType\\Passenger_DataType',
            'Spend_Category_Hierarchy_DataType' => '\\StructType\\Spend_Category_Hierarchy_DataType',
            'Put_Spend_Category_Hierarchy_RequestType' => '\\StructType\\Put_Spend_Category_Hierarchy_RequestType',
            'Put_Spend_Category_Hierarchy_ResponseType' => '\\StructType\\Put_Spend_Category_Hierarchy_ResponseType',
            'Spend_Category_Hierarchy_Request_ReferencesType' => '\\StructType\\Spend_Category_Hierarchy_Request_ReferencesType',
            'Spend_Category_Hierarchy_Request_CriteriaType' => '\\StructType\\Spend_Category_Hierarchy_Request_CriteriaType',
            'Spend_Category_Hierarchy_Response_GroupType' => '\\StructType\\Spend_Category_Hierarchy_Response_GroupType',
            'Get_Spend_Category_Hierarchies_RequestType' => '\\StructType\\Get_Spend_Category_Hierarchies_RequestType',
            'Spend_Category_HierarchyType' => '\\StructType\\Spend_Category_HierarchyType',
            'Spend_Category_Hierarchy_Response_DataType' => '\\StructType\\Spend_Category_Hierarchy_Response_DataType',
            'Get_Spend_Category_Hierarchies_ResponseType' => '\\StructType\\Get_Spend_Category_Hierarchies_ResponseType',
            'Submit_Expense_Report_for_Applicant_RequestType' => '\\StructType\\Submit_Expense_Report_for_Applicant_RequestType',
            'Submit_Expense_Report_for_Applicant_ResponseType' => '\\StructType\\Submit_Expense_Report_for_Applicant_ResponseType',
            'Payroll_Timesheet_Time_In_Time_Out_Request_ReferencesType' => '\\StructType\\Payroll_Timesheet_Time_In_Time_Out_Request_ReferencesType',
            'Payroll_Timesheet_Time_In_Time_Out_Request_CriteriaType' => '\\StructType\\Payroll_Timesheet_Time_In_Time_Out_Request_CriteriaType',
            'Payroll_Timesheet_Time_In_Time_Out_Response_GroupType' => '\\StructType\\Payroll_Timesheet_Time_In_Time_Out_Response_GroupType',
            'Get_Payroll_Timesheets_Time_In_Time_Out_RequestType' => '\\StructType\\Get_Payroll_Timesheets_Time_In_Time_Out_RequestType',
            'Payroll_Timesheet_Time_In_Time_OutType' => '\\StructType\\Payroll_Timesheet_Time_In_Time_OutType',
            'Payroll_Timesheet_Time_In_Time_Out_Response_DataType' => '\\StructType\\Payroll_Timesheet_Time_In_Time_Out_Response_DataType',
            'Get_Payroll_Timesheets_Time_In_Time_Out_ResponseType' => '\\StructType\\Get_Payroll_Timesheets_Time_In_Time_Out_ResponseType',
            'Payroll_Timesheet_Time_In_Time_Out_Data_WWSType' => '\\StructType\\Payroll_Timesheet_Time_In_Time_Out_Data_WWSType',
            'Payroll_Timesheet_Day_Time_In_Time_Out_WWSType' => '\\StructType\\Payroll_Timesheet_Day_Time_In_Time_Out_WWSType',
            'Payroll_Timesheet_Day_Time_In_Time_Out_Hours_WWSType' => '\\StructType\\Payroll_Timesheet_Day_Time_In_Time_Out_Hours_WWSType',
            'Payroll_Timesheet_Total_Hours_Request_ReferencesType' => '\\StructType\\Payroll_Timesheet_Total_Hours_Request_ReferencesType',
            'Payroll_Timesheet_Total_Hours_Request_CriteriaType' => '\\StructType\\Payroll_Timesheet_Total_Hours_Request_CriteriaType',
            'Payroll_Timesheet_Total_Hours_Response_GroupType' => '\\StructType\\Payroll_Timesheet_Total_Hours_Response_GroupType',
            'Get_Payroll_Timesheets_Total_Hours_RequestType' => '\\StructType\\Get_Payroll_Timesheets_Total_Hours_RequestType',
            'Payroll_Timesheet_Total_HoursType' => '\\StructType\\Payroll_Timesheet_Total_HoursType',
            'Payroll_Timesheet_Total_Hours_Response_DataType' => '\\StructType\\Payroll_Timesheet_Total_Hours_Response_DataType',
            'Get_Payroll_Timesheets_Total_Hours_ResponseType' => '\\StructType\\Get_Payroll_Timesheets_Total_Hours_ResponseType',
            'Payroll_Timesheet_Total_Hours_Data_WWSType' => '\\StructType\\Payroll_Timesheet_Total_Hours_Data_WWSType',
            'Payroll_Timesheet_Line_DataType' => '\\StructType\\Payroll_Timesheet_Line_DataType',
            'Payroll_Timesheet_Day_Total_Hours_DataType' => '\\StructType\\Payroll_Timesheet_Day_Total_Hours_DataType',
            'Project_Timesheet_Request_ReferencesType' => '\\StructType\\Project_Timesheet_Request_ReferencesType',
            'Project_Timesheet_Request_CriteriaType' => '\\StructType\\Project_Timesheet_Request_CriteriaType',
            'Get_Project_Timesheets_RequestType' => '\\StructType\\Get_Project_Timesheets_RequestType',
            'Project_TimesheetType' => '\\StructType\\Project_TimesheetType',
            'Project_Timesheet_Response_DataType' => '\\StructType\\Project_Timesheet_Response_DataType',
            'Get_Project_Timesheets_ResponseType' => '\\StructType\\Get_Project_Timesheets_ResponseType',
            'Project_Timesheet_DataType' => '\\StructType\\Project_Timesheet_DataType',
            'Project_Timesheet_Line_DataType' => '\\StructType\\Project_Timesheet_Line_DataType',
            'Project_Timesheet_Day_DataType' => '\\StructType\\Project_Timesheet_Day_DataType',
            'Cancel_Timesheet_RequestType' => '\\StructType\\Cancel_Timesheet_RequestType',
            'Cancel_Timesheet_ResponseType' => '\\StructType\\Cancel_Timesheet_ResponseType',
            'Travel_Profile_DataType' => '\\StructType\\Travel_Profile_DataType',
            'Travel_Profile_Request_ReferencesType' => '\\StructType\\Travel_Profile_Request_ReferencesType',
            'Travel_Profile_Request_CriteriaType' => '\\StructType\\Travel_Profile_Request_CriteriaType',
            'Travel_Profile_Response_GroupType' => '\\StructType\\Travel_Profile_Response_GroupType',
            'Get_Travel_Profiles_RequestType' => '\\StructType\\Get_Travel_Profiles_RequestType',
            'Travel_ProfileType' => '\\StructType\\Travel_ProfileType',
            'Travel_Profile_Response_DataType' => '\\StructType\\Travel_Profile_Response_DataType',
            'Get_Travel_Profiles_ResponseType' => '\\StructType\\Get_Travel_Profiles_ResponseType',
            'Worker_Travel_Profile_Attachment_DataType' => '\\StructType\\Worker_Travel_Profile_Attachment_DataType',
            'Expense_Report_Credit_Card_Transactions_DataType' => '\\StructType\\Expense_Report_Credit_Card_Transactions_DataType',
            'Expense_Report_Line_Credit_Card_Transaction_DataType' => '\\StructType\\Expense_Report_Line_Credit_Card_Transaction_DataType',
            'Credit_Card_Transaction_Billing_Currency_Conversion_DataType' => '\\StructType\\Credit_Card_Transaction_Billing_Currency_Conversion_DataType',
            'Image_DataType' => '\\StructType\\Image_DataType',
            'Expense_Report_WWS_Outbound_DataType' => '\\StructType\\Expense_Report_WWS_Outbound_DataType',
            'Expense_Report_Line_WWS_Outbound_DataType' => '\\StructType\\Expense_Report_Line_WWS_Outbound_DataType',
            'Itemized_Expense_Report_Line_WWS_Outbound_DataType' => '\\StructType\\Itemized_Expense_Report_Line_WWS_Outbound_DataType',
            'Credit_Card_Transaction_File_Request_ReferencesType' => '\\StructType\\Credit_Card_Transaction_File_Request_ReferencesType',
            'Credit_Card_Transaction_File_Request_CriteriaType' => '\\StructType\\Credit_Card_Transaction_File_Request_CriteriaType',
            'Credit_Card_Transaction_File_Response_GroupType' => '\\StructType\\Credit_Card_Transaction_File_Response_GroupType',
            'Get_Credit_Card_Transaction_Files_RequestType' => '\\StructType\\Get_Credit_Card_Transaction_Files_RequestType',
            'Credit_Card_Transaction_FileType' => '\\StructType\\Credit_Card_Transaction_FileType',
            'Credit_Card_Transaction_File_Response_DataType' => '\\StructType\\Credit_Card_Transaction_File_Response_DataType',
            'Get_Credit_Card_Transaction_Files_ResponseType' => '\\StructType\\Get_Credit_Card_Transaction_Files_ResponseType',
            'Credit_Card_Transaction_File_DataType' => '\\StructType\\Credit_Card_Transaction_File_DataType',
            'Put_Credit_Card_Transaction_File_RequestType' => '\\StructType\\Put_Credit_Card_Transaction_File_RequestType',
            'Put_Credit_Card_Transaction_File_ResponseType' => '\\StructType\\Put_Credit_Card_Transaction_File_ResponseType',
            'Expense_Credit_Card_Transaction_Request_ReferencesType' => '\\StructType\\Expense_Credit_Card_Transaction_Request_ReferencesType',
            'Expense_Credit_Card_Transaction_Request_CriteriaType' => '\\StructType\\Expense_Credit_Card_Transaction_Request_CriteriaType',
            'Expense_Credit_Card_Transaction_Response_GroupType' => '\\StructType\\Expense_Credit_Card_Transaction_Response_GroupType',
            'Get_Expense_Credit_Card_Transactions_RequestType' => '\\StructType\\Get_Expense_Credit_Card_Transactions_RequestType',
            'Expense_Credit_Card_TransactionType' => '\\StructType\\Expense_Credit_Card_TransactionType',
            'Expense_Credit_Card_Transaction_Response_DataType' => '\\StructType\\Expense_Credit_Card_Transaction_Response_DataType',
            'Get_Expense_Credit_Card_Transactions_ResponseType' => '\\StructType\\Get_Expense_Credit_Card_Transactions_ResponseType',
            'Credit_Card_Transaction_DataType' => '\\StructType\\Credit_Card_Transaction_DataType',
            'Put_Expense_Credit_Card_Transaction_RequestType' => '\\StructType\\Put_Expense_Credit_Card_Transaction_RequestType',
            'Put_Expense_Credit_Card_Transaction_ResponseType' => '\\StructType\\Put_Expense_Credit_Card_Transaction_ResponseType',
            'Expense_Company_Default_Request_ReferencesType' => '\\StructType\\Expense_Company_Default_Request_ReferencesType',
            'Expense_Company_Default_Request_CriteriaType' => '\\StructType\\Expense_Company_Default_Request_CriteriaType',
            'Expense_Company_Default_Response_GroupType' => '\\StructType\\Expense_Company_Default_Response_GroupType',
            'Get_Expense_Company_Defaults_RequestType' => '\\StructType\\Get_Expense_Company_Defaults_RequestType',
            'Expense_Company_DefaultType' => '\\StructType\\Expense_Company_DefaultType',
            'Expense_Company_Default_Response_DataType' => '\\StructType\\Expense_Company_Default_Response_DataType',
            'Get_Expense_Company_Defaults_ResponseType' => '\\StructType\\Get_Expense_Company_Defaults_ResponseType',
            'Expense_Company_Default_DataType' => '\\StructType\\Expense_Company_Default_DataType',
            'Put_Expense_Company_Default_RequestType' => '\\StructType\\Put_Expense_Company_Default_RequestType',
            'Put_Expense_Company_Default_ResponseType' => '\\StructType\\Put_Expense_Company_Default_ResponseType',
            'Card_Holder_Listing_File_DataType' => '\\StructType\\Card_Holder_Listing_File_DataType',
            'Put_Card_Holder_Listing_File_RequestType' => '\\StructType\\Put_Card_Holder_Listing_File_RequestType',
            'Put_Card_Holder_Listing_File_ResponseType' => '\\StructType\\Put_Card_Holder_Listing_File_ResponseType',
            'Card_Holder_Listing_File_Request_ReferencesType' => '\\StructType\\Card_Holder_Listing_File_Request_ReferencesType',
            'Card_Holder_Listing_File_Request_CriteriaType' => '\\StructType\\Card_Holder_Listing_File_Request_CriteriaType',
            'Card_Holder_Listing_File_Response_GroupType' => '\\StructType\\Card_Holder_Listing_File_Response_GroupType',
            'Get_Card_Holder_Listing_Files_RequestType' => '\\StructType\\Get_Card_Holder_Listing_Files_RequestType',
            'Card_Holder_Listing_FileType' => '\\StructType\\Card_Holder_Listing_FileType',
            'Card_Holder_Listing_File_Response_DataType' => '\\StructType\\Card_Holder_Listing_File_Response_DataType',
            'Get_Card_Holder_Listing_Files_ResponseType' => '\\StructType\\Get_Card_Holder_Listing_Files_ResponseType',
            'Expense_Item_Attribute_Group_DataType' => '\\StructType\\Expense_Item_Attribute_Group_DataType',
            'Put_Expense_Item_Attribute_Group_RequestType' => '\\StructType\\Put_Expense_Item_Attribute_Group_RequestType',
            'Put_Expense_Item_Attribute_Group_ResponseType' => '\\StructType\\Put_Expense_Item_Attribute_Group_ResponseType',
            'Expense_Item_Attribute_Group_Request_ReferencesType' => '\\StructType\\Expense_Item_Attribute_Group_Request_ReferencesType',
            'Expense_Item_Attribute_Group_Request_CriteriaType' => '\\StructType\\Expense_Item_Attribute_Group_Request_CriteriaType',
            'Expense_Item_Attribute_Group_Response_GroupType' => '\\StructType\\Expense_Item_Attribute_Group_Response_GroupType',
            'Get_Expense_Item_Attribute_Groups_RequestType' => '\\StructType\\Get_Expense_Item_Attribute_Groups_RequestType',
            'Expense_Item_Attribute_GroupType' => '\\StructType\\Expense_Item_Attribute_GroupType',
            'Expense_Item_Attribute_Group_Response_DataType' => '\\StructType\\Expense_Item_Attribute_Group_Response_DataType',
            'Get_Expense_Item_Attribute_Groups_ResponseType' => '\\StructType\\Get_Expense_Item_Attribute_Groups_ResponseType',
            'Recurring_Supplier_Invoice_DataType' => '\\StructType\\Recurring_Supplier_Invoice_DataType',
            'Submit_Supplier_Invoice_Contract_RequestType' => '\\StructType\\Submit_Supplier_Invoice_Contract_RequestType',
            'Submit_Supplier_Invoice_Contract_ResponseType' => '\\StructType\\Submit_Supplier_Invoice_Contract_ResponseType',
            'Submit_Supplier_Order_Contract_RequestType' => '\\StructType\\Submit_Supplier_Order_Contract_RequestType',
            'Supplier_Order_Contract_DataType' => '\\StructType\\Supplier_Order_Contract_DataType',
            'Submit_Supplier_Order_Contract_ResponseType' => '\\StructType\\Submit_Supplier_Order_Contract_ResponseType',
            'Receipt_Request_ReferencesType' => '\\StructType\\Receipt_Request_ReferencesType',
            'Receipt_Request_CriteriaType' => '\\StructType\\Receipt_Request_CriteriaType',
            'Receipt_Response_GroupType' => '\\StructType\\Receipt_Response_GroupType',
            'Get_Receipts_RequestType' => '\\StructType\\Get_Receipts_RequestType',
            'ReceiptType' => '\\StructType\\ReceiptType',
            'Receipt_Response_DataType' => '\\StructType\\Receipt_Response_DataType',
            'Get_Receipts_ResponseType' => '\\StructType\\Get_Receipts_ResponseType',
            'Receipt_DataType' => '\\StructType\\Receipt_DataType',
            'Item_Receipt_Line_Replacement_DataType' => '\\StructType\\Item_Receipt_Line_Replacement_DataType',
            'Submit_Receipt_RequestType' => '\\StructType\\Submit_Receipt_RequestType',
            'Submit_Receipt_ResponseType' => '\\StructType\\Submit_Receipt_ResponseType',
            'Register_Asset_RequestType' => '\\StructType\\Register_Asset_RequestType',
            'Register_Asset_ResponseType' => '\\StructType\\Register_Asset_ResponseType',
            'Business_Asset_for_Register_WWS_DataType' => '\\StructType\\Business_Asset_for_Register_WWS_DataType',
            'Asset_Book_Configuration_WWS_DataType' => '\\StructType\\Asset_Book_Configuration_WWS_DataType',
            'Catalog_Item_Request_ReferencesType' => '\\StructType\\Catalog_Item_Request_ReferencesType',
            'Catalog_Item_Request_CriteriaType' => '\\StructType\\Catalog_Item_Request_CriteriaType',
            'Get_Catalog_Items_RequestType' => '\\StructType\\Get_Catalog_Items_RequestType',
            'Catalog_ItemType' => '\\StructType\\Catalog_ItemType',
            'Catalog_Item_Response_DataType' => '\\StructType\\Catalog_Item_Response_DataType',
            'Get_Catalog_Items_ResponseType' => '\\StructType\\Get_Catalog_Items_ResponseType',
            'Catalog_Item_Data_DataType' => '\\StructType\\Catalog_Item_Data_DataType',
            'Catalog_Item_DataType' => '\\StructType\\Catalog_Item_DataType',
            'Cancel_Purchase_Order_RequestType' => '\\StructType\\Cancel_Purchase_Order_RequestType',
            'Cancel_Purchase_Order_ResponseType' => '\\StructType\\Cancel_Purchase_Order_ResponseType',
            'Note_WWS_DataType' => '\\StructType\\Note_WWS_DataType',
            'Requisition_Request_ReferencesType' => '\\StructType\\Requisition_Request_ReferencesType',
            'Requisition_Request_CriteriaType' => '\\StructType\\Requisition_Request_CriteriaType',
            'Requisition_Response_GroupType' => '\\StructType\\Requisition_Response_GroupType',
            'Get_Requisitions_RequestType' => '\\StructType\\Get_Requisitions_RequestType',
            'RequisitionType' => '\\StructType\\RequisitionType',
            'Requisition_Response_DataType' => '\\StructType\\Requisition_Response_DataType',
            'Get_Requisitions_ResponseType' => '\\StructType\\Get_Requisitions_ResponseType',
            'Requisition_DataType' => '\\StructType\\Requisition_DataType',
            'Asset_Book_Rule_Request_ReferencesType' => '\\StructType\\Asset_Book_Rule_Request_ReferencesType',
            'Get_Asset_Book_Rules_RequestType' => '\\StructType\\Get_Asset_Book_Rules_RequestType',
            'Asset_Book_RuleType' => '\\StructType\\Asset_Book_RuleType',
            'Asset_Book_Rule_Response_DataType' => '\\StructType\\Asset_Book_Rule_Response_DataType',
            'Get_Asset_Book_Rules_ResponseType' => '\\StructType\\Get_Asset_Book_Rules_ResponseType',
            'Asset_Book_Rule_DataType' => '\\StructType\\Asset_Book_Rule_DataType',
            'Asset_Book_Rule_Replacement_DataType' => '\\StructType\\Asset_Book_Rule_Replacement_DataType',
            'Put_Asset_Book_Rules_RequestType' => '\\StructType\\Put_Asset_Book_Rules_RequestType',
            'Put_Asset_Book_Rules_ResponseType' => '\\StructType\\Put_Asset_Book_Rules_ResponseType',
            'Item_Request_Line_DataType' => '\\StructType\\Item_Request_Line_DataType',
            'Project-Based_Requisition_Line_DataType' => '\\StructType\\Project_Based_Requisition_Line_DataType',
            'Cancel_Requisition_RequestType' => '\\StructType\\Cancel_Requisition_RequestType',
            'Cancel_Requisition_ResponseType' => '\\StructType\\Cancel_Requisition_ResponseType',
            'Asset_Issue_DataType' => '\\StructType\\Asset_Issue_DataType',
            'Issue_Asset_RequestType' => '\\StructType\\Issue_Asset_RequestType',
            'Issue_Asset_ResponseType' => '\\StructType\\Issue_Asset_ResponseType',
            'Submit_Requisition_RequestType' => '\\StructType\\Submit_Requisition_RequestType',
            'Submit_Requisition_ResponseType' => '\\StructType\\Submit_Requisition_ResponseType',
            'Project_Plan_Phase_Requisition_DataType' => '\\StructType\\Project_Plan_Phase_Requisition_DataType',
            'Project_Plan_Task_Requisition_DataType' => '\\StructType\\Project_Plan_Task_Requisition_DataType',
            'Business_Asset_Cost_Adjustment_DataType' => '\\StructType\\Business_Asset_Cost_Adjustment_DataType',
            'Adjust_Asset_Cost_RequestType' => '\\StructType\\Adjust_Asset_Cost_RequestType',
            'Adjust_Asset_Cost_ResponseType' => '\\StructType\\Adjust_Asset_Cost_ResponseType',
            'Asset_Edit_DataType' => '\\StructType\\Asset_Edit_DataType',
            'Edit_Asset_RequestType' => '\\StructType\\Edit_Asset_RequestType',
            'Edit_Asset_ResponseType' => '\\StructType\\Edit_Asset_ResponseType',
            'Business_Asset_Useful_Life_Update_DataType' => '\\StructType\\Business_Asset_Useful_Life_Update_DataType',
            'Update_Asset_Useful_Life_RequestType' => '\\StructType\\Update_Asset_Useful_Life_RequestType',
            'Update_Asset_Useful_Life_ResponseType' => '\\StructType\\Update_Asset_Useful_Life_ResponseType',
            'Hotel_Itemization_Mapping_DataType' => '\\StructType\\Hotel_Itemization_Mapping_DataType',
            'Asset_Transfer_DataType' => '\\StructType\\Asset_Transfer_DataType',
            'Transfer_Asset_RequestType' => '\\StructType\\Transfer_Asset_RequestType',
            'Transfer_Asset_ResponseType' => '\\StructType\\Transfer_Asset_ResponseType',
            'Spend_Authorization_DataType' => '\\StructType\\Spend_Authorization_DataType',
            'Submit_Spend_Authorization_RequestType' => '\\StructType\\Submit_Spend_Authorization_RequestType',
            'Submit_Spend_Authorization_ResponseType' => '\\StructType\\Submit_Spend_Authorization_ResponseType',
            'Spend_Authorization_Line_DataType' => '\\StructType\\Spend_Authorization_Line_DataType',
            'Spend_Authorization_Request_ReferencesType' => '\\StructType\\Spend_Authorization_Request_ReferencesType',
            'Spend_Authorization_Request_CriteriaType' => '\\StructType\\Spend_Authorization_Request_CriteriaType',
            'Spend_Authorization_Response_GroupType' => '\\StructType\\Spend_Authorization_Response_GroupType',
            'Get_Spend_Authorizations_RequestType' => '\\StructType\\Get_Spend_Authorizations_RequestType',
            'Spend_AuthorizationType' => '\\StructType\\Spend_AuthorizationType',
            'Spend_Authorization_Response_DataType' => '\\StructType\\Spend_Authorization_Response_DataType',
            'Get_Spend_Authorizations_ResponseType' => '\\StructType\\Get_Spend_Authorizations_ResponseType',
            'Business_Document_Line_Split_DataType' => '\\StructType\\Business_Document_Line_Split_DataType',
            'Supplier_Invoice_Schedule_Request_ReferencesType' => '\\StructType\\Supplier_Invoice_Schedule_Request_ReferencesType',
            'Supplier_Invoice_Schedule_Request_CriteriaType' => '\\StructType\\Supplier_Invoice_Schedule_Request_CriteriaType',
            'Supplier_Invoice_Schedule_Response_GroupType' => '\\StructType\\Supplier_Invoice_Schedule_Response_GroupType',
            'Get_Supplier_Invoice_Schedules_RequestType' => '\\StructType\\Get_Supplier_Invoice_Schedules_RequestType',
            'Supplier_Invoice_ScheduleType' => '\\StructType\\Supplier_Invoice_ScheduleType',
            'Supplier_Invoice_Schedule_Response_DataType' => '\\StructType\\Supplier_Invoice_Schedule_Response_DataType',
            'Get_Supplier_Invoice_Schedules_ResponseType' => '\\StructType\\Get_Supplier_Invoice_Schedules_ResponseType',
            'Purchase_Order_Schedule_Request_ReferencesType' => '\\StructType\\Purchase_Order_Schedule_Request_ReferencesType',
            'Purchase_Order_Schedule_Request_CriteriaType' => '\\StructType\\Purchase_Order_Schedule_Request_CriteriaType',
            'Purchase_Order_Schedule_Response_GroupType' => '\\StructType\\Purchase_Order_Schedule_Response_GroupType',
            'Get_Purchase_Order_Schedules_RequestType' => '\\StructType\\Get_Purchase_Order_Schedules_RequestType',
            'Purchase_Order_ScheduleType' => '\\StructType\\Purchase_Order_ScheduleType',
            'Purchase_Order_Schedule_Response_DataType' => '\\StructType\\Purchase_Order_Schedule_Response_DataType',
            'Get_Purchase_Order_Schedules_ResponseType' => '\\StructType\\Get_Purchase_Order_Schedules_ResponseType',
            'Supplier_Contract_Amendment_Request_ReferencesType' => '\\StructType\\Supplier_Contract_Amendment_Request_ReferencesType',
            'Supplier_Contract_Amendment_Response_GroupType' => '\\StructType\\Supplier_Contract_Amendment_Response_GroupType',
            'Supplier_Contract_DataType' => '\\StructType\\Supplier_Contract_DataType',
            'Submit_Supplier_Contract_RequestType' => '\\StructType\\Submit_Supplier_Contract_RequestType',
            'Related_Asset_Replacement_DataType' => '\\StructType\\Related_Asset_Replacement_DataType',
            'Supplier_Contract_Request_ReferencesType' => '\\StructType\\Supplier_Contract_Request_ReferencesType',
            'Supplier_Contract_Request_CriteriaType' => '\\StructType\\Supplier_Contract_Request_CriteriaType',
            'Supplier_Contract_Response_GroupType' => '\\StructType\\Supplier_Contract_Response_GroupType',
            'Get_Supplier_Contracts_RequestType' => '\\StructType\\Get_Supplier_Contracts_RequestType',
            'Supplier_ContractType' => '\\StructType\\Supplier_ContractType',
            'Supplier_Contract_Response_DataType' => '\\StructType\\Supplier_Contract_Response_DataType',
            'Get_Supplier_Contracts_ResponseType' => '\\StructType\\Get_Supplier_Contracts_ResponseType',
            'Supplier_Contract_Line_Replacement_DataType' => '\\StructType\\Supplier_Contract_Line_Replacement_DataType',
            'Supplier_Catalog_Request_ReferencesType' => '\\StructType\\Supplier_Catalog_Request_ReferencesType',
            'Supplier_Catalog_Request_CriteriaType' => '\\StructType\\Supplier_Catalog_Request_CriteriaType',
            'Supplier_Catalog_Response_GroupType' => '\\StructType\\Supplier_Catalog_Response_GroupType',
            'Get_Supplier_Catalogs_RequestType' => '\\StructType\\Get_Supplier_Catalogs_RequestType',
            'Supplier_CatalogType' => '\\StructType\\Supplier_CatalogType',
            'Supplier_Catalog_Response_DataType' => '\\StructType\\Supplier_Catalog_Response_DataType',
            'Get_Supplier_Catalogs_ResponseType' => '\\StructType\\Get_Supplier_Catalogs_ResponseType',
            'Supplier_Catalog_DataType' => '\\StructType\\Supplier_Catalog_DataType',
            'Catalog_Item_for_Supplier_Contract_DataType' => '\\StructType\\Catalog_Item_for_Supplier_Contract_DataType',
            'Catalog_Item_Data_for_Catalog_DataType' => '\\StructType\\Catalog_Item_Data_for_Catalog_DataType',
            'Put_Supplier_Catalog_RequestType' => '\\StructType\\Put_Supplier_Catalog_RequestType',
            'Put_Supplier_Catalog_ResponseType' => '\\StructType\\Put_Supplier_Catalog_ResponseType',
            'Supplier_Contract_Amendment_InformationType' => '\\StructType\\Supplier_Contract_Amendment_InformationType',
            'Airline_Request_ReferencesType' => '\\StructType\\Airline_Request_ReferencesType',
            'Airline_Request_CriteriaType' => '\\StructType\\Airline_Request_CriteriaType',
            'Airline_Response_GroupType' => '\\StructType\\Airline_Response_GroupType',
            'Get_Airlines_RequestType' => '\\StructType\\Get_Airlines_RequestType',
            'AirlineType' => '\\StructType\\AirlineType',
            'Airline_Response_DataType' => '\\StructType\\Airline_Response_DataType',
            'Get_Airlines_ResponseType' => '\\StructType\\Get_Airlines_ResponseType',
            'Airline_DataType' => '\\StructType\\Airline_DataType',
            'Put_Airline_RequestType' => '\\StructType\\Put_Airline_RequestType',
            'Put_Airline_ResponseType' => '\\StructType\\Put_Airline_ResponseType',
            'Hotel_Request_ReferencesType' => '\\StructType\\Hotel_Request_ReferencesType',
            'Hotel_Request_CriteriaType' => '\\StructType\\Hotel_Request_CriteriaType',
            'Hotel_Response_GroupType' => '\\StructType\\Hotel_Response_GroupType',
            'Get_Hotels_RequestType' => '\\StructType\\Get_Hotels_RequestType',
            'HotelType' => '\\StructType\\HotelType',
            'Hotel_Response_DataType' => '\\StructType\\Hotel_Response_DataType',
            'Get_Hotels_ResponseType' => '\\StructType\\Get_Hotels_ResponseType',
            'Hotel_DataType' => '\\StructType\\Hotel_DataType',
            'Put_Hotel_RequestType' => '\\StructType\\Put_Hotel_RequestType',
            'Put_Hotel_ResponseType' => '\\StructType\\Put_Hotel_ResponseType',
            'Car_Rental_Agency_Request_ReferencesType' => '\\StructType\\Car_Rental_Agency_Request_ReferencesType',
            'Car_Rental_Agency_Request_CriteriaType' => '\\StructType\\Car_Rental_Agency_Request_CriteriaType',
            'Car_Rental_Agency_Response_GroupType' => '\\StructType\\Car_Rental_Agency_Response_GroupType',
            'Get_Car_Rental_Agencies_RequestType' => '\\StructType\\Get_Car_Rental_Agencies_RequestType',
            'Car_Rental_AgencyType' => '\\StructType\\Car_Rental_AgencyType',
            'Car_Rental_Agency_Response_DataType' => '\\StructType\\Car_Rental_Agency_Response_DataType',
            'Get_Car_Rental_Agencies_ResponseType' => '\\StructType\\Get_Car_Rental_Agencies_ResponseType',
            'Car_Rental_Agency_DataType' => '\\StructType\\Car_Rental_Agency_DataType',
            'Put_Car_Rental_Agency_RequestType' => '\\StructType\\Put_Car_Rental_Agency_RequestType',
            'Put_Car_Rental_Agency_ResponseType' => '\\StructType\\Put_Car_Rental_Agency_ResponseType',
            'Travel_City_Request_ReferencesType' => '\\StructType\\Travel_City_Request_ReferencesType',
            'Travel_City_Request_CriteriaType' => '\\StructType\\Travel_City_Request_CriteriaType',
            'Travel_City_Response_GroupType' => '\\StructType\\Travel_City_Response_GroupType',
            'Get_Travel_Cities_RequestType' => '\\StructType\\Get_Travel_Cities_RequestType',
            'Travel_CityType' => '\\StructType\\Travel_CityType',
            'Travel_City_Response_DataType' => '\\StructType\\Travel_City_Response_DataType',
            'Get_Travel_Cities_ResponseType' => '\\StructType\\Get_Travel_Cities_ResponseType',
            'Travel_City_DataType' => '\\StructType\\Travel_City_DataType',
            'Put_Travel_City_RequestType' => '\\StructType\\Put_Travel_City_RequestType',
            'Put_Travel_City_ResponseType' => '\\StructType\\Put_Travel_City_ResponseType',
            'Airport_Request_ReferencesType' => '\\StructType\\Airport_Request_ReferencesType',
            'Airport_Request_CriteriaType' => '\\StructType\\Airport_Request_CriteriaType',
            'Airport_Response_GroupType' => '\\StructType\\Airport_Response_GroupType',
            'Get_Airports_RequestType' => '\\StructType\\Get_Airports_RequestType',
            'AirportType' => '\\StructType\\AirportType',
            'Airport_Response_DataType' => '\\StructType\\Airport_Response_DataType',
            'Get_Airports_ResponseType' => '\\StructType\\Get_Airports_ResponseType',
            'Airport_DataType' => '\\StructType\\Airport_DataType',
            'Put_Airport_RequestType' => '\\StructType\\Put_Airport_RequestType',
            'Put_Airport_ResponseType' => '\\StructType\\Put_Airport_ResponseType',
            'Submit_Supplier_Contract_ResponseType' => '\\StructType\\Submit_Supplier_Contract_ResponseType',
            'Item_Receipt_Line_Split_DataType' => '\\StructType\\Item_Receipt_Line_Split_DataType',
            'Supplier_Invoice_Line_Split_DataType' => '\\StructType\\Supplier_Invoice_Line_Split_DataType',
            'Transfer_Asset_To_Different_Company_DataType' => '\\StructType\\Transfer_Asset_To_Different_Company_DataType',
            'Transfer_Asset_To_Different_Company_RequestType' => '\\StructType\\Transfer_Asset_To_Different_Company_RequestType',
            'Transfer_Asset_To_Different_Company_ResponseType' => '\\StructType\\Transfer_Asset_To_Different_Company_ResponseType',
            'Asset_Request_ReferencesType' => '\\StructType\\Asset_Request_ReferencesType',
            'Asset_Request_CriteriaType' => '\\StructType\\Asset_Request_CriteriaType',
            'Asset_Response_GroupType' => '\\StructType\\Asset_Response_GroupType',
            'Get_Assets_RequestType' => '\\StructType\\Get_Assets_RequestType',
            'AssetType' => '\\StructType\\AssetType',
            'Asset_Response_DataType' => '\\StructType\\Asset_Response_DataType',
            'Get_Assets_ResponseType' => '\\StructType\\Get_Assets_ResponseType',
            'Asset_DataType' => '\\StructType\\Asset_DataType',
            'CC_Transaction_LineType' => '\\StructType\\CC_Transaction_LineType',
            'Asset_Acquisition_WWS_DataType' => '\\StructType\\Asset_Acquisition_WWS_DataType',
            'Alternate_Merchant_Name_DataType' => '\\StructType\\Alternate_Merchant_Name_DataType',
            'Asset_In_Service_Schedule_WWS_DataType' => '\\StructType\\Asset_In_Service_Schedule_WWS_DataType',
            'Asset_Impairment_WWS_DataType' => '\\StructType\\Asset_Impairment_WWS_DataType',
            'Asset_Intercompany_Transfer_WWS_DataType' => '\\StructType\\Asset_Intercompany_Transfer_WWS_DataType',
            'Asset_Reinstatement_WWS_DataType' => '\\StructType\\Asset_Reinstatement_WWS_DataType',
            'Asset_Disposal_WWS_DataType' => '\\StructType\\Asset_Disposal_WWS_DataType',
            'Asset_Depreciation_WWS_DataType' => '\\StructType\\Asset_Depreciation_WWS_DataType',
            'Asset_Custodian_WWS_DataType' => '\\StructType\\Asset_Custodian_WWS_DataType',
            'Asset_Cost_Adjustment_WWS_DataType' => '\\StructType\\Asset_Cost_Adjustment_WWS_DataType',
            'Credit_Card_Transaction_Name_Match_DataType' => '\\StructType\\Credit_Card_Transaction_Name_Match_DataType',
            'Asset_Book_Rule_Request_CriteriaType' => '\\StructType\\Asset_Book_Rule_Request_CriteriaType',
            'Asset_Book_Rule_Response_GroupType' => '\\StructType\\Asset_Book_Rule_Response_GroupType',
            'Travel_City_Alternate_Name_DataType' => '\\StructType\\Travel_City_Alternate_Name_DataType',
            'Impair_Asset_WWS_DataType' => '\\StructType\\Impair_Asset_WWS_DataType',
            'Impair_Asset_RequestType' => '\\StructType\\Impair_Asset_RequestType',
            'Impair_Asset_ResponseType' => '\\StructType\\Impair_Asset_ResponseType',
            'Reinstate_Asset_WWS_DataType' => '\\StructType\\Reinstate_Asset_WWS_DataType',
            'Reinstate_Asset_RequestType' => '\\StructType\\Reinstate_Asset_RequestType',
            'Reinstate_Asset_ResponseType' => '\\StructType\\Reinstate_Asset_ResponseType',
            'Dispose_Asset_DataType' => '\\StructType\\Dispose_Asset_DataType',
            'Dispose_Asset_RequestType' => '\\StructType\\Dispose_Asset_RequestType',
            'Dispose_Asset_ResponseType' => '\\StructType\\Dispose_Asset_ResponseType',
            'Asset_Depreciation_Detail_DataType' => '\\StructType\\Asset_Depreciation_Detail_DataType',
            'Asset_Depreciation_Detail_Line_DataType' => '\\StructType\\Asset_Depreciation_Detail_Line_DataType',
            'Contingent_Worker_Receipt_Line_Replacement_DataType' => '\\StructType\\Contingent_Worker_Receipt_Line_Replacement_DataType',
            'Hours_Worked_DataType' => '\\StructType\\Hours_Worked_DataType',
            'Asset_Book_Configurations_Request_ReferencesType' => '\\StructType\\Asset_Book_Configurations_Request_ReferencesType',
            'Asset_Book_Configurations_Request_CriteriaType' => '\\StructType\\Asset_Book_Configurations_Request_CriteriaType',
            'Get_Asset_Book_Configurations_RequestType' => '\\StructType\\Get_Asset_Book_Configurations_RequestType',
            'Asset_Depreciation_ScheduleType' => '\\StructType\\Asset_Depreciation_ScheduleType',
            'Asset_Book_Configuration_Response_DataType' => '\\StructType\\Asset_Book_Configuration_Response_DataType',
            'Get_Asset_Book_Configurations_ResponseType' => '\\StructType\\Get_Asset_Book_Configurations_ResponseType',
            'Asset_Depreciation_Schedule_DataType' => '\\StructType\\Asset_Depreciation_Schedule_DataType',
            'Asset_for_Depreciation_Schedule_DataType' => '\\StructType\\Asset_for_Depreciation_Schedule_DataType',
            'Update_Asset_Book_Configuration_RequestType' => '\\StructType\\Update_Asset_Book_Configuration_RequestType',
            'Update_Asset_Book_Configuration_ResponseType' => '\\StructType\\Update_Asset_Book_Configuration_ResponseType',
            'Asset_Depreciation_Schedule_Additional_InformationType' => '\\StructType\\Asset_Depreciation_Schedule_Additional_InformationType',
            'Remove_Asset_DataType' => '\\StructType\\Remove_Asset_DataType',
            'Remove_Asset_RequestType' => '\\StructType\\Remove_Asset_RequestType',
            'Remove_Asset_ResponseType' => '\\StructType\\Remove_Asset_ResponseType',
            'Cancel_Receipt_RequestType' => '\\StructType\\Cancel_Receipt_RequestType',
            'Cancel_Receipt_ResponseType' => '\\StructType\\Cancel_Receipt_ResponseType',
            'Asset_Reclassification_WWS_DataType' => '\\StructType\\Asset_Reclassification_WWS_DataType',
            'Asset_Removal_WWS_DataType' => '\\StructType\\Asset_Removal_WWS_DataType',
            'Address_ReferenceType' => '\\StructType\\Address_ReferenceType',
            'Put_Import_Process_ResponseType' => '\\StructType\\Put_Import_Process_ResponseType',
            'Prepaid_Spend_Amortization_Request_CriteriaType' => '\\StructType\\Prepaid_Spend_Amortization_Request_CriteriaType',
            'Prepaid_Spend_Amortization_Response_GroupType' => '\\StructType\\Prepaid_Spend_Amortization_Response_GroupType',
            'Get_Prepaid_Spend_Amortizations_RequestType' => '\\StructType\\Get_Prepaid_Spend_Amortizations_RequestType',
            'Prepaid_Spend_AmortizationType' => '\\StructType\\Prepaid_Spend_AmortizationType',
            'Prepaid_Spend_Amortization_Response_DataType' => '\\StructType\\Prepaid_Spend_Amortization_Response_DataType',
            'Get_Prepaid_Spend_Amortizations_ResponseType' => '\\StructType\\Get_Prepaid_Spend_Amortizations_ResponseType',
            'Prepaid_Spend_Amortization_DataType' => '\\StructType\\Prepaid_Spend_Amortization_DataType',
            'Submit_Prepaid_Spend_Amortization_RequestType' => '\\StructType\\Submit_Prepaid_Spend_Amortization_RequestType',
            'Submit_Prepaid_Spend_Amortization_ResponseType' => '\\StructType\\Submit_Prepaid_Spend_Amortization_ResponseType',
            'Supplier_Invoice_Schedule_DataType' => '\\StructType\\Supplier_Invoice_Schedule_DataType',
            'Supplier_Invoice_Installment_Replacement_DataType' => '\\StructType\\Supplier_Invoice_Installment_Replacement_DataType',
            'Supplier_Contract_Installment_Line_DataType' => '\\StructType\\Supplier_Contract_Installment_Line_DataType',
            'Submit_Supplier_Invoice_Schedule_RequestType' => '\\StructType\\Submit_Supplier_Invoice_Schedule_RequestType',
            'Submit_Supplier_Invoice_Schedule_ResponseType' => '\\StructType\\Submit_Supplier_Invoice_Schedule_ResponseType',
            'Suspend_Asset_Depreciation_RequestType' => '\\StructType\\Suspend_Asset_Depreciation_RequestType',
            'Suspend_Asset_Depreciation_for_WWS_DataType' => '\\StructType\\Suspend_Asset_Depreciation_for_WWS_DataType',
            'Suspend_Asset_Depreciation_ResponseType' => '\\StructType\\Suspend_Asset_Depreciation_ResponseType',
            'Bill_To_Address_ReferenceType' => '\\StructType\\Bill_To_Address_ReferenceType',
            'Ship_To_Address_ReferenceType' => '\\StructType\\Ship_To_Address_ReferenceType',
            'Filter_DateTimeZone_DataType' => '\\StructType\\Filter_DateTimeZone_DataType',
            'Purchase_Order_Installment_Replacement_DataType' => '\\StructType\\Purchase_Order_Installment_Replacement_DataType',
            'Purchase_Order_Schedule_DataType' => '\\StructType\\Purchase_Order_Schedule_DataType',
            'Remove_Supplier_Contract_Line_Hold_RequestType' => '\\StructType\\Remove_Supplier_Contract_Line_Hold_RequestType',
            'Add_Supplier_Contract_Line_Hold_RequestType' => '\\StructType\\Add_Supplier_Contract_Line_Hold_RequestType',
            'Add_Supplier_Contract_Line_Hold_ResponseType' => '\\StructType\\Add_Supplier_Contract_Line_Hold_ResponseType',
            'Remove_Supplier_Contract_Line_Hold_ResponseType' => '\\StructType\\Remove_Supplier_Contract_Line_Hold_ResponseType',
            'Submit_Purchase_Order_Schedule_RequestType' => '\\StructType\\Submit_Purchase_Order_Schedule_RequestType',
            'Submit_Purchase_Order_Schedule_ResponseType' => '\\StructType\\Submit_Purchase_Order_Schedule_ResponseType',
            'Prepaid_Spend_Amortization_Schedule_DataType' => '\\StructType\\Prepaid_Spend_Amortization_Schedule_DataType',
            'Submit_Prepaid_Spend_Amortization_Schedule_RequestType' => '\\StructType\\Submit_Prepaid_Spend_Amortization_Schedule_RequestType',
            'Submit_Prepaid_Spend_Amortization_Schedule_ResponseType' => '\\StructType\\Submit_Prepaid_Spend_Amortization_Schedule_ResponseType',
            'Prepaid_Spend_Amortization_Installment_DataType' => '\\StructType\\Prepaid_Spend_Amortization_Installment_DataType',
            'Prepaid_Spend_Amortization_Installment_Line_DataType' => '\\StructType\\Prepaid_Spend_Amortization_Installment_Line_DataType',
            'Remove_Supplier_Contract_Line_Hold_DataType' => '\\StructType\\Remove_Supplier_Contract_Line_Hold_DataType',
            'Goods_Line_Add_Hold_DataType' => '\\StructType\\Goods_Line_Add_Hold_DataType',
            'Add_Supplier_Contract_Line_Hold_DataType' => '\\StructType\\Add_Supplier_Contract_Line_Hold_DataType',
            'Prepaid_Spend_Amortization_Schedule_Request_ReferencesType' => '\\StructType\\Prepaid_Spend_Amortization_Schedule_Request_ReferencesType',
            'Get_Prepaid_Spend_Amortization_Schedules_RequestType' => '\\StructType\\Get_Prepaid_Spend_Amortization_Schedules_RequestType',
            'Prepaid_Spend_Amortization_ScheduleType' => '\\StructType\\Prepaid_Spend_Amortization_ScheduleType',
            'Prepaid_Spend_Amortization_Schedule_Response_DataType' => '\\StructType\\Prepaid_Spend_Amortization_Schedule_Response_DataType',
            'Get_Prepaid_Spend_Amortization_Schedules_ResponseType' => '\\StructType\\Get_Prepaid_Spend_Amortization_Schedules_ResponseType',
            'Project_Asset_Request_ReferencesType' => '\\StructType\\Project_Asset_Request_ReferencesType',
            'Project_Asset_Request_CriteriaType' => '\\StructType\\Project_Asset_Request_CriteriaType',
            'Project_Asset_Response_GroupType' => '\\StructType\\Project_Asset_Response_GroupType',
            'Get_Project_Asset_RequestType' => '\\StructType\\Get_Project_Asset_RequestType',
            'Project_AssetType' => '\\StructType\\Project_AssetType',
            'Project_Asset_Response_DataType' => '\\StructType\\Project_Asset_Response_DataType',
            'Get_Project_Asset_ResponseType' => '\\StructType\\Get_Project_Asset_ResponseType',
            'Project_Asset_DataType' => '\\StructType\\Project_Asset_DataType',
            'Put_Project_Asset_RequestType' => '\\StructType\\Put_Project_Asset_RequestType',
            'Put_Project_Asset_ResponseType' => '\\StructType\\Put_Project_Asset_ResponseType',
            'Resume_Asset_Depreciation_RequestType' => '\\StructType\\Resume_Asset_Depreciation_RequestType',
            'Resume_Asset_Depreciation_for_WWS_DataType' => '\\StructType\\Resume_Asset_Depreciation_for_WWS_DataType',
            'Resume_Asset_Depreciation_ResponseType' => '\\StructType\\Resume_Asset_Depreciation_ResponseType',
            'Asset_Pooling_Rule_Request_ReferencesType' => '\\StructType\\Asset_Pooling_Rule_Request_ReferencesType',
            'Asset_Pooling_Rule_Request_CriteriaType' => '\\StructType\\Asset_Pooling_Rule_Request_CriteriaType',
            'Asset_Pooling_Rule_Response_GroupType' => '\\StructType\\Asset_Pooling_Rule_Response_GroupType',
            'Get_Asset_Pooling_Rules_RequestType' => '\\StructType\\Get_Asset_Pooling_Rules_RequestType',
            'Asset_Pooling_Rule_Response_DataType' => '\\StructType\\Asset_Pooling_Rule_Response_DataType',
            'Get_Asset_Pooling_Rules_ResponseType' => '\\StructType\\Get_Asset_Pooling_Rules_ResponseType',
            'Asset_Pooling_Rule_Replacement_DataType' => '\\StructType\\Asset_Pooling_Rule_Replacement_DataType',
            'Asset_Pooling_RuleType' => '\\StructType\\Asset_Pooling_RuleType',
            'Put_Asset_Pooling_Rule_RequestType' => '\\StructType\\Put_Asset_Pooling_Rule_RequestType',
            'Put_Asset_Pooling_Rule_ResponseType' => '\\StructType\\Put_Asset_Pooling_Rule_ResponseType',
            'Intermediary_Bank_Account_WWS_DataType' => '\\StructType\\Intermediary_Bank_Account_WWS_DataType',
            'Asset_Pooling_Rule_DataType' => '\\StructType\\Asset_Pooling_Rule_DataType',
            'Submit_Supplier_RequestType' => '\\StructType\\Submit_Supplier_RequestType',
            'Submit_Supplier_ResponseType' => '\\StructType\\Submit_Supplier_ResponseType',
            'Submit_Return_RequestType' => '\\StructType\\Submit_Return_RequestType',
            'Submit_Return_DataType' => '\\StructType\\Submit_Return_DataType',
            'Item_Return_Line_Replacement_DataType' => '\\StructType\\Item_Return_Line_Replacement_DataType',
            'Submit_Return_ResponseType' => '\\StructType\\Submit_Return_ResponseType',
            'Proposed_Supplier_Status_DataType' => '\\StructType\\Proposed_Supplier_Status_DataType',
            'Asset_Components_WWS_DataType' => '\\StructType\\Asset_Components_WWS_DataType',
            'Component_Asset_WWS_DataType' => '\\StructType\\Component_Asset_WWS_DataType',
            'Get_Returns_RequestType' => '\\StructType\\Get_Returns_RequestType',
            'Return_Request_ReferencesType' => '\\StructType\\Return_Request_ReferencesType',
            'Return_Request_CriteriaType' => '\\StructType\\Return_Request_CriteriaType',
            'Return_Response_GroupType' => '\\StructType\\Return_Response_GroupType',
            'Get_Returns_ResponseType' => '\\StructType\\Get_Returns_ResponseType',
            'Return_Response_DataType' => '\\StructType\\Return_Response_DataType',
            'Return_to_SupplierType' => '\\StructType\\Return_to_SupplierType',
            'Return_to_Supplier_DataType' => '\\StructType\\Return_to_Supplier_DataType',
            'Return_to_Supplier_Line_DataType' => '\\StructType\\Return_to_Supplier_Line_DataType',
            'Place_Asset_in_Service_RequestType' => '\\StructType\\Place_Asset_in_Service_RequestType',
            'Asset_Place_in_Service_DataType' => '\\StructType\\Asset_Place_in_Service_DataType',
            'Place_Asset_in_Service_ResponseType' => '\\StructType\\Place_Asset_in_Service_ResponseType',
            'Submit_Workday_Project_Hierarchy_RequestType' => '\\StructType\\Submit_Workday_Project_Hierarchy_RequestType',
            'Submit_Workday_Project_Hierarchy_ResponseType' => '\\StructType\\Submit_Workday_Project_Hierarchy_ResponseType',
            'Project_Hierarchy_WWS_DataType' => '\\StructType\\Project_Hierarchy_WWS_DataType',
            'Get_Workday_Project_Hierarchies_RequestType' => '\\StructType\\Get_Workday_Project_Hierarchies_RequestType',
            'Get_Workday_Project_Hierarchies_ResponseType' => '\\StructType\\Get_Workday_Project_Hierarchies_ResponseType',
            'Projects_Hierarchy_Response_DataType' => '\\StructType\\Projects_Hierarchy_Response_DataType',
            'Projects_HierarchyType' => '\\StructType\\Projects_HierarchyType',
            'Get_Workday_Project_Hierarchies_without_Dependencies_RequestType' => '\\StructType\\Get_Workday_Project_Hierarchies_without_Dependencies_RequestType',
            'Get_Workday_Project_Hierarchies_without_Dependencies_ResponseType' => '\\StructType\\Get_Workday_Project_Hierarchies_without_Dependencies_ResponseType',
            'Areas_Changed_WWS_DataType' => '\\StructType\\Areas_Changed_WWS_DataType',
            'Submit_Return_Line_Split_DataType' => '\\StructType\\Submit_Return_Line_Split_DataType',
            'Supplier_Invoice__HV__DataType' => '\\StructType\\Supplier_Invoice__HV__DataType',
            'Import_Supplier_Invoice_RequestType' => '\\StructType\\Import_Supplier_Invoice_RequestType',
            'Supplier_Invoice_Line_Replacement__HV__DataType' => '\\StructType\\Supplier_Invoice_Line_Replacement__HV__DataType',
            'Procurement_Card_Transaction_Verification_Request_ReferencesType' => '\\StructType\\Procurement_Card_Transaction_Verification_Request_ReferencesType',
            'Procurement_Card_Transaction_Verification_Request_CriteriaType' => '\\StructType\\Procurement_Card_Transaction_Verification_Request_CriteriaType',
            'Procurement_Card_Transaction_Verification_Response_GroupType' => '\\StructType\\Procurement_Card_Transaction_Verification_Response_GroupType',
            'Get_Procurement_Card_Transaction_Verifications_RequestType' => '\\StructType\\Get_Procurement_Card_Transaction_Verifications_RequestType',
            'Procurement_Card_Transaction_VerificationType' => '\\StructType\\Procurement_Card_Transaction_VerificationType',
            'Procurement_Card_Transaction_Verification_Response_DataType' => '\\StructType\\Procurement_Card_Transaction_Verification_Response_DataType',
            'Get_Procurement_Card_Transaction_Verifications_ResponseType' => '\\StructType\\Get_Procurement_Card_Transaction_Verifications_ResponseType',
            'Procurement_Card_Transaction_Verification_DataType' => '\\StructType\\Procurement_Card_Transaction_Verification_DataType',
            'Procurement_Card_Transaction_Verification_Summary_DataType' => '\\StructType\\Procurement_Card_Transaction_Verification_Summary_DataType',
            'Procurement_Card_Transaction_Verification_Line_DataType' => '\\StructType\\Procurement_Card_Transaction_Verification_Line_DataType',
            'Submit_Procurement_Card_Transaction_Verification_RequestType' => '\\StructType\\Submit_Procurement_Card_Transaction_Verification_RequestType',
            'Submit_Procurement_Card_Transaction_Verification_ResponseType' => '\\StructType\\Submit_Procurement_Card_Transaction_Verification_ResponseType',
            'Travel_Booking_Header_RequestType' => '\\StructType\\Travel_Booking_Header_RequestType',
            'Travel_Booking_Record_DataType' => '\\StructType\\Travel_Booking_Record_DataType',
            'Travel_Booking_File_DataType' => '\\StructType\\Travel_Booking_File_DataType',
            'Travel_Booking_Record_Name_Match_DataType' => '\\StructType\\Travel_Booking_Record_Name_Match_DataType',
            'Procurement_Mass_Close_Request_ReferencesType' => '\\StructType\\Procurement_Mass_Close_Request_ReferencesType',
            'Procurement_Mass_Close_Request_CriteriaType' => '\\StructType\\Procurement_Mass_Close_Request_CriteriaType',
            'Procurement_Mass_Close_Response_GroupType' => '\\StructType\\Procurement_Mass_Close_Response_GroupType',
            'Get_Procurement_Mass_Close_RequestType' => '\\StructType\\Get_Procurement_Mass_Close_RequestType',
            'Procurement_Mass_CloseType' => '\\StructType\\Procurement_Mass_CloseType',
            'Procurement_Mass_Close_Response_DataType' => '\\StructType\\Procurement_Mass_Close_Response_DataType',
            'Get_Procurement_Mass_Close_ResponseType' => '\\StructType\\Get_Procurement_Mass_Close_ResponseType',
            'Procurement_Mass_Close_DataType' => '\\StructType\\Procurement_Mass_Close_DataType',
            'Submit_Procurement_Mass_Close_RequestType' => '\\StructType\\Submit_Procurement_Mass_Close_RequestType',
            'Submit_Procurement_Mass_Close_ResponseType' => '\\StructType\\Submit_Procurement_Mass_Close_ResponseType',
            'Procurement_Year_End_Request_Line_DataType' => '\\StructType\\Procurement_Year_End_Request_Line_DataType',
            'Travel_Booking_File_Request_ReferencesType' => '\\StructType\\Travel_Booking_File_Request_ReferencesType',
            'Travel_Booking_File_Request_CriteriaType' => '\\StructType\\Travel_Booking_File_Request_CriteriaType',
            'Travel_Booking_File_Response_GroupType' => '\\StructType\\Travel_Booking_File_Response_GroupType',
            'Get_Travel_Booking_Files_RequestType' => '\\StructType\\Get_Travel_Booking_Files_RequestType',
            'Travel_Booking_FileType' => '\\StructType\\Travel_Booking_FileType',
            'Travel_Booking_File_Response_DataType' => '\\StructType\\Travel_Booking_File_Response_DataType',
            'Get_Travel_Booking_Files_ResponseType' => '\\StructType\\Get_Travel_Booking_Files_ResponseType',
            'Multi-Supplier_DataType' => '\\StructType\\Multi_Supplier_DataType',
            'Supplier_List_Entry_DataType' => '\\StructType\\Supplier_List_Entry_DataType',
            'Renewal_Terms_DataType' => '\\StructType\\Renewal_Terms_DataType',
            'Project_Task_Resource_Line_DataType' => '\\StructType\\Project_Task_Resource_Line_DataType',
            'Put_Project_Task_Resources_RequestType' => '\\StructType\\Put_Project_Task_Resources_RequestType',
            'Put_Project_Task_Resources_ResponseType' => '\\StructType\\Put_Project_Task_Resources_ResponseType',
            'Project_Task_Resources_Request_ReferencesType' => '\\StructType\\Project_Task_Resources_Request_ReferencesType',
            'Project_Task_Resources_Request_CriteriaType' => '\\StructType\\Project_Task_Resources_Request_CriteriaType',
            'Project_Task_Resources_Response_GroupType' => '\\StructType\\Project_Task_Resources_Response_GroupType',
            'Get_Project_Task_Resources_RequestType' => '\\StructType\\Get_Project_Task_Resources_RequestType',
            'Project_Task_ResourcesType' => '\\StructType\\Project_Task_ResourcesType',
            'Project_Task_Resources_Response_DataType' => '\\StructType\\Project_Task_Resources_Response_DataType',
            'Get_Project_Task_Resources_ResponseType' => '\\StructType\\Get_Project_Task_Resources_ResponseType',
            'Project_DataType' => '\\StructType\\Project_DataType',
            'Submit_Project_RequestType' => '\\StructType\\Submit_Project_RequestType',
            'Project_Request_ReferencesType' => '\\StructType\\Project_Request_ReferencesType',
            'Project_Request_CriteriaType' => '\\StructType\\Project_Request_CriteriaType',
            'Project_Response_GroupType' => '\\StructType\\Project_Response_GroupType',
            'Get_Projects_RequestType' => '\\StructType\\Get_Projects_RequestType',
            'ProjectType' => '\\StructType\\ProjectType',
            'Project_Response_DataType' => '\\StructType\\Project_Response_DataType',
            'Get_Projects_ResponseType' => '\\StructType\\Get_Projects_ResponseType',
            'Submit_Project_ResponseType' => '\\StructType\\Submit_Project_ResponseType',
            'Project_Plan_Request_ReferencesType' => '\\StructType\\Project_Plan_Request_ReferencesType',
            'Get_Project_Plans_RequestType' => '\\StructType\\Get_Project_Plans_RequestType',
            'Project_PlanType' => '\\StructType\\Project_PlanType',
            'Project_Plan_Response_DataType' => '\\StructType\\Project_Plan_Response_DataType',
            'Get_Project_Plans_ResponseType' => '\\StructType\\Get_Project_Plans_ResponseType',
            'Project_Plan_Phase_WWS_DataType' => '\\StructType\\Project_Plan_Phase_WWS_DataType',
            'Put_Project_Plan_RequestType' => '\\StructType\\Put_Project_Plan_RequestType',
            'Put_Project_Plan_ResponseType' => '\\StructType\\Put_Project_Plan_ResponseType',
            'Project_Plan_Task_WWS_DataType' => '\\StructType\\Project_Plan_Task_WWS_DataType',
            'Project_Plan_DataType' => '\\StructType\\Project_Plan_DataType',
            'Credit_Card_Transaction_Header__HV__RequestType' => '\\StructType\\Credit_Card_Transaction_Header__HV__RequestType',
            'Credit_Card_Transaction_File__HV__DataType' => '\\StructType\\Credit_Card_Transaction_File__HV__DataType',
            'Credit_Card_Transaction__HV__DataType' => '\\StructType\\Credit_Card_Transaction__HV__DataType',
            'Project_Task_Resources_DataType' => '\\StructType\\Project_Task_Resources_DataType',
            'Project_Resource_Plan_Detail_WWS_DataType' => '\\StructType\\Project_Resource_Plan_Detail_WWS_DataType',
            'Submit_Resource_Plan_ResponseType' => '\\StructType\\Submit_Resource_Plan_ResponseType',
            'Submit_Resource_Plan_RequestType' => '\\StructType\\Submit_Resource_Plan_RequestType',
            'Resource_Plan_DataType' => '\\StructType\\Resource_Plan_DataType',
            'Resource_Plan_Request_ReferencesType' => '\\StructType\\Resource_Plan_Request_ReferencesType',
            'Resource_Plan_Request_CriteriaType' => '\\StructType\\Resource_Plan_Request_CriteriaType',
            'Resource_Plan_Response_GroupType' => '\\StructType\\Resource_Plan_Response_GroupType',
            'Get_Resource_Plans_RequestType' => '\\StructType\\Get_Resource_Plans_RequestType',
            'Resource_PlanType' => '\\StructType\\Resource_PlanType',
            'Resource_Plan_Response_DataType' => '\\StructType\\Resource_Plan_Response_DataType',
            'Get_Resource_Plans_ResponseType' => '\\StructType\\Get_Resource_Plans_ResponseType',
            'Supplier_Contract_Line_Renewal_DataType' => '\\StructType\\Supplier_Contract_Line_Renewal_DataType',
            'Import_Catalog_Load_RequestType' => '\\StructType\\Import_Catalog_Load_RequestType',
            'Catalog_Load_Item__HV__DataType' => '\\StructType\\Catalog_Load_Item__HV__DataType',
            'Catalog_Load__HV__DataType' => '\\StructType\\Catalog_Load__HV__DataType',
            'PO_Prepaid_Amortization_Schedule_WWS_DataType' => '\\StructType\\PO_Prepaid_Amortization_Schedule_WWS_DataType',
            'Purchase_Order_Lines_For_Amortization_Schedule_DataType' => '\\StructType\\Purchase_Order_Lines_For_Amortization_Schedule_DataType',
            'PO_Prepaid_Amortization_Schedule_Outbound_DataType' => '\\StructType\\PO_Prepaid_Amortization_Schedule_Outbound_DataType',
            'Supplier_Invoice_Prepaid_Amortization_Schedule_WWS_DataType' => '\\StructType\\Supplier_Invoice_Prepaid_Amortization_Schedule_WWS_DataType',
            'Supplier_Invoice_Lines_For_Amortization_Schedule_DataType' => '\\StructType\\Supplier_Invoice_Lines_For_Amortization_Schedule_DataType',
            'Business_Process_Attachment_DataType' => '\\StructType\\Business_Process_Attachment_DataType',
            'Service_Order_Line_Replacement_DataType' => '\\StructType\\Service_Order_Line_Replacement_DataType',
            'Get_Request_for_Quote_RequestType' => '\\StructType\\Get_Request_for_Quote_RequestType',
            'Request_for_Quote_Request_ReferencesType' => '\\StructType\\Request_for_Quote_Request_ReferencesType',
            'Request_for_Quote_Request_CriteriaType' => '\\StructType\\Request_for_Quote_Request_CriteriaType',
            'Request_for_Quote_Response_GroupType' => '\\StructType\\Request_for_Quote_Response_GroupType',
            'Get_Request_for_Quote_ResponseType' => '\\StructType\\Get_Request_for_Quote_ResponseType',
            'Request_for_Quote_Response_DataType' => '\\StructType\\Request_for_Quote_Response_DataType',
            'Request_for_Quote_OutboundType' => '\\StructType\\Request_for_Quote_OutboundType',
            'Request_for_Quote_DataType' => '\\StructType\\Request_for_Quote_DataType',
            'Request_for_Quote_Line_DataType' => '\\StructType\\Request_for_Quote_Line_DataType',
            'Request_for_Quote_Line_Bid_Requirement_DataType' => '\\StructType\\Request_for_Quote_Line_Bid_Requirement_DataType',
            'Request_for_Quote_Participant_List_DataType' => '\\StructType\\Request_for_Quote_Participant_List_DataType',
            'Request_for_Quote_Bid_Requirement_DataType' => '\\StructType\\Request_for_Quote_Bid_Requirement_DataType',
            'Item_Identifier_Type_Request_ReferencesType' => '\\StructType\\Item_Identifier_Type_Request_ReferencesType',
            'Item_Identifier_Type_Request_CriteriaType' => '\\StructType\\Item_Identifier_Type_Request_CriteriaType',
            'Item_Identifier_Type_Response_GroupType' => '\\StructType\\Item_Identifier_Type_Response_GroupType',
            'Get_Item_Identifier_Types_RequestType' => '\\StructType\\Get_Item_Identifier_Types_RequestType',
            'Item_Identifier_TypeType' => '\\StructType\\Item_Identifier_TypeType',
            'Item_Identifier_Type_Response_DataType' => '\\StructType\\Item_Identifier_Type_Response_DataType',
            'Get_Item_Identifier_Types_ResponseType' => '\\StructType\\Get_Item_Identifier_Types_ResponseType',
            'Item_Identifier_Type_DataType' => '\\StructType\\Item_Identifier_Type_DataType',
            'Put_Item_Identifier_Type_RequestType' => '\\StructType\\Put_Item_Identifier_Type_RequestType',
            'Put_Item_Identifier_Type_ResponseType' => '\\StructType\\Put_Item_Identifier_Type_ResponseType',
            'Submit_Request_for_Quote_RequestType' => '\\StructType\\Submit_Request_for_Quote_RequestType',
            'Submit_Request_for_Quote_ResponseType' => '\\StructType\\Submit_Request_for_Quote_ResponseType',
            'Request_for_Quote_Line_Splits_DataType' => '\\StructType\\Request_for_Quote_Line_Splits_DataType',
            'Supplier_Contract_Service_Line_Replacement_DataType' => '\\StructType\\Supplier_Contract_Service_Line_Replacement_DataType',
            'Service_Request_Line_DataType' => '\\StructType\\Service_Request_Line_DataType',
            'Reclassify_Asset_RequestType' => '\\StructType\\Reclassify_Asset_RequestType',
            'Reclassify_Asset_DataType' => '\\StructType\\Reclassify_Asset_DataType',
            'Reclassify_Asset_ResponseType' => '\\StructType\\Reclassify_Asset_ResponseType',
            'RFQ_Response_DataType' => '\\StructType\\RFQ_Response_DataType',
            'Request_for_Quote_Response_Request_ReferencesType' => '\\StructType\\Request_for_Quote_Response_Request_ReferencesType',
            'Request_for_Quote_Response_Request_CriteriaType' => '\\StructType\\Request_for_Quote_Response_Request_CriteriaType',
            'Request_for_Quote_Response_Response_GroupType' => '\\StructType\\Request_for_Quote_Response_Response_GroupType',
            'Get_Request_for_Quote_Responses_RequestType' => '\\StructType\\Get_Request_for_Quote_Responses_RequestType',
            'Request_for_Quote_Response_OutboundType' => '\\StructType\\Request_for_Quote_Response_OutboundType',
            'Request_for_Quote_Response_Response_DataType' => '\\StructType\\Request_for_Quote_Response_Response_DataType',
            'Get_Request_for_Quote_Responses_ResponseType' => '\\StructType\\Get_Request_for_Quote_Responses_ResponseType',
            'RFQ_Response_Line_DataType' => '\\StructType\\RFQ_Response_Line_DataType',
            'RFQ_Header_or_Line_Bid_Response_DataType' => '\\StructType\\RFQ_Header_or_Line_Bid_Response_DataType',
            'Submit_Request_for_Quote_Response_RequestType' => '\\StructType\\Submit_Request_for_Quote_Response_RequestType',
            'Submit_Request_for_Quote_Response_ResponseType' => '\\StructType\\Submit_Request_for_Quote_Response_ResponseType',
            'RFQ_Response_Data_InboundType' => '\\StructType\\RFQ_Response_Data_InboundType',
            'RFQ_Response_Line_Data_InboundType' => '\\StructType\\RFQ_Response_Line_Data_InboundType',
            'RFQ_Header_Or_Line_Bid_Response_Data_InboundType' => '\\StructType\\RFQ_Header_Or_Line_Bid_Response_Data_InboundType',
            'Catalog_Load_Alternate_Item_IdentifierType' => '\\StructType\\Catalog_Load_Alternate_Item_IdentifierType',
            'Credit_Card_Header__HV__RequestType' => '\\StructType\\Credit_Card_Header__HV__RequestType',
            'Credit_Card__HV__DataType' => '\\StructType\\Credit_Card__HV__DataType',
            'Cardholder_Listing_File__HV__DataType' => '\\StructType\\Cardholder_Listing_File__HV__DataType',
            'Business_Document_Attachment_with_External_Option_DataType' => '\\StructType\\Business_Document_Attachment_with_External_Option_DataType',
            'Supplier_Connection_Response_GroupType' => '\\StructType\\Supplier_Connection_Response_GroupType',
            'Get_Remit_To_Supplier_Connections_RequestType' => '\\StructType\\Get_Remit_To_Supplier_Connections_RequestType',
            'Supplier_ConnectionType' => '\\StructType\\Supplier_ConnectionType',
            'Supplier_Connection_Response_DataType' => '\\StructType\\Supplier_Connection_Response_DataType',
            'Get_Remit_To_Supplier_Connections_ResponseType' => '\\StructType\\Get_Remit_To_Supplier_Connections_ResponseType',
            'Supplier_Connection_LineType' => '\\StructType\\Supplier_Connection_LineType',
            'Submit_Remit_To_Supplier_Connection_RequestType' => '\\StructType\\Submit_Remit_To_Supplier_Connection_RequestType',
            'Submit_Remit_To_Supplier_Connection_ResponseType' => '\\StructType\\Submit_Remit_To_Supplier_Connection_ResponseType',
            'Supplier_Connection_DataType' => '\\StructType\\Supplier_Connection_DataType',
            'Resource_Plan_Requirement_DataType' => '\\StructType\\Resource_Plan_Requirement_DataType',
            'Put_Requirements_for_Resource_Plan_RequestType' => '\\StructType\\Put_Requirements_for_Resource_Plan_RequestType',
            'Resource_Plan_Requirement_Parameter_DataType' => '\\StructType\\Resource_Plan_Requirement_Parameter_DataType',
            'Put_Requirements_for_Resource_Plan_Line_ResponseType' => '\\StructType\\Put_Requirements_for_Resource_Plan_Line_ResponseType',
            'Get_Requirements_for_Resource_Plan_RequestType' => '\\StructType\\Get_Requirements_for_Resource_Plan_RequestType',
            'Get_Requirements_for_Resource_Plan_ResponseType' => '\\StructType\\Get_Requirements_for_Resource_Plan_ResponseType',
            'Resource_Requirements_Response_DataType' => '\\StructType\\Resource_Requirements_Response_DataType',
            'Resource_Plan_Line_Requirement_DataType' => '\\StructType\\Resource_Plan_Line_Requirement_DataType',
            'Resource_Plan_for_RequirementsType' => '\\StructType\\Resource_Plan_for_RequirementsType',
            'Receipt_Service_Line_Replacement_DataType' => '\\StructType\\Receipt_Service_Line_Replacement_DataType',
            'Receipt_Service_Line_Split_DataType' => '\\StructType\\Receipt_Service_Line_Split_DataType',
            'Request_for_Quote_Award_Request_ReferencesType' => '\\StructType\\Request_for_Quote_Award_Request_ReferencesType',
            'Request_for_Quote_Award_Request_CriteriaType' => '\\StructType\\Request_for_Quote_Award_Request_CriteriaType',
            'Request_for_Quote_Award_Response_GroupType' => '\\StructType\\Request_for_Quote_Award_Response_GroupType',
            'Get_Request_for_Quote_Awards_RequestType' => '\\StructType\\Get_Request_for_Quote_Awards_RequestType',
            'Request_for_Quote_Award_OutboundType' => '\\StructType\\Request_for_Quote_Award_OutboundType',
            'Request_for_Quote_Award_Response_DataType' => '\\StructType\\Request_for_Quote_Award_Response_DataType',
            'Get_Request_for_Quote_Awards_ResponseType' => '\\StructType\\Get_Request_for_Quote_Awards_ResponseType',
            'Request_for_Quote_Award_DataType' => '\\StructType\\Request_for_Quote_Award_DataType',
            'RFQ_Award_PO_Defaults_DataType' => '\\StructType\\RFQ_Award_PO_Defaults_DataType',
            'RFQ_Award_Contract_Defaults_DataType' => '\\StructType\\RFQ_Award_Contract_Defaults_DataType',
            'Request_for_Quote_Award_Line_DataType' => '\\StructType\\Request_for_Quote_Award_Line_DataType',
            'Request_for_Quote_Award_Line_Splits_DataType' => '\\StructType\\Request_for_Quote_Award_Line_Splits_DataType',
            'Submit_Request_for_Quote_Award_RequestType' => '\\StructType\\Submit_Request_for_Quote_Award_RequestType',
            'Submit_Request_for_Quote_Award_ResponseType' => '\\StructType\\Submit_Request_for_Quote_Award_ResponseType',
            'Request_for_Quote_Award_Data_InboundType' => '\\StructType\\Request_for_Quote_Award_Data_InboundType',
            'RFQ_Award_PO_Defaults_Data_InboundType' => '\\StructType\\RFQ_Award_PO_Defaults_Data_InboundType',
            'RFQ_Award_Contract_Defaults_Data_InboundType' => '\\StructType\\RFQ_Award_Contract_Defaults_Data_InboundType',
            'Request_for_Quote_Award_Line_Data_InboundType' => '\\StructType\\Request_for_Quote_Award_Line_Data_InboundType',
            'Request_for_Quote_Award_Line_Splits_Data_InboundType' => '\\StructType\\Request_for_Quote_Award_Line_Splits_Data_InboundType',
            'Purchase_Item_Unit_of_Measure_DataType' => '\\StructType\\Purchase_Item_Unit_of_Measure_DataType',
            'Alternate_Item_Identifiers_DataType' => '\\StructType\\Alternate_Item_Identifiers_DataType',
            'Requisition_Sourcing_Rule_Request_ReferencesType' => '\\StructType\\Requisition_Sourcing_Rule_Request_ReferencesType',
            'Requisition_Sourcing_Rule_Request_CriteriaType' => '\\StructType\\Requisition_Sourcing_Rule_Request_CriteriaType',
            'Requisition_Sourcing_Rule_Response_GroupType' => '\\StructType\\Requisition_Sourcing_Rule_Response_GroupType',
            'Get_Requisition_Sourcing_Rules_RequestType' => '\\StructType\\Get_Requisition_Sourcing_Rules_RequestType',
            'Requisition_Sourcing_RuleType' => '\\StructType\\Requisition_Sourcing_RuleType',
            'Requisition_Sourcing_Rule_Response_DataType' => '\\StructType\\Requisition_Sourcing_Rule_Response_DataType',
            'Get_Requisition_Sourcing_Rules_ResponseType' => '\\StructType\\Get_Requisition_Sourcing_Rules_ResponseType',
            'Requisition_Sourcing_Rule_Supplier_DataType' => '\\StructType\\Requisition_Sourcing_Rule_Supplier_DataType',
            'Put_Requisition_Sourcing_Rule_RequestType' => '\\StructType\\Put_Requisition_Sourcing_Rule_RequestType',
            'Put_Requisition_Sourcing_Rule_ResponseType' => '\\StructType\\Put_Requisition_Sourcing_Rule_ResponseType',
            'Guest_Header__HV__RequestType' => '\\StructType\\Guest_Header__HV__RequestType',
            'Guest__HV__DataType' => '\\StructType\\Guest__HV__DataType',
            'Guest_Listing_File__HV__DataType' => '\\StructType\\Guest_Listing_File__HV__DataType',
            'Guest_Request_ReferencesType' => '\\StructType\\Guest_Request_ReferencesType',
            'Guest_Request_CriteriaType' => '\\StructType\\Guest_Request_CriteriaType',
            'Guest_Response_GroupType' => '\\StructType\\Guest_Response_GroupType',
            'Get_Guests_RequestType' => '\\StructType\\Get_Guests_RequestType',
            'Guest_WWSType' => '\\StructType\\Guest_WWSType',
            'Guest_Response_DataType' => '\\StructType\\Guest_Response_DataType',
            'Get_Guests_ResponseType' => '\\StructType\\Get_Guests_ResponseType',
            'Item_Inventory_Attributes_DataType' => '\\StructType\\Item_Inventory_Attributes_DataType',
            'Fulfillment_Attributes_DataType' => '\\StructType\\Fulfillment_Attributes_DataType',
            'Guest_Listing_File_Request_ReferencesType' => '\\StructType\\Guest_Listing_File_Request_ReferencesType',
            'Guest_Listing_File_Request_CriteriaType' => '\\StructType\\Guest_Listing_File_Request_CriteriaType',
            'Guest_Listing_File_Response_GroupType' => '\\StructType\\Guest_Listing_File_Response_GroupType',
            'Get_Guest_Listing_Files_RequestType' => '\\StructType\\Get_Guest_Listing_Files_RequestType',
            'Guest_Listing_File_WWSType' => '\\StructType\\Guest_Listing_File_WWSType',
            'Guest_Listing_File_Response_DataType' => '\\StructType\\Guest_Listing_File_Response_DataType',
            'Get_Guest_Listing_Files_ResponseType' => '\\StructType\\Get_Guest_Listing_Files_ResponseType',
            'Replenishment_Policy_DataType' => '\\StructType\\Replenishment_Policy_DataType',
            'Submit_Supplier_Contact_Information_RequestType' => '\\StructType\\Submit_Supplier_Contact_Information_RequestType',
            'Get_Supplier_Contact_Information_RequestType' => '\\StructType\\Get_Supplier_Contact_Information_RequestType',
            'Get_Supplier_Contact_Information_ResponseType' => '\\StructType\\Get_Supplier_Contact_Information_ResponseType',
            'Get_Supplier_Contact_Information_Response_DataType' => '\\StructType\\Get_Supplier_Contact_Information_Response_DataType',
            'Supplier_Contact_InformationType' => '\\StructType\\Supplier_Contact_InformationType',
            'Submit_Supplier_Contact_Information_ResponseType' => '\\StructType\\Submit_Supplier_Contact_Information_ResponseType',
            'Requisition_Sourcing_Rule_Inventory_Site_DataType' => '\\StructType\\Requisition_Sourcing_Rule_Inventory_Site_DataType',
            'Requisition_Sourcing_Rule_DataType' => '\\StructType\\Requisition_Sourcing_Rule_DataType',
            'Remit-To_Supplier_Connection_Payee_Alternate_NameType' => '\\StructType\\Remit_To_Supplier_Connection_Payee_Alternate_NameType',
            'Resource_Forecast_Request_ReferencesType' => '\\StructType\\Resource_Forecast_Request_ReferencesType',
            'Resource_Forecast_Request_CriteriaType' => '\\StructType\\Resource_Forecast_Request_CriteriaType',
            'Resource_Forecast_Response_GroupType' => '\\StructType\\Resource_Forecast_Response_GroupType',
            'Get_Resource_Forecasts_RequestType' => '\\StructType\\Get_Resource_Forecasts_RequestType',
            'Resource_ForecastType' => '\\StructType\\Resource_ForecastType',
            'Resource_Forecast_Response_DataType' => '\\StructType\\Resource_Forecast_Response_DataType',
            'Get_Resource_Forecasts_ResponseType' => '\\StructType\\Get_Resource_Forecasts_ResponseType',
            'Resource_Forecast_Line_View_Get_WebserviceType' => '\\StructType\\Resource_Forecast_Line_View_Get_WebserviceType',
            'Resource_Forecast_Line_Allocation_for_Web_ServiceType' => '\\StructType\\Resource_Forecast_Line_Allocation_for_Web_ServiceType',
            'Guest_Listing_File_DataType' => '\\StructType\\Guest_Listing_File_DataType',
            'Resource_Forecast__HV__DataType' => '\\StructType\\Resource_Forecast__HV__DataType',
            'Import_Resource_Forecast_RequestType' => '\\StructType\\Import_Resource_Forecast_RequestType',
            'Resource_Forecast_Line__HV__DataType' => '\\StructType\\Resource_Forecast_Line__HV__DataType',
            'Resource_Forecast_Line_Allocation__HV__DataType' => '\\StructType\\Resource_Forecast_Line_Allocation__HV__DataType',
            'Related_Worktags_by_Worktag_Type_DataType' => '\\StructType\\Related_Worktags_by_Worktag_Type_DataType',
            'Allowed_Worktag_DataType' => '\\StructType\\Allowed_Worktag_DataType',
            'Default_Worktag_DataType' => '\\StructType\\Default_Worktag_DataType',
            'Related_Worktag_Widget_DataType' => '\\StructType\\Related_Worktag_Widget_DataType',
            'Cash_Advance_Repayment_DataType' => '\\StructType\\Cash_Advance_Repayment_DataType',
            'Put_Cash_Advance_Repayment_RequestType' => '\\StructType\\Put_Cash_Advance_Repayment_RequestType',
            'Put_Cash_Advance_Repayment_ResponseType' => '\\StructType\\Put_Cash_Advance_Repayment_ResponseType',
            'Cash_Advance_Repayment_Request_ReferencesType' => '\\StructType\\Cash_Advance_Repayment_Request_ReferencesType',
            'Cash_Advance_Repayment_Request_CriteriaType' => '\\StructType\\Cash_Advance_Repayment_Request_CriteriaType',
            'Cash_Advance_Repayment_Response_GroupType' => '\\StructType\\Cash_Advance_Repayment_Response_GroupType',
            'Get_Cash_Advance_Repayments_RequestType' => '\\StructType\\Get_Cash_Advance_Repayments_RequestType',
            'Cash_Advance_RepaymentType' => '\\StructType\\Cash_Advance_RepaymentType',
            'Cash_Advance_Repayment_Response_DataType' => '\\StructType\\Cash_Advance_Repayment_Response_DataType',
            'Get_Cash_Advance_Repayments_ResponseType' => '\\StructType\\Get_Cash_Advance_Repayments_ResponseType',
            'Lease_Supplier_Contract_Details_DataType' => '\\StructType\\Lease_Supplier_Contract_Details_DataType',
            'Non_Effective_Dated_Web_Service_Additional_DataType' => '\\StructType\\Non_Effective_Dated_Web_Service_Additional_DataType',
            'Counting_Attributes_DataType' => '\\StructType\\Counting_Attributes_DataType',
            'Purchase_Order_Change_Order_Request_ReferencesType' => '\\StructType\\Purchase_Order_Change_Order_Request_ReferencesType',
            'Purchase_Order_Change_Order_Request_CriteriaType' => '\\StructType\\Purchase_Order_Change_Order_Request_CriteriaType',
            'Purchase_Order_Change_Order_Response_GroupType' => '\\StructType\\Purchase_Order_Change_Order_Response_GroupType',
            'Get_Purchase_Order_Change_Orders_RequestType' => '\\StructType\\Get_Purchase_Order_Change_Orders_RequestType',
            'Purchase_Order_Change_Order_OutboundType' => '\\StructType\\Purchase_Order_Change_Order_OutboundType',
            'Purchase_Order_Change_Order_Response_DataType' => '\\StructType\\Purchase_Order_Change_Order_Response_DataType',
            'Get_Purchase_Order_Change_Orders_ResponseType' => '\\StructType\\Get_Purchase_Order_Change_Orders_ResponseType',
            'Submit_Purchase_Order_Change_Order_RequestType' => '\\StructType\\Submit_Purchase_Order_Change_Order_RequestType',
            'Submit_Purchase_Order_Change_Order_ResponseType' => '\\StructType\\Submit_Purchase_Order_Change_Order_ResponseType',
            'Purchase_Order_Change_Order_WWS_DataType' => '\\StructType\\Purchase_Order_Change_Order_WWS_DataType',
            'Purchase_Order_Change_Order_Outbound_DataType' => '\\StructType\\Purchase_Order_Change_Order_Outbound_DataType',
            'Change_Order_Item_Order_Line_WWS_DataType' => '\\StructType\\Change_Order_Item_Order_Line_WWS_DataType',
            'Change_Order_Line_Split_WWS_DataType' => '\\StructType\\Change_Order_Line_Split_WWS_DataType',
            'Change_Order_Service_Order_Line_WWS_DataType' => '\\StructType\\Change_Order_Service_Order_Line_WWS_DataType',
            'Maintain_Asset_Shares_RequestType' => '\\StructType\\Maintain_Asset_Shares_RequestType',
            'Asset_Share_Replacement_DataType' => '\\StructType\\Asset_Share_Replacement_DataType',
            'Asset_Share_DataType' => '\\StructType\\Asset_Share_DataType',
            'Maintain_Asset_Shares_ResponseType' => '\\StructType\\Maintain_Asset_Shares_ResponseType',
            'Asset_Shares_Response_GroupType' => '\\StructType\\Asset_Shares_Response_GroupType',
            'Asset_Shares_Request_CriteriaType' => '\\StructType\\Asset_Shares_Request_CriteriaType',
            'Asset_Shares_Request_ReferenceType' => '\\StructType\\Asset_Shares_Request_ReferenceType',
            'Get_Asset_Shares_RequestType' => '\\StructType\\Get_Asset_Shares_RequestType',
            'Get_Asset_Shares_ResponseType' => '\\StructType\\Get_Asset_Shares_ResponseType',
            'Asset_Shares_Response_DataType' => '\\StructType\\Asset_Shares_Response_DataType',
            'Asset_SharesType' => '\\StructType\\Asset_SharesType',
            'Asset_Share_Response_DataType' => '\\StructType\\Asset_Share_Response_DataType',
            'Cancel_Request_for_Quote_Response_RequestType' => '\\StructType\\Cancel_Request_for_Quote_Response_RequestType',
            'Cancel_Request_for_Quote_Response_ResponseType' => '\\StructType\\Cancel_Request_for_Quote_Response_ResponseType',
            'Cancel_Request_for_Quote_Response_DataType' => '\\StructType\\Cancel_Request_for_Quote_Response_DataType',
            'Supplier_Invoice_Retention_Release_Line_WWS_DataType' => '\\StructType\\Supplier_Invoice_Retention_Release_Line_WWS_DataType',
            'Project_Standard_Cost_Rate_Sheet_Request_ReferencesType' => '\\StructType\\Project_Standard_Cost_Rate_Sheet_Request_ReferencesType',
            'Project_Standard_Cost_Rate_Sheet_Request_CriteriaType' => '\\StructType\\Project_Standard_Cost_Rate_Sheet_Request_CriteriaType',
            'Project_Standard_Cost_Rate_Sheet_Response_GroupType' => '\\StructType\\Project_Standard_Cost_Rate_Sheet_Response_GroupType',
            'Get_Project_Standard_Cost_Rate_Sheets_RequestType' => '\\StructType\\Get_Project_Standard_Cost_Rate_Sheets_RequestType',
            'Project_Standard_Cost_Rate_SheetType' => '\\StructType\\Project_Standard_Cost_Rate_SheetType',
            'Project_Standard_Cost_Rate_Sheet_Response_DataType' => '\\StructType\\Project_Standard_Cost_Rate_Sheet_Response_DataType',
            'Get_Project_Standard_Cost_Rate_Sheets_ResponseType' => '\\StructType\\Get_Project_Standard_Cost_Rate_Sheets_ResponseType',
            'Project_Standard_Cost_Rate_Sheet_DataType' => '\\StructType\\Project_Standard_Cost_Rate_Sheet_DataType',
            'Project_Resource_Requirement_Parameter_DataType' => '\\StructType\\Project_Resource_Requirement_Parameter_DataType',
            'Put_Project_Standard_Cost_Rate_Sheet_RequestType' => '\\StructType\\Put_Project_Standard_Cost_Rate_Sheet_RequestType',
            'Put_Project_Standard_Cost_Rate_Sheet_ResponseType' => '\\StructType\\Put_Project_Standard_Cost_Rate_Sheet_ResponseType',
            'Item_Substitute_DataType' => '\\StructType\\Item_Substitute_DataType',
            'Project_Standard_Cost_Rate_Snapshot_DetailsType' => '\\StructType\\Project_Standard_Cost_Rate_Snapshot_DetailsType',
            'Internal_Service_Delivery_Request_ReferencesType' => '\\StructType\\Internal_Service_Delivery_Request_ReferencesType',
            'Internal_Service_Delivery_Request_CriteriaType' => '\\StructType\\Internal_Service_Delivery_Request_CriteriaType',
            'Internal_Service_Delivery_Response_GroupType' => '\\StructType\\Internal_Service_Delivery_Response_GroupType',
            'Get_Internal_Service_Deliveries_RequestType' => '\\StructType\\Get_Internal_Service_Deliveries_RequestType',
            'Internal_Service_Delivery_OutboundType' => '\\StructType\\Internal_Service_Delivery_OutboundType',
            'Internal_Service_Delivery_Response_DataType' => '\\StructType\\Internal_Service_Delivery_Response_DataType',
            'Get_Internal_Service_Deliveries_ResponseType' => '\\StructType\\Get_Internal_Service_Deliveries_ResponseType',
            'Internal_Service_Delivery_Data_OutboundType' => '\\StructType\\Internal_Service_Delivery_Data_OutboundType',
            'Internal_Service_Delivery_Line_Data_OutboundType' => '\\StructType\\Internal_Service_Delivery_Line_Data_OutboundType',
            'Internal_Service_Delivery_Line_Split_Data_OutboundType' => '\\StructType\\Internal_Service_Delivery_Line_Split_Data_OutboundType',
            'Submit_Expense_Report_for_Non-Worker_RequestType' => '\\StructType\\Submit_Expense_Report_for_Non_Worker_RequestType',
            'Submit_Expense_Report_for_Non-Worker_ResponseType' => '\\StructType\\Submit_Expense_Report_for_Non_Worker_ResponseType',
            'Internal_Service_Delivery_Data_InboundType' => '\\StructType\\Internal_Service_Delivery_Data_InboundType',
            'Submit_Internal_Service_Delivery_RequestType' => '\\StructType\\Submit_Internal_Service_Delivery_RequestType',
            'Submit_Internal_Service_Delivery_ResponseType' => '\\StructType\\Submit_Internal_Service_Delivery_ResponseType',
            'Internal_Service_Delivery_Line_Data_InboundType' => '\\StructType\\Internal_Service_Delivery_Line_Data_InboundType',
            'Internal_Service_Delivery_Line_Splits_Data_InboundType' => '\\StructType\\Internal_Service_Delivery_Line_Splits_Data_InboundType',
            'Cancel_Internal_Service_Delivery_DataType' => '\\StructType\\Cancel_Internal_Service_Delivery_DataType',
            'Cancel_Internal_Service_Delivery_RequestType' => '\\StructType\\Cancel_Internal_Service_Delivery_RequestType',
            'Cancel_Internal_Service_Delivery_ResponseType' => '\\StructType\\Cancel_Internal_Service_Delivery_ResponseType',
            'Put_Item_Tag_RequestType' => '\\StructType\\Put_Item_Tag_RequestType',
            'Put_Item_Tag_ResponseType' => '\\StructType\\Put_Item_Tag_ResponseType',
            'Item_Tag_DataType' => '\\StructType\\Item_Tag_DataType',
            'Item_Tag_Request_ReferencesType' => '\\StructType\\Item_Tag_Request_ReferencesType',
            'Get_Item_Tags_RequestType' => '\\StructType\\Get_Item_Tags_RequestType',
            'Item_Tag_Response_GroupType' => '\\StructType\\Item_Tag_Response_GroupType',
            'Item_Tag_Request_CriteriaType' => '\\StructType\\Item_Tag_Request_CriteriaType',
            'Get_Item_Tags_ResponseType' => '\\StructType\\Get_Item_Tags_ResponseType',
            'Item_TagType' => '\\StructType\\Item_TagType',
            'Item_Tag_Response_DataType' => '\\StructType\\Item_Tag_Response_DataType',
            'Internal_Service_Provider_Request_ReferencesType' => '\\StructType\\Internal_Service_Provider_Request_ReferencesType',
            'Internal_Service_Provider_Request_CriteriaType' => '\\StructType\\Internal_Service_Provider_Request_CriteriaType',
            'Internal_Service_Provider_Response_GroupType' => '\\StructType\\Internal_Service_Provider_Response_GroupType',
            'Get_Internal_Service_Providers_RequestType' => '\\StructType\\Get_Internal_Service_Providers_RequestType',
            'Internal_Service_ProviderType' => '\\StructType\\Internal_Service_ProviderType',
            'Internal_Service_Provider_Response_DataType' => '\\StructType\\Internal_Service_Provider_Response_DataType',
            'Get_Internal_Service_Providers_ResponseType' => '\\StructType\\Get_Internal_Service_Providers_ResponseType',
            'Put_Internal_Service_Provider_RequestType' => '\\StructType\\Put_Internal_Service_Provider_RequestType',
            'Put_Internal_Service_Provider_ResponseType' => '\\StructType\\Put_Internal_Service_Provider_ResponseType',
            'Internal_Service_Provider_DataType' => '\\StructType\\Internal_Service_Provider_DataType',
            'Cart_Line_Extrinsic_Name_and_ValueType' => '\\StructType\\Cart_Line_Extrinsic_Name_and_ValueType',
            'Internal_Catalog_Request_ReferencesType' => '\\StructType\\Internal_Catalog_Request_ReferencesType',
            'Get_Internal_Catalogs_RequestType' => '\\StructType\\Get_Internal_Catalogs_RequestType',
            'Internal_Catalog_Request_CriteriaType' => '\\StructType\\Internal_Catalog_Request_CriteriaType',
            'Internal_Catalog_Response_GroupType' => '\\StructType\\Internal_Catalog_Response_GroupType',
            'Get_Internal_Catalogs_ResponseType' => '\\StructType\\Get_Internal_Catalogs_ResponseType',
            'Internal_Catalog_Response_DataType' => '\\StructType\\Internal_Catalog_Response_DataType',
            'Internal_CatalogType' => '\\StructType\\Internal_CatalogType',
            'Internal_Catalog_DataType' => '\\StructType\\Internal_Catalog_DataType',
            'Put_Internal_Catalog_RequestType' => '\\StructType\\Put_Internal_Catalog_RequestType',
            'Put_Internal_Catalog_ResponseType' => '\\StructType\\Put_Internal_Catalog_ResponseType',
            'Catalog_Item_for_Internal_Catalog_DataType' => '\\StructType\\Catalog_Item_for_Internal_Catalog_DataType',
            'Get_Credit_Card_Code_Mappings_RequestType' => '\\StructType\\Get_Credit_Card_Code_Mappings_RequestType',
            'Credit_Card_Code_MappingType' => '\\StructType\\Credit_Card_Code_MappingType',
            'Credit_Card_Code_Mapping_Response_DataType' => '\\StructType\\Credit_Card_Code_Mapping_Response_DataType',
            'Get_Credit_Card_Code_Mappings_ResponseType' => '\\StructType\\Get_Credit_Card_Code_Mappings_ResponseType',
            'Put_Credit_Card_Code_Mapping_RequestType' => '\\StructType\\Put_Credit_Card_Code_Mapping_RequestType',
            'Put_Credit_Card_Code_Mapping_ResponseType' => '\\StructType\\Put_Credit_Card_Code_Mapping_ResponseType',
            'Withholding_Tax_Code_Application_DataType' => '\\StructType\\Withholding_Tax_Code_Application_DataType',
            'Item_Receipt_Line_Replacement_Lot_DataType' => '\\StructType\\Item_Receipt_Line_Replacement_Lot_DataType',
            'Supplier_Invoice_Request_Request_ReferencesType' => '\\StructType\\Supplier_Invoice_Request_Request_ReferencesType',
            'Get_Supplier_Invoice_Requests_RequestType' => '\\StructType\\Get_Supplier_Invoice_Requests_RequestType',
            'Supplier_Invoice_Request_Response_GroupType' => '\\StructType\\Supplier_Invoice_Request_Response_GroupType',
            'Supplier_Invoice_Request_Request_CriteriaType' => '\\StructType\\Supplier_Invoice_Request_Request_CriteriaType',
            'Get_Supplier_Invoice_Requests_ResponseType' => '\\StructType\\Get_Supplier_Invoice_Requests_ResponseType',
            'Supplier_Invoice_Request_Response_DataType' => '\\StructType\\Supplier_Invoice_Request_Response_DataType',
            'Supplier_Invoice_Request_OutboundType' => '\\StructType\\Supplier_Invoice_Request_OutboundType',
            'Supplier_Invoice_Request_Data_OutboundType' => '\\StructType\\Supplier_Invoice_Request_Data_OutboundType',
            'Supplier_Invoice_Request_Line_Data_OutboundType' => '\\StructType\\Supplier_Invoice_Request_Line_Data_OutboundType',
            'Supplier_Invoice_Request_Line_Split_Data_OutboundType' => '\\StructType\\Supplier_Invoice_Request_Line_Split_Data_OutboundType',
            'Alternate_Item_Identifier_for_PO_issue_DataType' => '\\StructType\\Alternate_Item_Identifier_for_PO_issue_DataType',
            'Supplier_Invoice_Request_Data_InboundType' => '\\StructType\\Supplier_Invoice_Request_Data_InboundType',
            'Submit_Supplier_Invoice_Request_RequestType' => '\\StructType\\Submit_Supplier_Invoice_Request_RequestType',
            'Submit_Supplier_Invoice_Request_ResponseType' => '\\StructType\\Submit_Supplier_Invoice_Request_ResponseType',
            'Supplier_Invoice_Request_Line_Data_InboundType' => '\\StructType\\Supplier_Invoice_Request_Line_Data_InboundType',
            'Supplier_Invoice_Request_Line_Splits_Data_InboundType' => '\\StructType\\Supplier_Invoice_Request_Line_Splits_Data_InboundType',
            'Requisition_Sourcing_Rule_Buyer_DataType' => '\\StructType\\Requisition_Sourcing_Rule_Buyer_DataType',
            'Bill_To_Contact_Info_for_Issue_Purchase_Order_Outbound_Sub_ViewType' => '\\StructType\\Bill_To_Contact_Info_for_Issue_Purchase_Order_Outbound_Sub_ViewType',
            'Ship_To_Contact_Info_for_Issue_Purchase_Order_Outbound_Sub_ViewType' => '\\StructType\\Ship_To_Contact_Info_for_Issue_Purchase_Order_Outbound_Sub_ViewType',
            'Put_Procurement_Document_Attachment_RequestType' => '\\StructType\\Put_Procurement_Document_Attachment_RequestType',
            'Put_Procurement_Document_Attachment_ResponseType' => '\\StructType\\Put_Procurement_Document_Attachment_ResponseType',
            'Business_Asset_In_Service_Date_Update_DataType' => '\\StructType\\Business_Asset_In_Service_Date_Update_DataType',
            'Adjust_Asset_In_Service_Date_ResponseType' => '\\StructType\\Adjust_Asset_In_Service_Date_ResponseType',
            'Adjust_Asset_In_Service_Date_RequestType' => '\\StructType\\Adjust_Asset_In_Service_Date_RequestType',
            'Supplier_Reference_for_Issue_Purchase_Order_Outbound_Sub_ViewType' => '\\StructType\\Supplier_Reference_for_Issue_Purchase_Order_Outbound_Sub_ViewType',
            'Unique_Name_Info_for_Issue_Purchase_Order_Outbound_Sub_ViewType' => '\\StructType\\Unique_Name_Info_for_Issue_Purchase_Order_Outbound_Sub_ViewType',
            'Business_Document_Attachments_for_PO_IssueType' => '\\StructType\\Business_Document_Attachments_for_PO_IssueType',
            'Resource_Plan_Template_Request_ReferencesType' => '\\StructType\\Resource_Plan_Template_Request_ReferencesType',
            'Resource_Plan_Template_Request_CriteriaType' => '\\StructType\\Resource_Plan_Template_Request_CriteriaType',
            'Resource_Plan_Template_Response_GroupType' => '\\StructType\\Resource_Plan_Template_Response_GroupType',
            'Get_Resource_Plan_Templates_RequestType' => '\\StructType\\Get_Resource_Plan_Templates_RequestType',
            'Resource_Plan_TemplateType' => '\\StructType\\Resource_Plan_TemplateType',
            'Resource_Plan_Template_Response_DataType' => '\\StructType\\Resource_Plan_Template_Response_DataType',
            'Get_Resource_Plan_Templates_ResponseType' => '\\StructType\\Get_Resource_Plan_Templates_ResponseType',
            'Resource_Plan_Template_DataType' => '\\StructType\\Resource_Plan_Template_DataType',
            'Submit_Advanced_Ship_Notice_RequestType' => '\\StructType\\Submit_Advanced_Ship_Notice_RequestType',
            'Submit_Advanced_Ship_Notice_ResponseType' => '\\StructType\\Submit_Advanced_Ship_Notice_ResponseType',
            'Advanced_Ship_Notice_Data_InboundType' => '\\StructType\\Advanced_Ship_Notice_Data_InboundType',
            'Advanced_Ship_Notice_Line_Data_InboundType' => '\\StructType\\Advanced_Ship_Notice_Line_Data_InboundType',
            'Resource_Forecast_Configuration_DataType' => '\\StructType\\Resource_Forecast_Configuration_DataType',
            'Resource_Forecast_Configuration_Get_Webservice_DataType' => '\\StructType\\Resource_Forecast_Configuration_Get_Webservice_DataType',
            'Resource_Plan_Detail_for_Template_DataType' => '\\StructType\\Resource_Plan_Detail_for_Template_DataType',
            'Get_Advanced_Ship_Notices_RequestType' => '\\StructType\\Get_Advanced_Ship_Notices_RequestType',
            'Get_Advanced_Ship_Notices_ResponseType' => '\\StructType\\Get_Advanced_Ship_Notices_ResponseType',
            'Advanced_Ship_Notice_Request_ReferencesType' => '\\StructType\\Advanced_Ship_Notice_Request_ReferencesType',
            'Advanced_Ship_Notice_Request_CriteriaType' => '\\StructType\\Advanced_Ship_Notice_Request_CriteriaType',
            'Advanced_Ship_Notice_Response_GroupType' => '\\StructType\\Advanced_Ship_Notice_Response_GroupType',
            'Advanced_Ship_Notice_Response_DataType' => '\\StructType\\Advanced_Ship_Notice_Response_DataType',
            'Advanced_Ship_Notice_OutboundType' => '\\StructType\\Advanced_Ship_Notice_OutboundType',
            'Advanced_Ship_Notice_Data_OutboundType' => '\\StructType\\Advanced_Ship_Notice_Data_OutboundType',
            'Advanced_Ship_Notice_Line_Data_OutboundType' => '\\StructType\\Advanced_Ship_Notice_Line_Data_OutboundType',
            'Purchase_Order_Acknowledgement_DataType' => '\\StructType\\Purchase_Order_Acknowledgement_DataType',
            'Submit_Purchase_Order_Acknowledgement_RequestType' => '\\StructType\\Submit_Purchase_Order_Acknowledgement_RequestType',
            'Submit_Purchase_Order_Acknowledgement_ResponseType' => '\\StructType\\Submit_Purchase_Order_Acknowledgement_ResponseType',
            'Line_Alternate_Item_Attribute_Value_Data_InboundType' => '\\StructType\\Line_Alternate_Item_Attribute_Value_Data_InboundType',
            'ASN_Line_Lot_Information_Data_InboundType' => '\\StructType\\ASN_Line_Lot_Information_Data_InboundType',
            'Line_Alternate_Item_Attribute_Value_Data_OutboundType' => '\\StructType\\Line_Alternate_Item_Attribute_Value_Data_OutboundType',
            'ASN_Line_Lot_Information_Data_OutboundType' => '\\StructType\\ASN_Line_Lot_Information_Data_OutboundType',
            'Cancel_Advanced_Ship_Notice_DataType' => '\\StructType\\Cancel_Advanced_Ship_Notice_DataType',
            'Cancel_Advanced_Ship_Notice_RequestType' => '\\StructType\\Cancel_Advanced_Ship_Notice_RequestType',
            'Cancel_Advanced_Ship_Notice_ResponseType' => '\\StructType\\Cancel_Advanced_Ship_Notice_ResponseType',
            'Expense_Rate_Table_Header__HV__RequestType' => '\\StructType\\Expense_Rate_Table_Header__HV__RequestType',
            'Expense_Rate_Table__HV__DataType' => '\\StructType\\Expense_Rate_Table__HV__DataType',
            'Expense_Rate_Table_Line__HV__DataType' => '\\StructType\\Expense_Rate_Table_Line__HV__DataType',
            'Graduated_Expense_Rate__HV__DataType' => '\\StructType\\Graduated_Expense_Rate__HV__DataType',
            'Worker_Travel_Profile_Header__HV__RequestType' => '\\StructType\\Worker_Travel_Profile_Header__HV__RequestType',
            'Travel__Profile__HV__DataType' => '\\StructType\\Travel__Profile__HV__DataType',
            'Worker_Travel_Profile_Listing_File__HV__DataType' => '\\StructType\\Worker_Travel_Profile_Listing_File__HV__DataType',
            'Worker_Travel_Profile_Listing_File_Request_ReferencesType' => '\\StructType\\Worker_Travel_Profile_Listing_File_Request_ReferencesType',
            'Worker_Travel_Profile_Listing_File_Request_CriteriaType' => '\\StructType\\Worker_Travel_Profile_Listing_File_Request_CriteriaType',
            'Worker_Travel_Profile_Listing_File_Response_GroupType' => '\\StructType\\Worker_Travel_Profile_Listing_File_Response_GroupType',
            'Get_Worker_Travel_Profile_Listing_Files_RequestType' => '\\StructType\\Get_Worker_Travel_Profile_Listing_Files_RequestType',
            'Worker_Travel_Profile_Listing_File_Response_DataType' => '\\StructType\\Worker_Travel_Profile_Listing_File_Response_DataType',
            'Get_Worker_Travel_Profile_Listing_Files_ResponseType' => '\\StructType\\Get_Worker_Travel_Profile_Listing_Files_ResponseType',
            'Worker_Travel_Profile_Listing_File_WWSType' => '\\StructType\\Worker_Travel_Profile_Listing_File_WWSType',
            'Worker_Travel_Profile_WWSType' => '\\StructType\\Worker_Travel_Profile_WWSType',
            'Worker_Travel_Profile_Listing_FileType' => '\\StructType\\Worker_Travel_Profile_Listing_FileType',
            'Purchase_Order_Acknowledgement_Request_ReferencesType' => '\\StructType\\Purchase_Order_Acknowledgement_Request_ReferencesType',
            'Purchase_Order_Acknowledgement_Request_CriteriaType' => '\\StructType\\Purchase_Order_Acknowledgement_Request_CriteriaType',
            'Purchase_Order_Acknowledgement_Response_GroupType' => '\\StructType\\Purchase_Order_Acknowledgement_Response_GroupType',
            'Get_Purchase_Order_Acknowledgements_RequestType' => '\\StructType\\Get_Purchase_Order_Acknowledgements_RequestType',
            'Purchase_Order_Acknowledgement_OutboundType' => '\\StructType\\Purchase_Order_Acknowledgement_OutboundType',
            'Purchase_Order_Acknowledgement_Response_DataType' => '\\StructType\\Purchase_Order_Acknowledgement_Response_DataType',
            'Get_Purchase_Order_Acknowledgements_ResponseType' => '\\StructType\\Get_Purchase_Order_Acknowledgements_ResponseType',
            'PO_Acknowledgement_Line_DataType' => '\\StructType\\PO_Acknowledgement_Line_DataType',
            'Location_Customer_Account_Number_Detail_Request_ReferencesType' => '\\StructType\\Location_Customer_Account_Number_Detail_Request_ReferencesType',
            'Location_Customer_Account_Number_Detail_Request_CriteriaType' => '\\StructType\\Location_Customer_Account_Number_Detail_Request_CriteriaType',
            'Location_Customer_Account_Number_Detail_Response_GroupType' => '\\StructType\\Location_Customer_Account_Number_Detail_Response_GroupType',
            'Get_Location_Customer_Account_Number_Details_RequestType' => '\\StructType\\Get_Location_Customer_Account_Number_Details_RequestType',
            'Location_Customer_Account_Number_DetailType' => '\\StructType\\Location_Customer_Account_Number_DetailType',
            'Location_Customer_Account_Number_Detail_Response_DataType' => '\\StructType\\Location_Customer_Account_Number_Detail_Response_DataType',
            'Get_Location_Customer_Account_Number_Details_ResponseType' => '\\StructType\\Get_Location_Customer_Account_Number_Details_ResponseType',
            'Location_Customer_Account_Number_Detail_DataType' => '\\StructType\\Location_Customer_Account_Number_Detail_DataType',
            'Put_Location_Customer_Account_Number_Detail_RequestType' => '\\StructType\\Put_Location_Customer_Account_Number_Detail_RequestType',
            'Put_Location_Customer_Account_Number_Detail_ResponseType' => '\\StructType\\Put_Location_Customer_Account_Number_Detail_ResponseType',
            'Asset_Useful_Life_for_Reclassify_DataType' => '\\StructType\\Asset_Useful_Life_for_Reclassify_DataType',
            'Expense_Item_Accumulator_Balance_DataType' => '\\StructType\\Expense_Item_Accumulator_Balance_DataType',
            'Contact_Information_Wrapper_DataType' => '\\StructType\\Contact_Information_Wrapper_DataType',
            'Project_Role_Category_Request_ReferencesType' => '\\StructType\\Project_Role_Category_Request_ReferencesType',
            'Project_Role_Category_Request_CriteriaType' => '\\StructType\\Project_Role_Category_Request_CriteriaType',
            'Project_Role_Category_Response_GroupType' => '\\StructType\\Project_Role_Category_Response_GroupType',
            'Get_Project_Role_Categories_RequestType' => '\\StructType\\Get_Project_Role_Categories_RequestType',
            'Project_Role_CategoryType' => '\\StructType\\Project_Role_CategoryType',
            'Project_Role_Category_Response_DataType' => '\\StructType\\Project_Role_Category_Response_DataType',
            'Get_Project_Role_Categories_ResponseType' => '\\StructType\\Get_Project_Role_Categories_ResponseType',
            'Project_Role_Category_DataType' => '\\StructType\\Project_Role_Category_DataType',
            'Put_Project_Role_Category_RequestType' => '\\StructType\\Put_Project_Role_Category_RequestType',
            'Put_Project_Role_Category_ResponseType' => '\\StructType\\Put_Project_Role_Category_ResponseType',
            'Put_Supplier_Classification_RequestType' => '\\StructType\\Put_Supplier_Classification_RequestType',
            'Supplier_Classification_DataType' => '\\StructType\\Supplier_Classification_DataType',
            'Supplier_Classification_Field_Replacement_DataType' => '\\StructType\\Supplier_Classification_Field_Replacement_DataType',
            'Put_Supplier_Classification_ResponseType' => '\\StructType\\Put_Supplier_Classification_ResponseType',
            'Supplier_Classification_Request_ReferencesType' => '\\StructType\\Supplier_Classification_Request_ReferencesType',
            'Supplier_Classification_Response_GroupType' => '\\StructType\\Supplier_Classification_Response_GroupType',
            'Get_Supplier_Classifications_RequestType' => '\\StructType\\Get_Supplier_Classifications_RequestType',
            'Supplier_ClassificationType' => '\\StructType\\Supplier_ClassificationType',
            'Supplier_Classification_Response_DataType' => '\\StructType\\Supplier_Classification_Response_DataType',
            'Get_Supplier_Classifications_ResponseType' => '\\StructType\\Get_Supplier_Classifications_ResponseType',
            'Ticket_Details_DataType' => '\\StructType\\Ticket_Details_DataType',
            'Trip_Leg_Details_DataType' => '\\StructType\\Trip_Leg_Details_DataType',
            'Trip_Leg_Details_Name_Match_DataType' => '\\StructType\\Trip_Leg_Details_Name_Match_DataType',
            'Supplier_Classification_Field_Choice_Replacement_DataType' => '\\StructType\\Supplier_Classification_Field_Choice_Replacement_DataType',
            'Get_Invoice_Types_RequestType' => '\\StructType\\Get_Invoice_Types_RequestType',
            'Invoice_Type_Response_GroupType' => '\\StructType\\Invoice_Type_Response_GroupType',
            'Invoice_Type_Request_CriteriaType' => '\\StructType\\Invoice_Type_Request_CriteriaType',
            'Invoice_Type_Request_ReferencesType' => '\\StructType\\Invoice_Type_Request_ReferencesType',
            'Get_Invoice_Types_ResponseType' => '\\StructType\\Get_Invoice_Types_ResponseType',
            'Invoice_Type_Response_DataType' => '\\StructType\\Invoice_Type_Response_DataType',
            'Invoice_TypeType' => '\\StructType\\Invoice_TypeType',
            'Invoice_Type_DataType' => '\\StructType\\Invoice_Type_DataType',
            'Purchase_Order_Service_Lines_DataType' => '\\StructType\\Purchase_Order_Service_Lines_DataType',
            'Put_Invoice_Types_RequestType' => '\\StructType\\Put_Invoice_Types_RequestType',
            'Put_Invoice_Types_ResponseType' => '\\StructType\\Put_Invoice_Types_ResponseType',
            'Priority_Ranked_Supplier_Item_DataType' => '\\StructType\\Priority_Ranked_Supplier_Item_DataType',
            'Primary_Image_DataType' => '\\StructType\\Primary_Image_DataType',
            'Additional_Image_DataType' => '\\StructType\\Additional_Image_DataType',
            'Supplier_Classification_Field_Interface_DataType' => '\\StructType\\Supplier_Classification_Field_Interface_DataType',
            'Cancel_Purchase_Order_Acknowledgement_RequestType' => '\\StructType\\Cancel_Purchase_Order_Acknowledgement_RequestType',
            'Cancel_Purchase_Order_Acknowledgement_ResponseType' => '\\StructType\\Cancel_Purchase_Order_Acknowledgement_ResponseType',
            'Tax_Rate_Options_DataType' => '\\StructType\\Tax_Rate_Options_DataType',
            'ASN_Item_Serial__Data_OutboundType' => '\\StructType\\ASN_Item_Serial__Data_OutboundType',
            'ASN_Item_Serial_Data_InboundType' => '\\StructType\\ASN_Item_Serial_Data_InboundType',
            'Item_Receipt_Line_Replacement_Serial_DataType' => '\\StructType\\Item_Receipt_Line_Replacement_Serial_DataType',
            'Default_PO_Issue_Email_DataType' => '\\StructType\\Default_PO_Issue_Email_DataType',
            'Default_PO_Issue_Email_Replacement_DataType' => '\\StructType\\Default_PO_Issue_Email_Replacement_DataType',
            'Put_Supplier_Contract_Document_Link_RequestType' => '\\StructType\\Put_Supplier_Contract_Document_Link_RequestType',
            'Put_Supplier_Contract_Document_Link_ResponseType' => '\\StructType\\Put_Supplier_Contract_Document_Link_ResponseType',
            'Catalog_Load_Item_Unit_of_Measure_DataType' => '\\StructType\\Catalog_Load_Item_Unit_of_Measure_DataType',
            'Unnamed_Resource_WWS_DataType' => '\\StructType\\Unnamed_Resource_WWS_DataType',
            'Submit_Mass_Reopen_Procurement_Documents_ResponseType' => '\\StructType\\Submit_Mass_Reopen_Procurement_Documents_ResponseType',
            'Mass_Reopen_Procurement_Documents_Line_DataType' => '\\StructType\\Mass_Reopen_Procurement_Documents_Line_DataType',
            'Submit_Mass_Reopen_Procurement_Documents_RequestType' => '\\StructType\\Submit_Mass_Reopen_Procurement_Documents_RequestType',
            'Mass_Reopen_Procurement_Documents_DataType' => '\\StructType\\Mass_Reopen_Procurement_Documents_DataType',
            'Lease_Payment_Line_Replacement_DataType' => '\\StructType\\Lease_Payment_Line_Replacement_DataType',
            'Put_Resource_Pool_Hierarchy_RequestType' => '\\StructType\\Put_Resource_Pool_Hierarchy_RequestType',
            'Resource_Pool_Hierarchy_Response_GroupType' => '\\StructType\\Resource_Pool_Hierarchy_Response_GroupType',
            'Get_Resource_Pool_Hierarchies_RequestType' => '\\StructType\\Get_Resource_Pool_Hierarchies_RequestType',
            'Put_Resource_Pool_Hierarchy_ResponseType' => '\\StructType\\Put_Resource_Pool_Hierarchy_ResponseType',
            'Resource_Pool_Hierarchy_Request_ReferencesType' => '\\StructType\\Resource_Pool_Hierarchy_Request_ReferencesType',
            'Resource_Pool_Hierarchy_Response_DataType' => '\\StructType\\Resource_Pool_Hierarchy_Response_DataType',
            'Resource_Pool_Hierarchy_DataType' => '\\StructType\\Resource_Pool_Hierarchy_DataType',
            'Resource_Pool_Hierarchy_Request_CriteriaType' => '\\StructType\\Resource_Pool_Hierarchy_Request_CriteriaType',
            'Resource_Pool_HierarchyType' => '\\StructType\\Resource_Pool_HierarchyType',
            'Get_Resource_Pool_Hierarchies_ResponseType' => '\\StructType\\Get_Resource_Pool_Hierarchies_ResponseType',
            'Put_Resource_Pool_RequestType' => '\\StructType\\Put_Resource_Pool_RequestType',
            'Resource_Pool_Response_GroupType' => '\\StructType\\Resource_Pool_Response_GroupType',
            'Resource_PoolType' => '\\StructType\\Resource_PoolType',
            'Resource_Pool_Request_ReferencesType' => '\\StructType\\Resource_Pool_Request_ReferencesType',
            'Resource_Pool_DataType' => '\\StructType\\Resource_Pool_DataType',
            'Resource_Pool_Request_CriteriaType' => '\\StructType\\Resource_Pool_Request_CriteriaType',
            'Resource_Pool_Response_DataType' => '\\StructType\\Resource_Pool_Response_DataType',
            'Put_Resource_Pool_ResponseType' => '\\StructType\\Put_Resource_Pool_ResponseType',
            'Get_Resource_Pools_RequestType' => '\\StructType\\Get_Resource_Pools_RequestType',
            'Get_Resource_Pools_ResponseType' => '\\StructType\\Get_Resource_Pools_ResponseType',
            'Get_Resource_Pool_Hierarchies_without_Dependencies_ResponseType' => '\\StructType\\Get_Resource_Pool_Hierarchies_without_Dependencies_ResponseType',
            'Get_Resource_Pool_Hierarchies_without_Dependencies_RequestType' => '\\StructType\\Get_Resource_Pool_Hierarchies_without_Dependencies_RequestType',
            'Put_Requisition_Additional_Data_RequestType' => '\\StructType\\Put_Requisition_Additional_Data_RequestType',
            'Get_Requisition_Line_Additional_Data_RequestType' => '\\StructType\\Get_Requisition_Line_Additional_Data_RequestType',
            'Put_Requisition_Line_Additional_Data_ResponseType' => '\\StructType\\Put_Requisition_Line_Additional_Data_ResponseType',
            'Requisition_Line_Response_GroupType' => '\\StructType\\Requisition_Line_Response_GroupType',
            'Get_Requisition_Additional_Data_ResponseType' => '\\StructType\\Get_Requisition_Additional_Data_ResponseType',
            'Get_Requisition_Line_Additional_Data_Response_DataType' => '\\StructType\\Get_Requisition_Line_Additional_Data_Response_DataType',
            'Requisition_Additional_DataType' => '\\StructType\\Requisition_Additional_DataType',
            'Put_Requisition_Line_Additional_Data_RequestType' => '\\StructType\\Put_Requisition_Line_Additional_Data_RequestType',
            'Put_Requisition_Additional_Data_ResponseType' => '\\StructType\\Put_Requisition_Additional_Data_ResponseType',
            'Requisition_Line_Request_CriteriaType' => '\\StructType\\Requisition_Line_Request_CriteriaType',
            'Get_Requisition_Additional_Data_RequestType' => '\\StructType\\Get_Requisition_Additional_Data_RequestType',
            'Get_Requisition_Line_Additional_Data_ResponseType' => '\\StructType\\Get_Requisition_Line_Additional_Data_ResponseType',
            'Requisition_Line_Additional_DataType' => '\\StructType\\Requisition_Line_Additional_DataType',
            'Get_Requisition_Additional_Data_Response_DataType' => '\\StructType\\Get_Requisition_Additional_Data_Response_DataType',
            'Requisition_Line_Request_ReferencesType' => '\\StructType\\Requisition_Line_Request_ReferencesType',
            'Cancel_Procurement_Card_Transaction_Verification_ResponseType' => '\\StructType\\Cancel_Procurement_Card_Transaction_Verification_ResponseType',
            'Cancel_Procurement_Card_Transaction_Verification_RequestType' => '\\StructType\\Cancel_Procurement_Card_Transaction_Verification_RequestType',
            'Put_Company_Asset_Book_Restrictions_ResponseType' => '\\StructType\\Put_Company_Asset_Book_Restrictions_ResponseType',
            'Company_Asset_Book_Restriction_Data_ResponseType' => '\\StructType\\Company_Asset_Book_Restriction_Data_ResponseType',
            'Put_Company_Asset_Book_Restrictions_RequestType' => '\\StructType\\Put_Company_Asset_Book_Restrictions_RequestType',
            'Company_Asset_Book_Restrictions_DataType' => '\\StructType\\Company_Asset_Book_Restrictions_DataType',
            'Company_Asset_Book_Restriction_Replacement_DataType' => '\\StructType\\Company_Asset_Book_Restriction_Replacement_DataType',
            'Tax_Widget_DataType' => '\\StructType\\Tax_Widget_DataType',
            'Company_Asset_Book_Restriction_Response_GroupType' => '\\StructType\\Company_Asset_Book_Restriction_Response_GroupType',
            'Company_Asset_Book_Restriction_Request_ReferencesType' => '\\StructType\\Company_Asset_Book_Restriction_Request_ReferencesType',
            'Get_Company_Asset_Book_Restrictions_ResponseType' => '\\StructType\\Get_Company_Asset_Book_Restrictions_ResponseType',
            'Company_Asset_Book_RestrictionType' => '\\StructType\\Company_Asset_Book_RestrictionType',
            'Get_Company_Asset_Book_Restrictions_RequestType' => '\\StructType\\Get_Company_Asset_Book_Restrictions_RequestType',
            'Company_Asset_Book_Restriction_Response_DataType' => '\\StructType\\Company_Asset_Book_Restriction_Response_DataType',
            'Company_Asset_Book_Restriction_Request_CriteriaType' => '\\StructType\\Company_Asset_Book_Restriction_Request_CriteriaType',
            'Transfer_Pricing_Rate_Sheet_Snapshot_DataType' => '\\StructType\\Transfer_Pricing_Rate_Sheet_Snapshot_DataType',
            'Get_Transfer_Pricing_Rate_Sheets_RequestType' => '\\StructType\\Get_Transfer_Pricing_Rate_Sheets_RequestType',
            'Transfer_Pricing_Rate_Sheet_Request_CriteriaType' => '\\StructType\\Transfer_Pricing_Rate_Sheet_Request_CriteriaType',
            'Transfer_Pricing_Rate_Sheet_Response_DataType' => '\\StructType\\Transfer_Pricing_Rate_Sheet_Response_DataType',
            'Transfer_Pricing_Rate_SheetType' => '\\StructType\\Transfer_Pricing_Rate_SheetType',
            'Transfer_Pricing_Rate_Sheet_Request_ReferencesType' => '\\StructType\\Transfer_Pricing_Rate_Sheet_Request_ReferencesType',
            'Transfer_Pricing_Rate_Sheet_DataType' => '\\StructType\\Transfer_Pricing_Rate_Sheet_DataType',
            'Get_Transfer_Pricing_Rate_Sheets_ResponseType' => '\\StructType\\Get_Transfer_Pricing_Rate_Sheets_ResponseType',
            'Transfer_Pricing_Rate_Sheet_Response_GroupType' => '\\StructType\\Transfer_Pricing_Rate_Sheet_Response_GroupType',
            'Transfer_Pricing_Rate_Sheet_Detail_DataType' => '\\StructType\\Transfer_Pricing_Rate_Sheet_Detail_DataType',
            'Put_Transfer_Pricing_Rate_Sheet_ResponseType' => '\\StructType\\Put_Transfer_Pricing_Rate_Sheet_ResponseType',
            'Put_Transfer_Pricing_Rate_Sheet_RequestType' => '\\StructType\\Put_Transfer_Pricing_Rate_Sheet_RequestType',
            'Order-From_Supplier_Connection_Default_PO_Issue_Email_ReferenceType' => '\\StructType\\Order_From_Supplier_Connection_Default_PO_Issue_Email_ReferenceType',
            'Order_From_Supplier_ConnectionType' => '\\StructType\\Order_From_Supplier_ConnectionType',
            'Get_Order_From_Supplier_Connections_RequestType' => '\\StructType\\Get_Order_From_Supplier_Connections_RequestType',
            'Order_From_Supplier_Connection_Line_DataType' => '\\StructType\\Order_From_Supplier_Connection_Line_DataType',
            'Get_Order_From_Supplier_Connections_ResponseType' => '\\StructType\\Get_Order_From_Supplier_Connections_ResponseType',
            'Submit_Order_From_Supplier_Connection_RequestType' => '\\StructType\\Submit_Order_From_Supplier_Connection_RequestType',
            'Submit_Order_From_Supplier_Connection_ResponseType' => '\\StructType\\Submit_Order_From_Supplier_Connection_ResponseType',
            'Order_From_Supplier_Connection_Response_DataType' => '\\StructType\\Order_From_Supplier_Connection_Response_DataType',
            'Order_From_Supplier_Connection_DataType' => '\\StructType\\Order_From_Supplier_Connection_DataType',
            'Expense_Credit_Card_Transaction_Assignee_DataType' => '\\StructType\\Expense_Credit_Card_Transaction_Assignee_DataType',
            'Reassign_Expense_Credit_Card_Transaction_ResponseType' => '\\StructType\\Reassign_Expense_Credit_Card_Transaction_ResponseType',
            'Reassign_Expense_Credit_Card_Transaction_RequestType' => '\\StructType\\Reassign_Expense_Credit_Card_Transaction_RequestType',
            'Procedure_Information_DataType' => '\\StructType\\Procedure_Information_DataType',
            'Lot_Serial_Information_DataType' => '\\StructType\\Lot_Serial_Information_DataType',
            'Order-From_Connection_Alternate_Name_DataType' => '\\StructType\\Order_From_Connection_Alternate_Name_DataType',
            'Requisition_Sourcing_Rule_Order_Connection_DataType' => '\\StructType\\Requisition_Sourcing_Rule_Order_Connection_DataType',
            'Street_Line_DataType' => '\\StructType\\Street_Line_DataType',
            'Supplier_Item_Price_Update_Unit_of_Measure_DataType' => '\\StructType\\Supplier_Item_Price_Update_Unit_of_Measure_DataType',
            'Supplier_Item_Price_Update__HV__DataType' => '\\StructType\\Supplier_Item_Price_Update__HV__DataType',
            'Supplier_Item_Price_Update_RequestType' => '\\StructType\\Supplier_Item_Price_Update_RequestType',
            'Put_Revenue_Center_ResponseType' => '\\StructType\\Put_Revenue_Center_ResponseType',
            'Revenue_Center_DataType' => '\\StructType\\Revenue_Center_DataType',
            'Put_Revenue_Center_RequestType' => '\\StructType\\Put_Revenue_Center_RequestType',
            'Assign_Expense_Central_Travel_Card_Transaction_RequestType' => '\\StructType\\Assign_Expense_Central_Travel_Card_Transaction_RequestType',
            'Assign_Expense_Central_Travel_Card_Transaction_ResponseType' => '\\StructType\\Assign_Expense_Central_Travel_Card_Transaction_ResponseType',
            'Expense_Central_Travel_Card_Transaction_DataType' => '\\StructType\\Expense_Central_Travel_Card_Transaction_DataType',
            'Project_Worker_Rate_Standard_Cost_Rate_DetailsType' => '\\StructType\\Project_Worker_Rate_Standard_Cost_Rate_DetailsType',
            'Project_Cost_Rate_Rule_Standard_Cost_Rate_DetailsType' => '\\StructType\\Project_Cost_Rate_Rule_Standard_Cost_Rate_DetailsType',
            'Project_Role_Standard_Cost_Rate_DetailsType' => '\\StructType\\Project_Role_Standard_Cost_Rate_DetailsType',
            'Change_Depreciation_Accounting_Status_ResponseType' => '\\StructType\\Change_Depreciation_Accounting_Status_ResponseType',
            'Override_Depreciation_Period_Status_DataType' => '\\StructType\\Override_Depreciation_Period_Status_DataType',
            'Override_Depreciation_Period_Status_Data_ResponseType' => '\\StructType\\Override_Depreciation_Period_Status_Data_ResponseType',
            'Change_Depreciation_Accounting_Status_RequestType' => '\\StructType\\Change_Depreciation_Accounting_Status_RequestType',
            'Put_Requisition_Template_ResponseType' => '\\StructType\\Put_Requisition_Template_ResponseType',
            'Put_Requisition_Template_RequestType' => '\\StructType\\Put_Requisition_Template_RequestType',
            'Requisition_Template_DataType' => '\\StructType\\Requisition_Template_DataType',
            'Requisition_Template_Service_Line_DataType' => '\\StructType\\Requisition_Template_Service_Line_DataType',
            'Patient_Charge_Information_DataType' => '\\StructType\\Patient_Charge_Information_DataType',
            'Patient_Charge_Information_Row_DataType' => '\\StructType\\Patient_Charge_Information_Row_DataType',
            'Requisition_Template_Request_CriteriaType' => '\\StructType\\Requisition_Template_Request_CriteriaType',
            'Requisition_Template_Response_GroupType' => '\\StructType\\Requisition_Template_Response_GroupType',
            'Requisition_Template_WWSType' => '\\StructType\\Requisition_Template_WWSType',
            'Get_Requisition_Templates_RequestType' => '\\StructType\\Get_Requisition_Templates_RequestType',
            'Get_Requisition_Templates_ResponseType' => '\\StructType\\Get_Requisition_Templates_ResponseType',
            'Requisition_Template_Request_ReferencesType' => '\\StructType\\Requisition_Template_Request_ReferencesType',
            'Requisition_Template_Goods_Line_DataType' => '\\StructType\\Requisition_Template_Goods_Line_DataType',
            'Get_Supplier_Items_RequestType' => '\\StructType\\Get_Supplier_Items_RequestType',
            'Get_Supplier_Items_ResponseType' => '\\StructType\\Get_Supplier_Items_ResponseType',
            'Supplier_Item_Response_DataType' => '\\StructType\\Supplier_Item_Response_DataType',
            'Supplier_ItemType' => '\\StructType\\Supplier_ItemType',
            'Supplier_Item_Request_CriteriaType' => '\\StructType\\Supplier_Item_Request_CriteriaType',
            'Supplier_Item_Request_ReferencesType' => '\\StructType\\Supplier_Item_Request_ReferencesType',
            'Supplier_Item_Response_GroupType' => '\\StructType\\Supplier_Item_Response_GroupType',
            'Revenue_Center_Request_ReferencesType' => '\\StructType\\Revenue_Center_Request_ReferencesType',
            'Get_Revenue_Centers_RequestType' => '\\StructType\\Get_Revenue_Centers_RequestType',
            'Revenue_Center_Response_DataType' => '\\StructType\\Revenue_Center_Response_DataType',
            'Revenue_Center_Request_CriteriaType' => '\\StructType\\Revenue_Center_Request_CriteriaType',
            'Get_Revenue_Centers_ResponseType' => '\\StructType\\Get_Revenue_Centers_ResponseType',
            'Revenue_CenterType' => '\\StructType\\Revenue_CenterType',
            'Cancel_Pending_Supplier_Change_RequestType' => '\\StructType\\Cancel_Pending_Supplier_Change_RequestType',
            'Cancel_Pending_Supplier_Change_ResponseType' => '\\StructType\\Cancel_Pending_Supplier_Change_ResponseType',
            'Supplier_Contract_Amendment_DataType' => '\\StructType\\Supplier_Contract_Amendment_DataType',
            'Supplier_Invoice_Defaults_for_Supplier_Contract_Amendment_DataType' => '\\StructType\\Supplier_Invoice_Defaults_for_Supplier_Contract_Amendment_DataType',
            'Submit_Supplier_Contract_Amendment_ResponseType' => '\\StructType\\Submit_Supplier_Contract_Amendment_ResponseType',
            'Supplier_Contract_Amendment_Response_DataType' => '\\StructType\\Supplier_Contract_Amendment_Response_DataType',
            'Purchase_Order_Defaults_for_Supplier_Contract_Amendment_DataType' => '\\StructType\\Purchase_Order_Defaults_for_Supplier_Contract_Amendment_DataType',
            'Supplier_Contract_Amendment_Request_CriteriaType' => '\\StructType\\Supplier_Contract_Amendment_Request_CriteriaType',
            'Supplier_Contract_Amendment_Service_Line_Replacement_DataType' => '\\StructType\\Supplier_Contract_Amendment_Service_Line_Replacement_DataType',
            'Supplier_Contract_AmendmentType' => '\\StructType\\Supplier_Contract_AmendmentType',
            'Get_Supplier_Contract_Amendments_RequestType' => '\\StructType\\Get_Supplier_Contract_Amendments_RequestType',
            'Get_Supplier_Contract_Amendments_ResponseType' => '\\StructType\\Get_Supplier_Contract_Amendments_ResponseType',
            'Submit_Supplier_Contract_Amendment_RequestType' => '\\StructType\\Submit_Supplier_Contract_Amendment_RequestType',
            'Supplier_Contract_Amendment_Goods_Line_Replacement_DataType' => '\\StructType\\Supplier_Contract_Amendment_Goods_Line_Replacement_DataType',
            'Put_Patient_Charge_Information_ResponseType' => '\\StructType\\Put_Patient_Charge_Information_ResponseType',
            'Put_Patient_Charge_Information_RequestType' => '\\StructType\\Put_Patient_Charge_Information_RequestType',
            'Supplier_Item_Advanced_Pricing_DataType' => '\\StructType\\Supplier_Item_Advanced_Pricing_DataType',
            'Priority_Ranked_Supplier_Catalog_Item_JIT_Pricing_DataType' => '\\StructType\\Priority_Ranked_Supplier_Catalog_Item_JIT_Pricing_DataType',
            'Priority_Ranked_Supplier_Catalog_Item_Ordering_Pricing_DataType' => '\\StructType\\Priority_Ranked_Supplier_Catalog_Item_Ordering_Pricing_DataType',
            'Alternate_Contract_Interest_Rate_DataType' => '\\StructType\\Alternate_Contract_Interest_Rate_DataType',
            'Shared_Requisition_Template_Response_DataType' => '\\StructType\\Shared_Requisition_Template_Response_DataType',
            'Get_Supplier_Invoice_Line_Additional_Data_ResponseType' => '\\StructType\\Get_Supplier_Invoice_Line_Additional_Data_ResponseType',
            'Supplier_Invoice_Line_Additional_DataType' => '\\StructType\\Supplier_Invoice_Line_Additional_DataType',
            'Put_Supplier_Invoice_Line_Additional_Data_ResponseType' => '\\StructType\\Put_Supplier_Invoice_Line_Additional_Data_ResponseType',
            'Supplier_Invoice_Line_Request_CriteriaType' => '\\StructType\\Supplier_Invoice_Line_Request_CriteriaType',
            'Supplier_Invoice_Line_Response_GroupType' => '\\StructType\\Supplier_Invoice_Line_Response_GroupType',
            'Put_Supplier_Invoice_Line_Additional_Data_RequestType' => '\\StructType\\Put_Supplier_Invoice_Line_Additional_Data_RequestType',
            'Get_Supplier_Invoice_Line_Additional_Data_Response_DataType' => '\\StructType\\Get_Supplier_Invoice_Line_Additional_Data_Response_DataType',
            'Supplier_Invoice_Line_Request_ReferencesType' => '\\StructType\\Supplier_Invoice_Line_Request_ReferencesType',
            'Get_Supplier_Invoice_Line_Additional_Data_RequestType' => '\\StructType\\Get_Supplier_Invoice_Line_Additional_Data_RequestType',
            'Worker_Utilization_Target_Sheet_DataType' => '\\StructType\\Worker_Utilization_Target_Sheet_DataType',
            'Worker_Utilization_Target_Sheets_Request_ReferencesType' => '\\StructType\\Worker_Utilization_Target_Sheets_Request_ReferencesType',
            'Get_Worker_Utilization_Target_Sheets_ResponseType' => '\\StructType\\Get_Worker_Utilization_Target_Sheets_ResponseType',
            'Get_Worker_Utilization_Target_Sheets_RequestType' => '\\StructType\\Get_Worker_Utilization_Target_Sheets_RequestType',
            'Worker_Utilization_Target_Sheets_Response_DataType' => '\\StructType\\Worker_Utilization_Target_Sheets_Response_DataType',
            'Worker_Utilization_Target_Sheets_Request_CriteriaType' => '\\StructType\\Worker_Utilization_Target_Sheets_Request_CriteriaType',
            'Worker_Utilization_Target_Sheets_Response_GroupType' => '\\StructType\\Worker_Utilization_Target_Sheets_Response_GroupType',
            'Worker_Utilization_Target_Snapshot_DataType' => '\\StructType\\Worker_Utilization_Target_Snapshot_DataType',
            'Worker_Utilization_Target_Rule_Details_DataType' => '\\StructType\\Worker_Utilization_Target_Rule_Details_DataType',
            'Put_Worker_Utilization_Target_Sheet_RequestType' => '\\StructType\\Put_Worker_Utilization_Target_Sheet_RequestType',
            'Worker_Utilization_Target_SheetType' => '\\StructType\\Worker_Utilization_Target_SheetType',
            'Put_Worker_Utilization_Target_Sheet_ResponseType' => '\\StructType\\Put_Worker_Utilization_Target_Sheet_ResponseType',
            'Worker_Utilization_Target_Details_DataType' => '\\StructType\\Worker_Utilization_Target_Details_DataType',
            'OCR_Supplier_Invoice_DataType' => '\\StructType\\OCR_Supplier_Invoice_DataType',
            'Put_OCR_Supplier_Invoice_ResponseType' => '\\StructType\\Put_OCR_Supplier_Invoice_ResponseType',
            'Put_OCR_Supplier_Invoice_RequestType' => '\\StructType\\Put_OCR_Supplier_Invoice_RequestType',
            'Put_Supplier_Payment_Memo_RequestType' => '\\StructType\\Put_Supplier_Payment_Memo_RequestType',
            'Put_Supplier_Payment_Memo_ResponseType' => '\\StructType\\Put_Supplier_Payment_Memo_ResponseType',
            'Supplier_Payment_Memo_DataType' => '\\StructType\\Supplier_Payment_Memo_DataType',
            'Purchase_Item_Substitute_DataType' => '\\StructType\\Purchase_Item_Substitute_DataType',
            'Company_Industry_Code_DataType' => '\\StructType\\Company_Industry_Code_DataType',
            'Purchase_Order_Line_Additional_Data_Request_ReferencesType' => '\\StructType\\Purchase_Order_Line_Additional_Data_Request_ReferencesType',
            'Get_Purchase_Order_Lines_Additional_Data_RequestType' => '\\StructType\\Get_Purchase_Order_Lines_Additional_Data_RequestType',
            'Purchase_Order_Line_Additional_Data_Response_GroupType' => '\\StructType\\Purchase_Order_Line_Additional_Data_Response_GroupType',
            'Purchase_Order_Line_Additional_Data_Request_CriteriaType' => '\\StructType\\Purchase_Order_Line_Additional_Data_Request_CriteriaType',
            'Put_Purchase_Order_Line_Additional_Data_RequestType' => '\\StructType\\Put_Purchase_Order_Line_Additional_Data_RequestType',
            'Get_Purchase_Order_Lines_Additional_Data_ResponseType' => '\\StructType\\Get_Purchase_Order_Lines_Additional_Data_ResponseType',
            'Purchase_Order_Line_Additional_Data_Response_DataType' => '\\StructType\\Purchase_Order_Line_Additional_Data_Response_DataType',
            'Put_Purchase_Order_Line_Additional_Data_ResponseType' => '\\StructType\\Put_Purchase_Order_Line_Additional_Data_ResponseType',
            'Purchase_Order_Line_Additional_DataType' => '\\StructType\\Purchase_Order_Line_Additional_DataType',
            'Cancel_Spend_Authorization_RequestType' => '\\StructType\\Cancel_Spend_Authorization_RequestType',
            'Cancel_Spend_Authorization_ResponseType' => '\\StructType\\Cancel_Spend_Authorization_ResponseType',
            'Child_Project_Data_for_PortfolioType' => '\\StructType\\Child_Project_Data_for_PortfolioType',
            'Get_Project_Portfolios_ResponseType' => '\\StructType\\Get_Project_Portfolios_ResponseType',
            'Project_Portfolio_Request_ReferencesType' => '\\StructType\\Project_Portfolio_Request_ReferencesType',
            'Get_Project_Portfolios_RequestType' => '\\StructType\\Get_Project_Portfolios_RequestType',
            'Project_Portfolio_Response_DataType' => '\\StructType\\Project_Portfolio_Response_DataType',
            'Project_PortfolioType' => '\\StructType\\Project_PortfolioType',
            'Project_Portfolio_Response_GroupType' => '\\StructType\\Project_Portfolio_Response_GroupType',
            'Project_Portfolio_WWS_DataType' => '\\StructType\\Project_Portfolio_WWS_DataType',
            'Project_Portfolio_Request_CriteriaType' => '\\StructType\\Project_Portfolio_Request_CriteriaType',
            'Put_Project_Portfolio_ResponseType' => '\\StructType\\Put_Project_Portfolio_ResponseType',
            'Put_Project_Portfolio_RequestType' => '\\StructType\\Put_Project_Portfolio_RequestType',
            'Purchase_Oder_Line_Worktags_DataType' => '\\StructType\\Purchase_Oder_Line_Worktags_DataType',
            'Lease_Details_Amendment_DataType' => '\\StructType\\Lease_Details_Amendment_DataType',
            'Supplier_Contract_Lease_Amendment_DataType' => '\\StructType\\Supplier_Contract_Lease_Amendment_DataType',
            'Submit_Supplier_Contract_Lease_Amendment_ResponseType' => '\\StructType\\Submit_Supplier_Contract_Lease_Amendment_ResponseType',
            'Submit_Supplier_Contract_Lease_Amendment_RequestType' => '\\StructType\\Submit_Supplier_Contract_Lease_Amendment_RequestType',
            'Put_Worktag_Split_Template_Restriction_ResponseType' => '\\StructType\\Put_Worktag_Split_Template_Restriction_ResponseType',
            'Worktag_Split_Template_Criteria_DataType' => '\\StructType\\Worktag_Split_Template_Criteria_DataType',
            'Put_Worktag_Split_Template_Restriction_RequestType' => '\\StructType\\Put_Worktag_Split_Template_Restriction_RequestType',
            'Get_Supplier_Contract_Lease_Amendments_RequestType' => '\\StructType\\Get_Supplier_Contract_Lease_Amendments_RequestType',
            'Supplier_Contract_Lease_Amendment_Request_CriteriaType' => '\\StructType\\Supplier_Contract_Lease_Amendment_Request_CriteriaType',
            'Get_Supplier_Contract_Lease_Amendments_ResponseType' => '\\StructType\\Get_Supplier_Contract_Lease_Amendments_ResponseType',
            'Supplier_Contract_Lease_Amendment_Response_DataType' => '\\StructType\\Supplier_Contract_Lease_Amendment_Response_DataType',
            'Supplier_Contract_Lease_Amendment_Request_ReferencesType' => '\\StructType\\Supplier_Contract_Lease_Amendment_Request_ReferencesType',
            'Worktag_Split_Template_Criteria_Request_ReferencesType' => '\\StructType\\Worktag_Split_Template_Criteria_Request_ReferencesType',
            'Worktag_Split_Template_Criteria_Request_CriteriaType' => '\\StructType\\Worktag_Split_Template_Criteria_Request_CriteriaType',
            'Get_Worktag_Split_Template_Restrictions_RequestType' => '\\StructType\\Get_Worktag_Split_Template_Restrictions_RequestType',
            'Worktag_Split_Template_Criteria_Response_DataType' => '\\StructType\\Worktag_Split_Template_Criteria_Response_DataType',
            'Worktag_Split_Template_CriteriaType' => '\\StructType\\Worktag_Split_Template_CriteriaType',
            'Worktag_Split_Template_Criteria_Response_GroupType' => '\\StructType\\Worktag_Split_Template_Criteria_Response_GroupType',
            'Get_Worktag_Split_Template_Restrictions_ResponseType' => '\\StructType\\Get_Worktag_Split_Template_Restrictions_ResponseType',
            'Worktag_Split_TemplateType' => '\\StructType\\Worktag_Split_TemplateType',
            'Worktag_Split_Template_Item_DataType' => '\\StructType\\Worktag_Split_Template_Item_DataType',
            'Worktag_Split_Template_Request_ReferencesType' => '\\StructType\\Worktag_Split_Template_Request_ReferencesType',
            'Worktag_Split_Template_Sharing_DataType' => '\\StructType\\Worktag_Split_Template_Sharing_DataType',
            'Worktag_Split_Template_Response_GroupType' => '\\StructType\\Worktag_Split_Template_Response_GroupType',
            'Worktag_Split_Template_Request_CriteriaType' => '\\StructType\\Worktag_Split_Template_Request_CriteriaType',
            'Worktag_Split_Template_Response_DataType' => '\\StructType\\Worktag_Split_Template_Response_DataType',
            'Worktag_Split_Template_Snapshot_DataType' => '\\StructType\\Worktag_Split_Template_Snapshot_DataType',
            'Get_Worktag_Split_Templates_RequestType' => '\\StructType\\Get_Worktag_Split_Templates_RequestType',
            'Worktag_Split_Template_DataType' => '\\StructType\\Worktag_Split_Template_DataType',
            'Get_Worktag_Split_Templates_ResponseType' => '\\StructType\\Get_Worktag_Split_Templates_ResponseType',
            'Put_Worktag_Split_Template_RequestType' => '\\StructType\\Put_Worktag_Split_Template_RequestType',
            'Put_Worktag_Split_Template_ResponseType' => '\\StructType\\Put_Worktag_Split_Template_ResponseType',
            'Ship_to_Address_for_RequisitionType' => '\\StructType\\Ship_to_Address_for_RequisitionType',
            'Supplier_Contract_Lease_AmendmentType' => '\\StructType\\Supplier_Contract_Lease_AmendmentType',
            'Multi-Participant_DataType' => '\\StructType\\Multi_Participant_DataType',
            'Supplier_Contract_Participant_List_Entry_DataType' => '\\StructType\\Supplier_Contract_Participant_List_Entry_DataType',
            'Unnamed_Resource_WWS_Data_for_Resource_Plan_TemplateType' => '\\StructType\\Unnamed_Resource_WWS_Data_for_Resource_Plan_TemplateType',
            'Get_Project_Portfolios_without_Dependencies_ResponseType' => '\\StructType\\Get_Project_Portfolios_without_Dependencies_ResponseType',
            'Get_Project_Portfolios_without_Dependencies_RequestType' => '\\StructType\\Get_Project_Portfolios_without_Dependencies_RequestType',
            'Get_Travel_Booking_Records_RequestType' => '\\StructType\\Get_Travel_Booking_Records_RequestType',
            'Travel_Booking_Record_Request_ReferencesType' => '\\StructType\\Travel_Booking_Record_Request_ReferencesType',
            'Travel_Booking_Record_Response_GroupType' => '\\StructType\\Travel_Booking_Record_Response_GroupType',
            'Travel_Booking_Record_Response_DataType' => '\\StructType\\Travel_Booking_Record_Response_DataType',
            'Travel_Booking_Record_Request_CriteriaType' => '\\StructType\\Travel_Booking_Record_Request_CriteriaType',
            'Get_Travel_Booking_Records_ResponseType' => '\\StructType\\Get_Travel_Booking_Records_ResponseType',
            'Travel_Booking_RecordType' => '\\StructType\\Travel_Booking_RecordType',
            'Receivable_Repayment_WWSType' => '\\StructType\\Receivable_Repayment_WWSType',
            'Receivable_Repayment_Response_DataType' => '\\StructType\\Receivable_Repayment_Response_DataType',
            'Receivable_Repayment_Response_GroupType' => '\\StructType\\Receivable_Repayment_Response_GroupType',
            'Recovery_Expense_Reports_DataType' => '\\StructType\\Recovery_Expense_Reports_DataType',
            'Get_Receivable_Repayment_RequestType' => '\\StructType\\Get_Receivable_Repayment_RequestType',
            'Receivable_Repayment_Adhoc_Bank_TransactionType' => '\\StructType\\Receivable_Repayment_Adhoc_Bank_TransactionType',
            'Receivable_Repayment_Request_CriteriaType' => '\\StructType\\Receivable_Repayment_Request_CriteriaType',
            'Receivable_Repayment_DataType' => '\\StructType\\Receivable_Repayment_DataType',
            'Receivable_Repayment_Request_ReferencesType' => '\\StructType\\Receivable_Repayment_Request_ReferencesType',
            'Get_Receivable_Repayment_ResponseType' => '\\StructType\\Get_Receivable_Repayment_ResponseType',
            'Supplier_Invoice_LineType' => '\\StructType\\Supplier_Invoice_LineType',
            'Supplier_Invoice_Lines_Request_CriteriaType' => '\\StructType\\Supplier_Invoice_Lines_Request_CriteriaType',
            'Get_Supplier_Invoice_Lines_ResponseType' => '\\StructType\\Get_Supplier_Invoice_Lines_ResponseType',
            'Supplier_Invoice_Line_Response_DataType' => '\\StructType\\Supplier_Invoice_Line_Response_DataType',
            'Get_Supplier_Invoice_Lines_RequestType' => '\\StructType\\Get_Supplier_Invoice_Lines_RequestType',
            'Put_Receivable_Repayment_RequestType' => '\\StructType\\Put_Receivable_Repayment_RequestType',
            'Put_Receivable_Repayment_ResponseType' => '\\StructType\\Put_Receivable_Repayment_ResponseType',
            'Receivable_Repayment_WWS_DataType' => '\\StructType\\Receivable_Repayment_WWS_DataType',
            'Receivable_Repayment_Journal_LinesType' => '\\StructType\\Receivable_Repayment_Journal_LinesType',
            'Withholding_Tax_Certificate_NumberType' => '\\StructType\\Withholding_Tax_Certificate_NumberType',
            'Tax_Certificate_Numbers_DataType' => '\\StructType\\Tax_Certificate_Numbers_DataType',
            'Put_Tax_Certificate_Numbers_On_Supplier_Payment_ResponseType' => '\\StructType\\Put_Tax_Certificate_Numbers_On_Supplier_Payment_ResponseType',
            'Put_Tax_Certificate_Numbers_On_Supplier_Payment_RequestType' => '\\StructType\\Put_Tax_Certificate_Numbers_On_Supplier_Payment_RequestType',
            'Supplier_Payment_Tax_Certificate_Manual_Numbers_DataType' => '\\StructType\\Supplier_Payment_Tax_Certificate_Manual_Numbers_DataType',
            'Get_Receipt_Adjustments_RequestType' => '\\StructType\\Get_Receipt_Adjustments_RequestType',
            'Receipt_Adjustment_Service_Line_DataType' => '\\StructType\\Receipt_Adjustment_Service_Line_DataType',
            'Receipt_Adjustment_Request_ReferencesType' => '\\StructType\\Receipt_Adjustment_Request_ReferencesType',
            'Receipt_Adjustment_Request_CriteriaType' => '\\StructType\\Receipt_Adjustment_Request_CriteriaType',
            'Get_Receipt_Adjustments_ResponseType' => '\\StructType\\Get_Receipt_Adjustments_ResponseType',
            'Receipt_Adjustment_Item_Line_DataType' => '\\StructType\\Receipt_Adjustment_Item_Line_DataType',
            'Receipt_AdjustmentType' => '\\StructType\\Receipt_AdjustmentType',
            'Receipt_Adjustment_Response_GroupType' => '\\StructType\\Receipt_Adjustment_Response_GroupType',
            'Receipt_Adjustment_Response_DataType' => '\\StructType\\Receipt_Adjustment_Response_DataType',
            'Cancel_Receipt_Adjustment_ResponseType' => '\\StructType\\Cancel_Receipt_Adjustment_ResponseType',
            'Cancel_Receipt_Adjustment_RequestType' => '\\StructType\\Cancel_Receipt_Adjustment_RequestType',
            'Submit_Receipt_Adjustment_ResponseType' => '\\StructType\\Submit_Receipt_Adjustment_ResponseType',
            'Submit_Receipt_Adjustment_RequestType' => '\\StructType\\Submit_Receipt_Adjustment_RequestType',
            'Receipt_Adjustment_DataType' => '\\StructType\\Receipt_Adjustment_DataType',
            'Receipt_Adjustment_Item_LineType' => '\\StructType\\Receipt_Adjustment_Item_LineType',
            'Receipt_Adjustment_Service_LineType' => '\\StructType\\Receipt_Adjustment_Service_LineType',
            'Commodity_Code_Type_Response_GroupType' => '\\StructType\\Commodity_Code_Type_Response_GroupType',
            'Put_Commodity_Code_Type_ResponseType' => '\\StructType\\Put_Commodity_Code_Type_ResponseType',
            'Commodity_Code_TypeType' => '\\StructType\\Commodity_Code_TypeType',
            'Put_Commodity_Code_Type_RequestType' => '\\StructType\\Put_Commodity_Code_Type_RequestType',
            'Commodity_Code_Type_Request_CriteriaType' => '\\StructType\\Commodity_Code_Type_Request_CriteriaType',
            'Commodity_Code_Type_Request_ReferencesType' => '\\StructType\\Commodity_Code_Type_Request_ReferencesType',
            'Commodity_Code_Type_Level_DataType' => '\\StructType\\Commodity_Code_Type_Level_DataType',
            'Get_Commodity_Code_Types_RequestType' => '\\StructType\\Get_Commodity_Code_Types_RequestType',
            'Commodity_Code_Type_Response_DataType' => '\\StructType\\Commodity_Code_Type_Response_DataType',
            'Get_Commodity_Code_Types_ResponseType' => '\\StructType\\Get_Commodity_Code_Types_ResponseType',
            'Commodity_Code_Type_DataType' => '\\StructType\\Commodity_Code_Type_DataType',
            'Put_Supplier_Invoice_Work_Queue_Tag_RequestType' => '\\StructType\\Put_Supplier_Invoice_Work_Queue_Tag_RequestType',
            'Put_Supplier_Invoice_Work_Queue_Tag_ResponseType' => '\\StructType\\Put_Supplier_Invoice_Work_Queue_Tag_ResponseType',
            'Supplier_Invoice_Work_Queue_Tag_Request_ReferencesType' => '\\StructType\\Supplier_Invoice_Work_Queue_Tag_Request_ReferencesType',
            'Supplier_Invoice_Work_Queue_TagType' => '\\StructType\\Supplier_Invoice_Work_Queue_TagType',
            'Get_Supplier_Invoice_Work_Queue_Tags_ResponseType' => '\\StructType\\Get_Supplier_Invoice_Work_Queue_Tags_ResponseType',
            'Supplier_Invoice_Work_Queue_Tag_Request_CriteriaType' => '\\StructType\\Supplier_Invoice_Work_Queue_Tag_Request_CriteriaType',
            'Supplier_Invoice_Work_Queue_Tag_Response_GroupType' => '\\StructType\\Supplier_Invoice_Work_Queue_Tag_Response_GroupType',
            'Get_Supplier_Invoice_Work_Queue_Tags_RequestType' => '\\StructType\\Get_Supplier_Invoice_Work_Queue_Tags_RequestType',
            'Supplier_Invoice_Work_Queue_Tag_Response_DataType' => '\\StructType\\Supplier_Invoice_Work_Queue_Tag_Response_DataType',
            'Supplier_Invoice_Work_Queue_Tag_DataType' => '\\StructType\\Supplier_Invoice_Work_Queue_Tag_DataType',
            'Put_Commodity_Code_ResponseType' => '\\StructType\\Put_Commodity_Code_ResponseType',
            'Commodity_Code_Response_GroupType' => '\\StructType\\Commodity_Code_Response_GroupType',
            'Get_Commodity_Codes_RequestType' => '\\StructType\\Get_Commodity_Codes_RequestType',
            'Commodity_CodeType' => '\\StructType\\Commodity_CodeType',
            'Commodity_Code_Response_DataType' => '\\StructType\\Commodity_Code_Response_DataType',
            'Commodity_Code_Request_ReferencesType' => '\\StructType\\Commodity_Code_Request_ReferencesType',
            'Commodity_Code_DataType' => '\\StructType\\Commodity_Code_DataType',
            'Commodity_Code_Request_CriteriaType' => '\\StructType\\Commodity_Code_Request_CriteriaType',
            'Put_Commodity_Code_RequestType' => '\\StructType\\Put_Commodity_Code_RequestType',
            'Get_Commodity_Codes_ResponseType' => '\\StructType\\Get_Commodity_Codes_ResponseType',
            'Put_Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_ResponseType' => '\\StructType\\Put_Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_ResponseType',
            'Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Response_DataType' => '\\StructType\\Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Response_DataType',
            'Get_Supplier_Invoice_Work_Queue_Tag_Assignment_Rules_RequestType' => '\\StructType\\Get_Supplier_Invoice_Work_Queue_Tag_Assignment_Rules_RequestType',
            'Supplier_Invoice_Work_Queue_Tag_Assignment_RuleType' => '\\StructType\\Supplier_Invoice_Work_Queue_Tag_Assignment_RuleType',
            'Put_Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_RequestType' => '\\StructType\\Put_Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_RequestType',
            'Get_Supplier_Invoice_Work_Queue_Tag_Assignment_Rules_ResponseType' => '\\StructType\\Get_Supplier_Invoice_Work_Queue_Tag_Assignment_Rules_ResponseType',
            'Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Response_GroupType' => '\\StructType\\Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_Response_GroupType',
            'Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_DataType' => '\\StructType\\Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_DataType',
            'Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_ReferencesType' => '\\StructType\\Supplier_Invoice_Work_Queue_Tag_Assignment_Rule_ReferencesType',
            'Supplier_Invoice_Work_Queue_Information_DataType' => '\\StructType\\Supplier_Invoice_Work_Queue_Information_DataType',
            'Get_Project_Plans_without_Dependencies_ResponseType' => '\\StructType\\Get_Project_Plans_without_Dependencies_ResponseType',
            'Get_Project_Plans_without_Dependencies_RequestType' => '\\StructType\\Get_Project_Plans_without_Dependencies_RequestType',
            'Supplier_Invoice_Assignment_Rule_ReferencesType' => '\\StructType\\Supplier_Invoice_Assignment_Rule_ReferencesType',
            'Supplier_Invoice_Assignment_Rule_DataType' => '\\StructType\\Supplier_Invoice_Assignment_Rule_DataType',
            'Put_Supplier_Invoice_Assignment_Rule_RequestType' => '\\StructType\\Put_Supplier_Invoice_Assignment_Rule_RequestType',
            'Get_Supplier_Invoice_Assignment_Rules_RequestType' => '\\StructType\\Get_Supplier_Invoice_Assignment_Rules_RequestType',
            'Put_Supplier_Invoice_Assignment_Rule_ResponseType' => '\\StructType\\Put_Supplier_Invoice_Assignment_Rule_ResponseType',
            'Get_Supplier_Invoice_Assignment_Rules_ResponseType' => '\\StructType\\Get_Supplier_Invoice_Assignment_Rules_ResponseType',
            'Supplier_Invoice_Assignment_RuleType' => '\\StructType\\Supplier_Invoice_Assignment_RuleType',
            'Supplier_Invoice_Assignment_Rule_Response_DataType' => '\\StructType\\Supplier_Invoice_Assignment_Rule_Response_DataType',
            'Supplier_Invoice_Assignment_Rule_Response_GroupType' => '\\StructType\\Supplier_Invoice_Assignment_Rule_Response_GroupType',
            'Receipt_Adjustment_Item_Line_Lot_DataType' => '\\StructType\\Receipt_Adjustment_Item_Line_Lot_DataType',
            'Receipt_Adjustment_Item_Line_LotType' => '\\StructType\\Receipt_Adjustment_Item_Line_LotType',
            'Contingent_Worker_Response_DataType' => '\\StructType\\Contingent_Worker_Response_DataType',
            'Contingent_Worker_Response_GroupType' => '\\StructType\\Contingent_Worker_Response_GroupType',
            'Get_Assign_Supplier_to_Contingent_Worker_ResponseType' => '\\StructType\\Get_Assign_Supplier_to_Contingent_Worker_ResponseType',
            'Contingent_Worker_Request_CriteriaType' => '\\StructType\\Contingent_Worker_Request_CriteriaType',
            'Contingent_Worker_WWSType' => '\\StructType\\Contingent_Worker_WWSType',
            'Contingent_Workers_Request_ReferencesType' => '\\StructType\\Contingent_Workers_Request_ReferencesType',
            'Get_Assign_Supplier_to_Contingent_Worker_RequestType' => '\\StructType\\Get_Assign_Supplier_to_Contingent_Worker_RequestType',
            'Contingent_Worker_Request_ReferencesType' => '\\StructType\\Contingent_Worker_Request_ReferencesType',
            'Contingent_Workers_DataType' => '\\StructType\\Contingent_Workers_DataType',
            'Put_Assign_Supplier_to_Contingent_Worker_ResponseType' => '\\StructType\\Put_Assign_Supplier_to_Contingent_Worker_ResponseType',
            'Put_Assign_Supplier_to_Contingent_Worker_RequestType' => '\\StructType\\Put_Assign_Supplier_to_Contingent_Worker_RequestType',
            'Procurement_Condition_RuleType' => '\\StructType\\Procurement_Condition_RuleType',
            'Put_Procurement_Conditional_Rule_ResponseType' => '\\StructType\\Put_Procurement_Conditional_Rule_ResponseType',
            'Procurement_Condition_Rule_Response_GroupType' => '\\StructType\\Procurement_Condition_Rule_Response_GroupType',
            'Get_Procurement_Conditional_Rules_RequestType' => '\\StructType\\Get_Procurement_Conditional_Rules_RequestType',
            'Procurement_Condition_Rule_DataType' => '\\StructType\\Procurement_Condition_Rule_DataType',
            'Procurement_Conditions_Rule_Request_CriteriaType' => '\\StructType\\Procurement_Conditions_Rule_Request_CriteriaType',
            'Get_Procurement_Conditional_Rules_Without_Dependencies_RequestType' => '\\StructType\\Get_Procurement_Conditional_Rules_Without_Dependencies_RequestType',
            'Get_Procurement_Conditional_Rules_ResponseType' => '\\StructType\\Get_Procurement_Conditional_Rules_ResponseType',
            'Put_Procurement_Conditional_Rule_RequestType' => '\\StructType\\Put_Procurement_Conditional_Rule_RequestType',
            'Procurement_Conditional_Rule_Request_ReferencesType' => '\\StructType\\Procurement_Conditional_Rule_Request_ReferencesType',
            'Get_Procurement_Conditional_Rules_Without_Dependencies_ResponseType' => '\\StructType\\Get_Procurement_Conditional_Rules_Without_Dependencies_ResponseType',
            'Procurement_Condition_Rule_Response_DataType' => '\\StructType\\Procurement_Condition_Rule_Response_DataType',
            'Project_Budget_Template_Response_DataType' => '\\StructType\\Project_Budget_Template_Response_DataType',
            'Project_Budget_TemplateType' => '\\StructType\\Project_Budget_TemplateType',
            'Project_Budget_Template_DataType' => '\\StructType\\Project_Budget_Template_DataType',
            'Get_Project_Budget_Templates_ResponseType' => '\\StructType\\Get_Project_Budget_Templates_ResponseType',
            'Project_Budget_Template_Request_ReferencesType' => '\\StructType\\Project_Budget_Template_Request_ReferencesType',
            'Get_Project_Budget_Templates_RequestType' => '\\StructType\\Get_Project_Budget_Templates_RequestType',
            'Project_Budget_Template_Line_DataType' => '\\StructType\\Project_Budget_Template_Line_DataType',
            'Configurable_Attributes_DataType' => '\\StructType\\Configurable_Attributes_DataType',
            'Return_to_Supplier_Line_Inventory_Location_Quantity_Details_DataType' => '\\StructType\\Return_to_Supplier_Line_Inventory_Location_Quantity_Details_DataType',
            'Put_Project_Budget_Template_ResponseType' => '\\StructType\\Put_Project_Budget_Template_ResponseType',
            'Project_Budget_Template_Response_GroupType' => '\\StructType\\Project_Budget_Template_Response_GroupType',
            'Put_Project_Budget_Template_RequestType' => '\\StructType\\Put_Project_Budget_Template_RequestType',
            'Close_Status_InformationType' => '\\StructType\\Close_Status_InformationType',
            'Import_Purchase_Order_Close_Lines_RequestType' => '\\StructType\\Import_Purchase_Order_Close_Lines_RequestType',
            'Purchase_Order_Close_Lines__HV__DataType' => '\\StructType\\Purchase_Order_Close_Lines__HV__DataType',
            'Put_Purchase_Item_Request_Type_ResponseType' => '\\StructType\\Put_Purchase_Item_Request_Type_ResponseType',
            'Put_Purchase_Item_Request_Type_RequestType' => '\\StructType\\Put_Purchase_Item_Request_Type_RequestType',
            'Purchase_Item_Request_Type_Enrichment_TemplatesType' => '\\StructType\\Purchase_Item_Request_Type_Enrichment_TemplatesType',
            'Purchase_Item_Request_Type_DataType' => '\\StructType\\Purchase_Item_Request_Type_DataType',
            'Discrete_Child_ComponentType' => '\\StructType\\Discrete_Child_ComponentType',
            'Purchase_Item_Request_Template_Outbound_DataType' => '\\StructType\\Purchase_Item_Request_Template_Outbound_DataType',
            'Get_Purchase_Item_Request_Templates_ResponseType' => '\\StructType\\Get_Purchase_Item_Request_Templates_ResponseType',
            'Purchase_Item_Request_Template_Response_GroupType' => '\\StructType\\Purchase_Item_Request_Template_Response_GroupType',
            'Purchase_Item_Request_Template_Response_DataType' => '\\StructType\\Purchase_Item_Request_Template_Response_DataType',
            'Purchase_Item_Request_Template_DataType' => '\\StructType\\Purchase_Item_Request_Template_DataType',
            'Put_Purchase_Item_Request_Template_RequestType' => '\\StructType\\Put_Purchase_Item_Request_Template_RequestType',
            'Purchase_Item_Request_Template_Definition_DataType' => '\\StructType\\Purchase_Item_Request_Template_Definition_DataType',
            'Purchase_Item_Request_Template_Request_CriteriaType' => '\\StructType\\Purchase_Item_Request_Template_Request_CriteriaType',
            'Get_Purchase_Item_Request_Templates_RequestType' => '\\StructType\\Get_Purchase_Item_Request_Templates_RequestType',
            'Put_Purchase_Item_Request_Template_ResponseType' => '\\StructType\\Put_Purchase_Item_Request_Template_ResponseType',
            'Purchase_Item_Request_Template_Request_ReferencesType' => '\\StructType\\Purchase_Item_Request_Template_Request_ReferencesType',
            'Purchase_Item_Request_Template_Item_DataType' => '\\StructType\\Purchase_Item_Request_Template_Item_DataType',
            'Get_Purchase_Item_Request_Types_RequestType' => '\\StructType\\Get_Purchase_Item_Request_Types_RequestType',
            'Purchase_Item_Request_Type_Response_GroupType' => '\\StructType\\Purchase_Item_Request_Type_Response_GroupType',
            'Purchase_Item_Request_Type_CriteriaType' => '\\StructType\\Purchase_Item_Request_Type_CriteriaType',
            'Get_Purchase_Item_Request_Types_ResponseType' => '\\StructType\\Get_Purchase_Item_Request_Types_ResponseType',
            'Purchase_Item_Request_Type_Response_DataType' => '\\StructType\\Purchase_Item_Request_Type_Response_DataType',
            'Purchase_Item_Request_Type_Request_ReferencesType' => '\\StructType\\Purchase_Item_Request_Type_Request_ReferencesType',
            'Purchase_Item_Request_Type_WWSType' => '\\StructType\\Purchase_Item_Request_Type_WWSType',
            'Expense_Item_Distance_Calculation_Configuration_DataType' => '\\StructType\\Expense_Item_Distance_Calculation_Configuration_DataType',
            'Remit_to_Supplier_Connection_Snapshot_Status_DataType' => '\\StructType\\Remit_to_Supplier_Connection_Snapshot_Status_DataType',
            'Cancel_Netting_Transaction_RequestType' => '\\StructType\\Cancel_Netting_Transaction_RequestType',
            'Cancel_Netting_Transaction_ResponseType' => '\\StructType\\Cancel_Netting_Transaction_ResponseType',
            'Get_External_Transaction_Sources_ResponseType' => '\\StructType\\Get_External_Transaction_Sources_ResponseType',
            'External_Transaction_Source_Response_GroupType' => '\\StructType\\External_Transaction_Source_Response_GroupType',
            'External_Transaction_Source_DataType' => '\\StructType\\External_Transaction_Source_DataType',
            'External_Transaction_Source_Response_DataType' => '\\StructType\\External_Transaction_Source_Response_DataType',
            'External_Transaction_Source_Request_CriteriaType' => '\\StructType\\External_Transaction_Source_Request_CriteriaType',
            'External_Transaction_SourceType' => '\\StructType\\External_Transaction_SourceType',
            'Get_External_Transaction_Sources_RequestType' => '\\StructType\\Get_External_Transaction_Sources_RequestType',
            'External_Transaction_Source_Request_ReferencesType' => '\\StructType\\External_Transaction_Source_Request_ReferencesType',
            'Submit_Netting_Transaction_ResponseType' => '\\StructType\\Submit_Netting_Transaction_ResponseType',
            'Submit_Netting_Transaction_RequestType' => '\\StructType\\Submit_Netting_Transaction_RequestType',
            'Netting_Transaction_DataType' => '\\StructType\\Netting_Transaction_DataType',
            'Supplier_Invoice_For_Netting_DataType' => '\\StructType\\Supplier_Invoice_For_Netting_DataType',
            'Customer_Invoice_for_Netting_DataType' => '\\StructType\\Customer_Invoice_for_Netting_DataType',
            'Netting_Transaction_Response_DataType' => '\\StructType\\Netting_Transaction_Response_DataType',
            'Netting_Transaction_Request_CriteriaType' => '\\StructType\\Netting_Transaction_Request_CriteriaType',
            'Get_Netting_Transactions_RequestType' => '\\StructType\\Get_Netting_Transactions_RequestType',
            'Netting_Transaction_Request_ReferencesType' => '\\StructType\\Netting_Transaction_Request_ReferencesType',
            'Get_Netting_Transactions_ResponseType' => '\\StructType\\Get_Netting_Transactions_ResponseType',
            'Netting_Transaction_for_GET_Netting_TransactionType' => '\\StructType\\Netting_Transaction_for_GET_Netting_TransactionType',
            'Netting_Transaction_Response_GroupType' => '\\StructType\\Netting_Transaction_Response_GroupType',
            'Put_External_Transaction_Source_ResponseType' => '\\StructType\\Put_External_Transaction_Source_ResponseType',
            'Put_External_Transaction_Source_RequestType' => '\\StructType\\Put_External_Transaction_Source_RequestType',
            'Supplier_Refund_Response_GroupType' => '\\StructType\\Supplier_Refund_Response_GroupType',
            'Supplier_Refund_Request_CriteriaType' => '\\StructType\\Supplier_Refund_Request_CriteriaType',
            'Supplier_Refund_Request_ReferencesType' => '\\StructType\\Supplier_Refund_Request_ReferencesType',
            'Supplier_RefundType' => '\\StructType\\Supplier_RefundType',
            'Get_Supplier_Refunds_RequestType' => '\\StructType\\Get_Supplier_Refunds_RequestType',
            'Supplier_Refund_Response_DataType' => '\\StructType\\Supplier_Refund_Response_DataType',
            'Get_Supplier_Refunds_ResponseType' => '\\StructType\\Get_Supplier_Refunds_ResponseType',
            'Supplier_Refund_DataType' => '\\StructType\\Supplier_Refund_DataType',
            'Supplier_Refund_Application_DataType' => '\\StructType\\Supplier_Refund_Application_DataType',
            'Submit_Supplier_Refund_RequestType' => '\\StructType\\Submit_Supplier_Refund_RequestType',
            'Submit_Supplier_Refund_ResponseType' => '\\StructType\\Submit_Supplier_Refund_ResponseType',
            'Currency_Rate_DataType' => '\\StructType\\Currency_Rate_DataType',
            'Put_External_Reference_on_Spend_Transaction_RequestType' => '\\StructType\\Put_External_Reference_on_Spend_Transaction_RequestType',
            'Put_External_Reference_on_Spend_Transaction_ResponseType' => '\\StructType\\Put_External_Reference_on_Spend_Transaction_ResponseType',
            'Requesting_Entity_Outbound_DataType' => '\\StructType\\Requesting_Entity_Outbound_DataType',
            'Requesting_Entity_Response_DataType' => '\\StructType\\Requesting_Entity_Response_DataType',
            'Requesting_Entity_Request_CriteriaType' => '\\StructType\\Requesting_Entity_Request_CriteriaType',
            'Get_Requesting_Entities_RequestType' => '\\StructType\\Get_Requesting_Entities_RequestType',
            'Requesting_Entity_DataType' => '\\StructType\\Requesting_Entity_DataType',
            'Get_Requesting_Entities_ResponseType' => '\\StructType\\Get_Requesting_Entities_ResponseType',
            'Put_Requesting_Entity_RequestType' => '\\StructType\\Put_Requesting_Entity_RequestType',
            'Requesting_Entity_Request_ReferencesType' => '\\StructType\\Requesting_Entity_Request_ReferencesType',
            'Put_Requesting_Entity_ResponseType' => '\\StructType\\Put_Requesting_Entity_ResponseType',
            'Requesting_Entity_Response_GroupType' => '\\StructType\\Requesting_Entity_Response_GroupType',
            'Get_Purchase_Item_Lists_ResponseType' => '\\StructType\\Get_Purchase_Item_Lists_ResponseType',
            'Restricted_Purchase_Item_List_Response_GroupType' => '\\StructType\\Restricted_Purchase_Item_List_Response_GroupType',
            'Restricted_Purchase_Item_List_Request_ReferencesType' => '\\StructType\\Restricted_Purchase_Item_List_Request_ReferencesType',
            'Put_Purchase_Item_List_RequestType' => '\\StructType\\Put_Purchase_Item_List_RequestType',
            'Restricted_Purchase_Item_List_Response_DataType' => '\\StructType\\Restricted_Purchase_Item_List_Response_DataType',
            'Restricted_Purchase_Item_List_Request_CriteriaType' => '\\StructType\\Restricted_Purchase_Item_List_Request_CriteriaType',
            'Get_Purchase_Item_Lists_RequestType' => '\\StructType\\Get_Purchase_Item_Lists_RequestType',
            'Restricted_Purchase_Item_List_Outbound_DataType' => '\\StructType\\Restricted_Purchase_Item_List_Outbound_DataType',
            'Put_Purchase_Item_List_ResponseType' => '\\StructType\\Put_Purchase_Item_List_ResponseType',
            'Restricted_Purchase_Item_List_DataType' => '\\StructType\\Restricted_Purchase_Item_List_DataType',
            'Prepaid_Spend_Amortization_Schedule_Response_GroupType' => '\\StructType\\Prepaid_Spend_Amortization_Schedule_Response_GroupType',
            'Get_Web_Item_Attributes_RequestType' => '\\StructType\\Get_Web_Item_Attributes_RequestType',
            'Put_Web_Item_Attributes_ResponseType' => '\\StructType\\Put_Web_Item_Attributes_ResponseType',
            'Get_Web_Item_Attributes_ResponseType' => '\\StructType\\Get_Web_Item_Attributes_ResponseType',
            'Web_Item_Attributes_Request_ReferencesType' => '\\StructType\\Web_Item_Attributes_Request_ReferencesType',
            'Web_Item_Attributes_DataType' => '\\StructType\\Web_Item_Attributes_DataType',
            'Web_Item_AttributesType' => '\\StructType\\Web_Item_AttributesType',
            'Put_Web_Item_Attributes_RequestType' => '\\StructType\\Put_Web_Item_Attributes_RequestType',
            'Web_Item_Attributes_Response_GroupType' => '\\StructType\\Web_Item_Attributes_Response_GroupType',
            'Web_Item_Attributes_Request_CriteriaType' => '\\StructType\\Web_Item_Attributes_Request_CriteriaType',
            'Web_Item_Attributes_Response_DataType' => '\\StructType\\Web_Item_Attributes_Response_DataType',
            'Workday_Account_Creation_Options_DataType' => '\\StructType\\Workday_Account_Creation_Options_DataType',
            'Put_External_Business_Entity_Contact_RequestType' => '\\StructType\\Put_External_Business_Entity_Contact_RequestType',
            'External_Business_Entity_Contact_DataType' => '\\StructType\\External_Business_Entity_Contact_DataType',
            'Put_External_Business_Entity_Contact_ResponseType' => '\\StructType\\Put_External_Business_Entity_Contact_ResponseType',
            'Change_Prepaid_Amortization_Type_RequestType' => '\\StructType\\Change_Prepaid_Amortization_Type_RequestType',
            'Change_Prepaid_Amortization_Type_DataType' => '\\StructType\\Change_Prepaid_Amortization_Type_DataType',
            'Change_Prepaid_Amortization_Type_ResponseType' => '\\StructType\\Change_Prepaid_Amortization_Type_ResponseType',
            'External_Business_Entity_Contact_Request_ReferencesType' => '\\StructType\\External_Business_Entity_Contact_Request_ReferencesType',
            'External_Business_Entity_ContactType' => '\\StructType\\External_Business_Entity_ContactType',
            'Get_External_Business_Entity_Contacts_ResponseType' => '\\StructType\\Get_External_Business_Entity_Contacts_ResponseType',
            'External_Business_Entity_Contact_Request_CriteriaType' => '\\StructType\\External_Business_Entity_Contact_Request_CriteriaType',
            'External_Business_Entity_Contact_Response_GroupType' => '\\StructType\\External_Business_Entity_Contact_Response_GroupType',
            'External_Business_Entity_Contact_Response_DataType' => '\\StructType\\External_Business_Entity_Contact_Response_DataType',
            'Get_External_Business_Entity_Contact_RequestType' => '\\StructType\\Get_External_Business_Entity_Contact_RequestType',
            'Cancel_Supplier_Payment_ResponseType' => '\\StructType\\Cancel_Supplier_Payment_ResponseType',
            'Cancel_Supplier_Payment_RequestType' => '\\StructType\\Cancel_Supplier_Payment_RequestType',
            'Change_Supplier_Invoice_On_Hold_Status_RequestType' => '\\StructType\\Change_Supplier_Invoice_On_Hold_Status_RequestType',
            'On_Hold_DataType' => '\\StructType\\On_Hold_DataType',
            'Change_Supplier_Invoice_On_Hold_Status_ResponseType' => '\\StructType\\Change_Supplier_Invoice_On_Hold_Status_ResponseType',
            'Settlement_Account_WWS_Widget_DataType' => '\\StructType\\Settlement_Account_WWS_Widget_DataType',
            'Settlement_Bank_Account_WWS_DataType' => '\\StructType\\Settlement_Bank_Account_WWS_DataType',
            'Tax_ID_WWS_DataType' => '\\StructType\\Tax_ID_WWS_DataType',
            'Tax_ID_Widget_DataType' => '\\StructType\\Tax_ID_Widget_DataType',
            'Tax_Status_WWS_DataType' => '\\StructType\\Tax_Status_WWS_DataType',
            'Tax_Status_Widget_DataType' => '\\StructType\\Tax_Status_Widget_DataType',
            'Intermediary_Bank_Account_DataType' => '\\StructType\\Intermediary_Bank_Account_DataType',
            'Intermediary_Bank_Account_Widget_DataType' => '\\StructType\\Intermediary_Bank_Account_Widget_DataType',
            'Default_PO_Issue_Email_WWS_DataType' => '\\StructType\\Default_PO_Issue_Email_WWS_DataType',
            'Default_PO_Issue_Email_WWS_Widget_DataType' => '\\StructType\\Default_PO_Issue_Email_WWS_Widget_DataType',
            'Business_Entity_Contact_Type_Tenanted_DataType' => '\\StructType\\Business_Entity_Contact_Type_Tenanted_DataType',
            'Supplier_Classification_Interface_WWS_DataType' => '\\StructType\\Supplier_Classification_Interface_WWS_DataType',
            'Supplier_Classification_Widget_DataType' => '\\StructType\\Supplier_Classification_Widget_DataType',
            'Supplier_Invoice_Validation_Configuration_DataType' => '\\StructType\\Supplier_Invoice_Validation_Configuration_DataType',
            'Put_Supplier_Invoice_System_Validation_Configuration_ResponseType' => '\\StructType\\Put_Supplier_Invoice_System_Validation_Configuration_ResponseType',
            'Put_Supplier_Invoice_System_Validation_Configuration_RequestType' => '\\StructType\\Put_Supplier_Invoice_System_Validation_Configuration_RequestType',
            'Supplier_Invoice_System_Validation_Configuration_Request_CriteriaType' => '\\StructType\\Supplier_Invoice_System_Validation_Configuration_Request_CriteriaType',
            'Supplier_Invoice_System_Validation_Configuration_ReferencesType' => '\\StructType\\Supplier_Invoice_System_Validation_Configuration_ReferencesType',
            'Get_Supplier_Invoice_System_Validation_Configuration_RequestType' => '\\StructType\\Get_Supplier_Invoice_System_Validation_Configuration_RequestType',
            'Supplier_Invoice_System_Validation_Configuration_Response_DataType' => '\\StructType\\Supplier_Invoice_System_Validation_Configuration_Response_DataType',
            'Supplier_Invoice_System_Validation_Configuration_Response_GroupType' => '\\StructType\\Supplier_Invoice_System_Validation_Configuration_Response_GroupType',
            'Get_Supplier_Invoice_System_Validation_Configuration_ResponseType' => '\\StructType\\Get_Supplier_Invoice_System_Validation_Configuration_ResponseType',
            'Supplier_Invoice_System_Validation_ConfigurationType' => '\\StructType\\Supplier_Invoice_System_Validation_ConfigurationType',
            'Validation_Status_DataType' => '\\StructType\\Validation_Status_DataType',
            'Charge_Control_DataType' => '\\StructType\\Charge_Control_DataType',
            'Financials_Attachment_WWS_DataType' => '\\StructType\\Financials_Attachment_WWS_DataType',
            'Financials_Attachment_Widget_DataType' => '\\StructType\\Financials_Attachment_Widget_DataType',
            'Business_Entity_Alternate_Name_WWS_DataType' => '\\StructType\\Business_Entity_Alternate_Name_WWS_DataType',
            'Business_Entity_Alternate_Name_Widget_DataType' => '\\StructType\\Business_Entity_Alternate_Name_Widget_DataType',
            'Bulk_Import_Submit_Supplier_RequestType' => '\\StructType\\Bulk_Import_Submit_Supplier_RequestType',
            'Bulk_Import_Adjust_Asset_Cost_RequestType' => '\\StructType\\Bulk_Import_Adjust_Asset_Cost_RequestType',
            'Business_Assets_Detail_WWS_DataType' => '\\StructType\\Business_Assets_Detail_WWS_DataType',
            'Get_Carriers_ResponseType' => '\\StructType\\Get_Carriers_ResponseType',
            'Put_Carriers_RequestType' => '\\StructType\\Put_Carriers_RequestType',
            'Carriers_DataType' => '\\StructType\\Carriers_DataType',
            'Carriers_Response_DataType' => '\\StructType\\Carriers_Response_DataType',
            'Carrier_Request_ReferencesType' => '\\StructType\\Carrier_Request_ReferencesType',
            'Put_Carriers_ResponseType' => '\\StructType\\Put_Carriers_ResponseType',
            'Get_Carriers_RequestType' => '\\StructType\\Get_Carriers_RequestType',
            'Carrier_Request_CriteriaType' => '\\StructType\\Carrier_Request_CriteriaType',
            'CarriersType' => '\\StructType\\CarriersType',
            'Bulk_Import_Update_Asset_Book_Configuration_RequestType' => '\\StructType\\Bulk_Import_Update_Asset_Book_Configuration_RequestType',
            'Bulk_Import_Transfer_Asset_RequestType' => '\\StructType\\Bulk_Import_Transfer_Asset_RequestType',
            'Revenue_Center_Response_GroupType' => '\\StructType\\Revenue_Center_Response_GroupType',
            'Credit_Card_Code_Mapping_DataType' => '\\StructType\\Credit_Card_Code_Mapping_DataType',
            'Credit_Card_Code_Mapping_Request_CriteriaType' => '\\StructType\\Credit_Card_Code_Mapping_Request_CriteriaType',
            'Credit_Card_Code_Mapping_Request_ReferencesType' => '\\StructType\\Credit_Card_Code_Mapping_Request_ReferencesType',
            'Credit_Card_Code_Mapping_Response_GroupType' => '\\StructType\\Credit_Card_Code_Mapping_Response_GroupType',
            'Distance_Calculation_Attribute_Configuration_DataType' => '\\StructType\\Distance_Calculation_Attribute_Configuration_DataType',
            'Bulk_Import_Dispose_Asset_RequestType' => '\\StructType\\Bulk_Import_Dispose_Asset_RequestType',
            'Business_Document_Attachment_with_External_Option_And_Attachment_Category_DataType' => '\\StructType\\Business_Document_Attachment_with_External_Option_And_Attachment_Category_DataType',
            'Bulk_Import_Submit_Remit_To_Supplier_Connection_RequestType' => '\\StructType\\Bulk_Import_Submit_Remit_To_Supplier_Connection_RequestType',
            'Financials_Attachment_with_Attachment_Category_DataType' => '\\StructType\\Financials_Attachment_with_Attachment_Category_DataType',
            'Supplier_Invoice_Document_Link_DataType' => '\\StructType\\Supplier_Invoice_Document_Link_DataType',
            'Put_Supplier_Invoice_Links_ResponseType' => '\\StructType\\Put_Supplier_Invoice_Links_ResponseType',
            'Put_Supplier_Invoice_Links_RequestType' => '\\StructType\\Put_Supplier_Invoice_Links_RequestType',
            'Supplier_Classification_Request_CriteriaType' => '\\StructType\\Supplier_Classification_Request_CriteriaType',
            'Bulk_Import_Register_Asset_RequestType' => '\\StructType\\Bulk_Import_Register_Asset_RequestType',
            'Register_Asset_RequestRootType' => '\\StructType\\Register_Asset_RequestRootType',
            'Adjust_Asset_Cost_RequestRootType' => '\\StructType\\Adjust_Asset_Cost_RequestRootType',
            'Transfer_Asset_RequestRootType' => '\\StructType\\Transfer_Asset_RequestRootType',
            'Dispose_Asset_RequestRootType' => '\\StructType\\Dispose_Asset_RequestRootType',
            'Update_Asset_Book_Configuration_RequestRootType' => '\\StructType\\Update_Asset_Book_Configuration_RequestRootType',
            'Submit_Supplier_RequestRootType' => '\\StructType\\Submit_Supplier_RequestRootType',
            'Submit_Remit_To_Supplier_Connection_RequestRootType' => '\\StructType\\Submit_Remit_To_Supplier_Connection_RequestRootType',
            'Validation_FaultType' => '\\StructType\\Validation_FaultType',
            'Processing_FaultType' => '\\StructType\\Processing_FaultType',
            'Validation_ErrorType' => '\\StructType\\Validation_ErrorType',
            'System_UserObjectType' => '\\StructType\\System_UserObjectType',
            'Relational_OperatorObjectType' => '\\StructType\\Relational_OperatorObjectType',
            'Rounding_OptionObjectType' => '\\StructType\\Rounding_OptionObjectType',
            'LocationObjectType' => '\\StructType\\LocationObjectType',
            'Job_ProfileObjectType' => '\\StructType\\Job_ProfileObjectType',
            'OrganizationObjectType' => '\\StructType\\OrganizationObjectType',
            'Organization_SubtypeObjectType' => '\\StructType\\Organization_SubtypeObjectType',
            'EmployeeObjectType' => '\\StructType\\EmployeeObjectType',
            'Instant_Messenger_TypeObjectType' => '\\StructType\\Instant_Messenger_TypeObjectType',
            'WorkerObjectType' => '\\StructType\\WorkerObjectType',
            'Contingent_WorkerObjectType' => '\\StructType\\Contingent_WorkerObjectType',
            'Position_Time_TypeObjectType' => '\\StructType\\Position_Time_TypeObjectType',
            'ContactObjectType' => '\\StructType\\ContactObjectType',
            'Integration_System__Audited_ObjectType' => '\\StructType\\Integration_System__Audited_ObjectType',
            'Financial_Report_GroupObjectType' => '\\StructType\\Financial_Report_GroupObjectType',
            'Item_DescriptorObjectType' => '\\StructType\\Item_DescriptorObjectType',
            'Supplier_GroupObjectType' => '\\StructType\\Supplier_GroupObjectType',
            'Revenue_CategoryObjectType' => '\\StructType\\Revenue_CategoryObjectType',
            'Spend_CategoryObjectType' => '\\StructType\\Spend_CategoryObjectType',
            'Purchase_Item_GroupObjectType' => '\\StructType\\Purchase_Item_GroupObjectType',
            'Sales_ItemObjectType' => '\\StructType\\Sales_ItemObjectType',
            'Purchase_ItemObjectType' => '\\StructType\\Purchase_ItemObjectType',
            'Supplier_CategoryObjectType' => '\\StructType\\Supplier_CategoryObjectType',
            'Payment_TermsObjectType' => '\\StructType\\Payment_TermsObjectType',
            'Tax_RateObjectType' => '\\StructType\\Tax_RateObjectType',
            'Tax_CodeObjectType' => '\\StructType\\Tax_CodeObjectType',
            'Tax_CategoryObjectType' => '\\StructType\\Tax_CategoryObjectType',
            'Accounting_CategoryObjectType' => '\\StructType\\Accounting_CategoryObjectType',
            'Business_DocumentObjectType' => '\\StructType\\Business_DocumentObjectType',
            'Business_Document_LineObjectType' => '\\StructType\\Business_Document_LineObjectType',
            'Supplier_Invoice_LineObjectType' => '\\StructType\\Supplier_Invoice_LineObjectType',
            'Supplier_InvoiceObjectType' => '\\StructType\\Supplier_InvoiceObjectType',
            'Supplier_Invoice_AdjustmentObjectType' => '\\StructType\\Supplier_Invoice_AdjustmentObjectType',
            'Supplier_Payment_for_InvoicesObjectType' => '\\StructType\\Supplier_Payment_for_InvoicesObjectType',
            'Payment_TypeObjectType' => '\\StructType\\Payment_TypeObjectType',
            'Audited_Accounting_WorktagObjectType' => '\\StructType\\Audited_Accounting_WorktagObjectType',
            'Document_Payment_StatusObjectType' => '\\StructType\\Document_Payment_StatusObjectType',
            'Customer_InvoiceObjectType' => '\\StructType\\Customer_InvoiceObjectType',
            'Customer_Invoice_AdjustmentObjectType' => '\\StructType\\Customer_Invoice_AdjustmentObjectType',
            'ImageObjectType' => '\\StructType\\ImageObjectType',
            'Phone_Device_TypeObjectType' => '\\StructType\\Phone_Device_TypeObjectType',
            'Data_Load_StatusObjectType' => '\\StructType\\Data_Load_StatusObjectType',
            'Tax_ApplicabilityObjectType' => '\\StructType\\Tax_ApplicabilityObjectType',
            'Unit_of_MeasureObjectType' => '\\StructType\\Unit_of_MeasureObjectType',
            'Invoice_Adjustment_ReasonObjectType' => '\\StructType\\Invoice_Adjustment_ReasonObjectType',
            'Arithmetic_OperatorObjectType' => '\\StructType\\Arithmetic_OperatorObjectType',
            'PeriodObjectType' => '\\StructType\\PeriodObjectType',
            'RequisitionObjectType' => '\\StructType\\RequisitionObjectType',
            'Purchase_OrderObjectType' => '\\StructType\\Purchase_OrderObjectType',
            'Item_Requisition_LineObjectType' => '\\StructType\\Item_Requisition_LineObjectType',
            'Item_Order_LineObjectType' => '\\StructType\\Item_Order_LineObjectType',
            'ReceiptObjectType' => '\\StructType\\ReceiptObjectType',
            'Supplier_Invoice_DocumentObjectType' => '\\StructType\\Supplier_Invoice_DocumentObjectType',
            'Customer_Invoice_LineObjectType' => '\\StructType\\Customer_Invoice_LineObjectType',
            'Expense_ReportObjectType' => '\\StructType\\Expense_ReportObjectType',
            'Expense_ItemObjectType' => '\\StructType\\Expense_ItemObjectType',
            'Expense_Item_GroupObjectType' => '\\StructType\\Expense_Item_GroupObjectType',
            'Requisition_SourceObjectType' => '\\StructType\\Requisition_SourceObjectType',
            'Business_Entity_ContactObjectType' => '\\StructType\\Business_Entity_ContactObjectType',
            'CustomerObjectType' => '\\StructType\\CustomerObjectType',
            'Tax_AuthorityObjectType' => '\\StructType\\Tax_AuthorityObjectType',
            'Financial_InstitutionObjectType' => '\\StructType\\Financial_InstitutionObjectType',
            'SupplierObjectType' => '\\StructType\\SupplierObjectType',
            'And_Or_OperatorsObjectType' => '\\StructType\\And_Or_OperatorsObjectType',
            'Business_AssetObjectType' => '\\StructType\\Business_AssetObjectType',
            'Expense_PayeeObjectType' => '\\StructType\\Expense_PayeeObjectType',
            'Condition_Entry_OptionObjectType' => '\\StructType\\Condition_Entry_OptionObjectType',
            'Budget_StructureObjectType' => '\\StructType\\Budget_StructureObjectType',
            'Requisition_LineObjectType' => '\\StructType\\Requisition_LineObjectType',
            'Communication_Usage_TypeObjectType' => '\\StructType\\Communication_Usage_TypeObjectType',
            'Communication_Usage_BehaviorObjectType' => '\\StructType\\Communication_Usage_BehaviorObjectType',
            'Supplier_ContractObjectType' => '\\StructType\\Supplier_ContractObjectType',
            'Supplier_Contract_Item_LineObjectType' => '\\StructType\\Supplier_Contract_Item_LineObjectType',
            'CountryObjectType' => '\\StructType\\CountryObjectType',
            'Country_RegionObjectType' => '\\StructType\\Country_RegionObjectType',
            'Purchase_Order_LineObjectType' => '\\StructType\\Purchase_Order_LineObjectType',
            'Country_Predefined_Person_Name_Component_ValueObjectType' => '\\StructType\\Country_Predefined_Person_Name_Component_ValueObjectType',
            'CurrencyObjectType' => '\\StructType\\CurrencyObjectType',
            'Currency_Rate_TypeObjectType' => '\\StructType\\Currency_Rate_TypeObjectType',
            'Project-Based_Requisition_LineObjectType' => '\\StructType\\Project_Based_Requisition_LineObjectType',
            'Project_Plan_TaskObjectType' => '\\StructType\\Project_Plan_TaskObjectType',
            'ProjectObjectType' => '\\StructType\\ProjectObjectType',
            'Condition_RuleObjectType' => '\\StructType\\Condition_RuleObjectType',
            'Depreciation_ProfileObjectType' => '\\StructType\\Depreciation_ProfileObjectType',
            'Frequency_BehaviorObjectType' => '\\StructType\\Frequency_BehaviorObjectType',
            'Bank_Account_TypeObjectType' => '\\StructType\\Bank_Account_TypeObjectType',
            'Acquisition_MethodObjectType' => '\\StructType\\Acquisition_MethodObjectType',
            'Accounting_TreatmentObjectType' => '\\StructType\\Accounting_TreatmentObjectType',
            'Depreciation_ConventionObjectType' => '\\StructType\\Depreciation_ConventionObjectType',
            'Depreciation_Posting_FrequencyObjectType' => '\\StructType\\Depreciation_Posting_FrequencyObjectType',
            'Tenanted_Security_GroupObjectType' => '\\StructType\\Tenanted_Security_GroupObjectType',
            'Resource_ProviderObjectType' => '\\StructType\\Resource_ProviderObjectType',
            'Security_GroupObjectType' => '\\StructType\\Security_GroupObjectType',
            'Requisition_TemplateObjectType' => '\\StructType\\Requisition_TemplateObjectType',
            'Time_Entry_CodeObjectType' => '\\StructType\\Time_Entry_CodeObjectType',
            'Spend_AuthorizationObjectType' => '\\StructType\\Spend_AuthorizationObjectType',
            'Supervisory_OrganizationObjectType' => '\\StructType\\Supervisory_OrganizationObjectType',
            'CompanyObjectType' => '\\StructType\\CompanyObjectType',
            'Cost_CenterObjectType' => '\\StructType\\Cost_CenterObjectType',
            'Time_ZoneObjectType' => '\\StructType\\Time_ZoneObjectType',
            'Accounting_WorktagObjectType' => '\\StructType\\Accounting_WorktagObjectType',
            'Settlement_Bank_AccountObjectType' => '\\StructType\\Settlement_Bank_AccountObjectType',
            'Accounting_Worktag_TypeObjectType' => '\\StructType\\Accounting_Worktag_TypeObjectType',
            'Transaction_Log_TypeObjectType' => '\\StructType\\Transaction_Log_TypeObjectType',
            'Event_Lite_TypeObjectType' => '\\StructType\\Event_Lite_TypeObjectType',
            'Credit_Card_TypeObjectType' => '\\StructType\\Credit_Card_TypeObjectType',
            'Worker_Credit_CardObjectType' => '\\StructType\\Worker_Credit_CardObjectType',
            'Credit_Card_TransactionObjectType' => '\\StructType\\Credit_Card_TransactionObjectType',
            'Supplier_LinkObjectType' => '\\StructType\\Supplier_LinkObjectType',
            'Expense_StatusObjectType' => '\\StructType\\Expense_StatusObjectType',
            'Credit_Card_Transaction_FileObjectType' => '\\StructType\\Credit_Card_Transaction_FileObjectType',
            'Merchant_CodeObjectType' => '\\StructType\\Merchant_CodeObjectType',
            'Corporate_Credit_Card_AccountObjectType' => '\\StructType\\Corporate_Credit_Card_AccountObjectType',
            'Business_Entity_Status_ValueObjectType' => '\\StructType\\Business_Entity_Status_ValueObjectType',
            'Unique_IdentifierObjectType' => '\\StructType\\Unique_IdentifierObjectType',
            'Accounting_Worktag_and_Aggregation_DimensionObjectType' => '\\StructType\\Accounting_Worktag_and_Aggregation_DimensionObjectType',
            'External_FieldObjectType' => '\\StructType\\External_FieldObjectType',
            'Asset_Disposal_TypeObjectType' => '\\StructType\\Asset_Disposal_TypeObjectType',
            'Business_Asset_Disposal_MethodObjectType' => '\\StructType\\Business_Asset_Disposal_MethodObjectType',
            'Document_StatusObjectType' => '\\StructType\\Document_StatusObjectType',
            'Catalog_ItemObjectType' => '\\StructType\\Catalog_ItemObjectType',
            'Catalog_Load_ItemObjectType' => '\\StructType\\Catalog_Load_ItemObjectType',
            'Alternate_Name_UsageObjectType' => '\\StructType\\Alternate_Name_UsageObjectType',
            'Taggable_TypeObjectType' => '\\StructType\\Taggable_TypeObjectType',
            'Procurement_ItemObjectType' => '\\StructType\\Procurement_ItemObjectType',
            'Project_GroupObjectType' => '\\StructType\\Project_GroupObjectType',
            'InitiativeObjectType' => '\\StructType\\InitiativeObjectType',
            'Supplier_Invoice_HistoryObjectType' => '\\StructType\\Supplier_Invoice_HistoryObjectType',
            'Reason_for_Supplier_Status_ChangeObjectType' => '\\StructType\\Reason_for_Supplier_Status_ChangeObjectType',
            'Purchase_Order_Change_OrderObjectType' => '\\StructType\\Purchase_Order_Change_OrderObjectType',
            'Recurring_Supplier_InvoiceObjectType' => '\\StructType\\Recurring_Supplier_InvoiceObjectType',
            'Supplier_Contract_BaseObjectType' => '\\StructType\\Supplier_Contract_BaseObjectType',
            'Travel_LocationObjectType' => '\\StructType\\Travel_LocationObjectType',
            'Business_PurposeObjectType' => '\\StructType\\Business_PurposeObjectType',
            'Project_RoleObjectType' => '\\StructType\\Project_RoleObjectType',
            'Project_Resource_Plan_DetailObjectType' => '\\StructType\\Project_Resource_Plan_DetailObjectType',
            'Project_Plan_PhaseObjectType' => '\\StructType\\Project_Plan_PhaseObjectType',
            'Project_PhaseObjectType' => '\\StructType\\Project_PhaseObjectType',
            'Project_TaskObjectType' => '\\StructType\\Project_TaskObjectType',
            'Project_Resource_PlanObjectType' => '\\StructType\\Project_Resource_PlanObjectType',
            'AirlineObjectType' => '\\StructType\\AirlineObjectType',
            'HotelObjectType' => '\\StructType\\HotelObjectType',
            'Car_Rental_AgencyObjectType' => '\\StructType\\Car_Rental_AgencyObjectType',
            'Travel_CityObjectType' => '\\StructType\\Travel_CityObjectType',
            'AirportObjectType' => '\\StructType\\AirportObjectType',
            'Expense_Item_Attribute_TypeObjectType' => '\\StructType\\Expense_Item_Attribute_TypeObjectType',
            'Success_RatingObjectType' => '\\StructType\\Success_RatingObjectType',
            'Schedule_Distribution_MethodObjectType' => '\\StructType\\Schedule_Distribution_MethodObjectType',
            'Project_Plan_TemplateObjectType' => '\\StructType\\Project_Plan_TemplateObjectType',
            'Project_Resource_Plan_TemplateObjectType' => '\\StructType\\Project_Resource_Plan_TemplateObjectType',
            'Project_TemplateObjectType' => '\\StructType\\Project_TemplateObjectType',
            'Purchase_Order_Issue_OptionObjectType' => '\\StructType\\Purchase_Order_Issue_OptionObjectType',
            'Project_HierarchyObjectType' => '\\StructType\\Project_HierarchyObjectType',
            'Business_Document_Line_SplitObjectType' => '\\StructType\\Business_Document_Line_SplitObjectType',
            'Corporate_Payment_ResponsibilityObjectType' => '\\StructType\\Corporate_Payment_ResponsibilityObjectType',
            'Class_of_ServiceObjectType' => '\\StructType\\Class_of_ServiceObjectType',
            'Project_AbstractObjectType' => '\\StructType\\Project_AbstractObjectType',
            'PositionObjectType' => '\\StructType\\PositionObjectType',
            'Vehicle_TypeObjectType' => '\\StructType\\Vehicle_TypeObjectType',
            'Vehicle_PlanObjectType' => '\\StructType\\Vehicle_PlanObjectType',
            'Engine_CapacityObjectType' => '\\StructType\\Engine_CapacityObjectType',
            'Expense_Policy_GroupObjectType' => '\\StructType\\Expense_Policy_GroupObjectType',
            'Expense_Rate_TableObjectType' => '\\StructType\\Expense_Rate_TableObjectType',
            'Expense_Rate_Table_TypeObjectType' => '\\StructType\\Expense_Rate_Table_TypeObjectType',
            'Payroll_Timesheet_Total_HoursObjectType' => '\\StructType\\Payroll_Timesheet_Total_HoursObjectType',
            'Project_TimesheetObjectType' => '\\StructType\\Project_TimesheetObjectType',
            'TimesheetObjectType' => '\\StructType\\TimesheetObjectType',
            'Expense_AccumulatorObjectType' => '\\StructType\\Expense_AccumulatorObjectType',
            'Behavior_Spend_DataObjectType' => '\\StructType\\Behavior_Spend_DataObjectType',
            'ActivityObjectType' => '\\StructType\\ActivityObjectType',
            'Payroll_Timesheet_Time_In_Time_OutObjectType' => '\\StructType\\Payroll_Timesheet_Time_In_Time_OutObjectType',
            'Spend_Category_HierarchyObjectType' => '\\StructType\\Spend_Category_HierarchyObjectType',
            'Project_Member_ResourceObjectType' => '\\StructType\\Project_Member_ResourceObjectType',
            'Job_RequisitionObjectType' => '\\StructType\\Job_RequisitionObjectType',
            'InvestorObjectType' => '\\StructType\\InvestorObjectType',
            'Cardholder_Listing_FileObjectType' => '\\StructType\\Cardholder_Listing_FileObjectType',
            'Tax_ID_TypeObjectType' => '\\StructType\\Tax_ID_TypeObjectType',
            'Importance_RatingObjectType' => '\\StructType\\Importance_RatingObjectType',
            'Credit_CardObjectType' => '\\StructType\\Credit_CardObjectType',
            'Expense_Item_Attribute_GroupObjectType' => '\\StructType\\Expense_Item_Attribute_GroupObjectType',
            'Fuel_TypeObjectType' => '\\StructType\\Fuel_TypeObjectType',
            'Condition_Rule_CategoryObjectType' => '\\StructType\\Condition_Rule_CategoryObjectType',
            'Expense_Item_Accumulator_BalanceObjectType' => '\\StructType\\Expense_Item_Accumulator_BalanceObjectType',
            'Project_Cost_Rate_RuleObjectType' => '\\StructType\\Project_Cost_Rate_RuleObjectType',
            'Hotel_Charge_TypeObjectType' => '\\StructType\\Hotel_Charge_TypeObjectType',
            'Balancing_WorktagObjectType' => '\\StructType\\Balancing_WorktagObjectType',
            'Asset_Cost_Adjustment_ReasonObjectType' => '\\StructType\\Asset_Cost_Adjustment_ReasonObjectType',
            'Spend_Category_or_HierarchyObjectType' => '\\StructType\\Spend_Category_or_HierarchyObjectType',
            'Business_Asset_Amount_BasisObjectType' => '\\StructType\\Business_Asset_Amount_BasisObjectType',
            'Work_PriorityObjectType' => '\\StructType\\Work_PriorityObjectType',
            'Risk_LevelObjectType' => '\\StructType\\Risk_LevelObjectType',
            'Supplier_CatalogObjectType' => '\\StructType\\Supplier_CatalogObjectType',
            'Supplier_Invoice_Line_SplitObjectType' => '\\StructType\\Supplier_Invoice_Line_SplitObjectType',
            'Supplier_Contract_AbstractObjectType' => '\\StructType\\Supplier_Contract_AbstractObjectType',
            'Supplier_Contract_AmendmentObjectType' => '\\StructType\\Supplier_Contract_AmendmentObjectType',
            'Purchase_Order_InstallmentObjectType' => '\\StructType\\Purchase_Order_InstallmentObjectType',
            'Supplier_Invoice_InstallmentObjectType' => '\\StructType\\Supplier_Invoice_InstallmentObjectType',
            'Supplier_Contract_TypeObjectType' => '\\StructType\\Supplier_Contract_TypeObjectType',
            'Depreciation_Rate_BasisObjectType' => '\\StructType\\Depreciation_Rate_BasisObjectType',
            'Purchase_Order_Line_SplitObjectType' => '\\StructType\\Purchase_Order_Line_SplitObjectType',
            'Purchase_Order_ScheduleObjectType' => '\\StructType\\Purchase_Order_ScheduleObjectType',
            'Supplier_Invoice_ScheduleObjectType' => '\\StructType\\Supplier_Invoice_ScheduleObjectType',
            'Asset_Impairment_ReasonObjectType' => '\\StructType\\Asset_Impairment_ReasonObjectType',
            'Installment_ItemObjectType' => '\\StructType\\Installment_ItemObjectType',
            'Supplier_Contract_LineObjectType' => '\\StructType\\Supplier_Contract_LineObjectType',
            'Supplier_Contract_Amendment_TypeObjectType' => '\\StructType\\Supplier_Contract_Amendment_TypeObjectType',
            'Credit_Card_Account_Usage_IndicatorObjectType' => '\\StructType\\Credit_Card_Account_Usage_IndicatorObjectType',
            'Asset_BookObjectType' => '\\StructType\\Asset_BookObjectType',
            'Abstract_Spend_Data_NameObjectType' => '\\StructType\\Abstract_Spend_Data_NameObjectType',
            'Payment_Handling_InstructionObjectType' => '\\StructType\\Payment_Handling_InstructionObjectType',
            'Asset_TypeObjectType' => '\\StructType\\Asset_TypeObjectType',
            'Asset_ClassObjectType' => '\\StructType\\Asset_ClassObjectType',
            'Asset_Location_or_Location_HierarchyObjectType' => '\\StructType\\Asset_Location_or_Location_HierarchyObjectType',
            'Tax_OptionObjectType' => '\\StructType\\Tax_OptionObjectType',
            'Procurement_Card_Transaction_VerificationObjectType' => '\\StructType\\Procurement_Card_Transaction_VerificationObjectType',
            'Tax_TypeObjectType' => '\\StructType\\Tax_TypeObjectType',
            'Abstract_Payee_Data_NameObjectType' => '\\StructType\\Abstract_Payee_Data_NameObjectType',
            'Asset_Removal_ReasonObjectType' => '\\StructType\\Asset_Removal_ReasonObjectType',
            'Project_Scenario_GroupObjectType' => '\\StructType\\Project_Scenario_GroupObjectType',
            'Billable_EntityObjectType' => '\\StructType\\Billable_EntityObjectType',
            'Procurement_Date_OptionObjectType' => '\\StructType\\Procurement_Date_OptionObjectType',
            'Project_AssetObjectType' => '\\StructType\\Project_AssetObjectType',
            'Prepaid_Spend_Amortization_ScheduleObjectType' => '\\StructType\\Prepaid_Spend_Amortization_ScheduleObjectType',
            'Address_ReferenceObjectType' => '\\StructType\\Address_ReferenceObjectType',
            'Job_ApplicationObjectType' => '\\StructType\\Job_ApplicationObjectType',
            'Prepaid_Spend_Amortization_InstallmentObjectType' => '\\StructType\\Prepaid_Spend_Amortization_InstallmentObjectType',
            'Web_Service_Background_Process_RuntimeObjectType' => '\\StructType\\Web_Service_Background_Process_RuntimeObjectType',
            'Supplier_Invoice_Line_AbstractObjectType' => '\\StructType\\Supplier_Invoice_Line_AbstractObjectType',
            'Prepaid_Amortization_TypeObjectType' => '\\StructType\\Prepaid_Amortization_TypeObjectType',
            'Spend_Category_or_Hierarchy_Display_OptionObjectType' => '\\StructType\\Spend_Category_or_Hierarchy_Display_OptionObjectType',
            'Payee_TypeObjectType' => '\\StructType\\Payee_TypeObjectType',
            'Industry_Code_TypeObjectType' => '\\StructType\\Industry_Code_TypeObjectType',
            'Communication_Usage_Behavior_TenantedObjectType' => '\\StructType\\Communication_Usage_Behavior_TenantedObjectType',
            'Hierarchy_LevelObjectType' => '\\StructType\\Hierarchy_LevelObjectType',
            'Tax_Authority_Form_TypeObjectType' => '\\StructType\\Tax_Authority_Form_TypeObjectType',
            'Return_to_Supplier_ReasonObjectType' => '\\StructType\\Return_to_Supplier_ReasonObjectType',
            'Asset_Pooling_RuleObjectType' => '\\StructType\\Asset_Pooling_RuleObjectType',
            'Return_to_SupplierObjectType' => '\\StructType\\Return_to_SupplierObjectType',
            'Procurement_Document_TypeObjectType' => '\\StructType\\Procurement_Document_TypeObjectType',
            'Procurement_Document_Mass_ActionObjectType' => '\\StructType\\Procurement_Document_Mass_ActionObjectType',
            'Travel_Booking_RecordObjectType' => '\\StructType\\Travel_Booking_RecordObjectType',
            'Travel_Booking_FileObjectType' => '\\StructType\\Travel_Booking_FileObjectType',
            'Booking_StatusObjectType' => '\\StructType\\Booking_StatusObjectType',
            'Travel_Booking_Record_TypeObjectType' => '\\StructType\\Travel_Booking_Record_TypeObjectType',
            'QuestionnaireObjectType' => '\\StructType\\QuestionnaireObjectType',
            'Requisition_TypeObjectType' => '\\StructType\\Requisition_TypeObjectType',
            'Unit_of_Time_for_ProcurementObjectType' => '\\StructType\\Unit_of_Time_for_ProcurementObjectType',
            'CommitteeObjectType' => '\\StructType\\CommitteeObjectType',
            'Project_Template_Date_Offset_TypeObjectType' => '\\StructType\\Project_Template_Date_Offset_TypeObjectType',
            'Unit_of_Measure_SetObjectType' => '\\StructType\\Unit_of_Measure_SetObjectType',
            'Event_Attachment_CategoryObjectType' => '\\StructType\\Event_Attachment_CategoryObjectType',
            'Request_for_Quote_Bid_Requirement_TypeObjectType' => '\\StructType\\Request_for_Quote_Bid_Requirement_TypeObjectType',
            'Request_for_Quote_Bid_Requirement_ClassificationObjectType' => '\\StructType\\Request_for_Quote_Bid_Requirement_ClassificationObjectType',
            'Request_for_Quote_Line_TypeObjectType' => '\\StructType\\Request_for_Quote_Line_TypeObjectType',
            'Request_for_QuoteObjectType' => '\\StructType\\Request_for_QuoteObjectType',
            'Abstract_Request_for_Quote_ParticipantObjectType' => '\\StructType\\Abstract_Request_for_Quote_ParticipantObjectType',
            'Request_for_Quote_LineObjectType' => '\\StructType\\Request_for_Quote_LineObjectType',
            'Request_for_Quote_TypeObjectType' => '\\StructType\\Request_for_Quote_TypeObjectType',
            'Abstract_Request_for_Quote_Bid_RequirementObjectType' => '\\StructType\\Abstract_Request_for_Quote_Bid_RequirementObjectType',
            'Order_Service_LineObjectType' => '\\StructType\\Order_Service_LineObjectType',
            'Item_Identifier_TypeObjectType' => '\\StructType\\Item_Identifier_TypeObjectType',
            'Supplier_Contract_Service_LineObjectType' => '\\StructType\\Supplier_Contract_Service_LineObjectType',
            'Project_StageObjectType' => '\\StructType\\Project_StageObjectType',
            'Service_Requisition_LineObjectType' => '\\StructType\\Service_Requisition_LineObjectType',
            'Request_for_Quote_ResponseObjectType' => '\\StructType\\Request_for_Quote_ResponseObjectType',
            'Request_for_Quote_Response_LineObjectType' => '\\StructType\\Request_for_Quote_Response_LineObjectType',
            'Abstract_Request_for_Quote_Bid_ResponseObjectType' => '\\StructType\\Abstract_Request_for_Quote_Bid_ResponseObjectType',
            'Remit-To_Supplier_ConnectionObjectType' => '\\StructType\\Remit_To_Supplier_ConnectionObjectType',
            'Request_for_Quote_Award_TypeObjectType' => '\\StructType\\Request_for_Quote_Award_TypeObjectType',
            'Request_for_Quote_AwardObjectType' => '\\StructType\\Request_for_Quote_AwardObjectType',
            'Request_for_Quote_Award_LineObjectType' => '\\StructType\\Request_for_Quote_Award_LineObjectType',
            'Country_CityObjectType' => '\\StructType\\Country_CityObjectType',
            'Replenishment_OptionObjectType' => '\\StructType\\Replenishment_OptionObjectType',
            'Replenishment_TypeObjectType' => '\\StructType\\Replenishment_TypeObjectType',
            'Expense_EligibilityObjectType' => '\\StructType\\Expense_EligibilityObjectType',
            'Universal_Item_Identifier_TypeObjectType' => '\\StructType\\Universal_Item_Identifier_TypeObjectType',
            'Requisition_Sourcing_RuleObjectType' => '\\StructType\\Requisition_Sourcing_RuleObjectType',
            'Guest_Listing_FileObjectType' => '\\StructType\\Guest_Listing_FileObjectType',
            'Resource_ForecastObjectType' => '\\StructType\\Resource_ForecastObjectType',
            'Resource_Forecast_LineObjectType' => '\\StructType\\Resource_Forecast_LineObjectType',
            'Inventory_ABC_ClassificationObjectType' => '\\StructType\\Inventory_ABC_ClassificationObjectType',
            'Cash_Advance_RepaymentObjectType' => '\\StructType\\Cash_Advance_RepaymentObjectType',
            'Procurement_Award_ReasonObjectType' => '\\StructType\\Procurement_Award_ReasonObjectType',
            'Project_ResourceObjectType' => '\\StructType\\Project_ResourceObjectType',
            'Project_Standard_Cost_Rate_SheetObjectType' => '\\StructType\\Project_Standard_Cost_Rate_SheetObjectType',
            'Inventory_Stock_Request_TypeObjectType' => '\\StructType\\Inventory_Stock_Request_TypeObjectType',
            'Abstract_Retainable_LineObjectType' => '\\StructType\\Abstract_Retainable_LineObjectType',
            'Delivery_TypeObjectType' => '\\StructType\\Delivery_TypeObjectType',
            'Business_Entity_Contact_TypeObjectType' => '\\StructType\\Business_Entity_Contact_TypeObjectType',
            'Business_Entity_Contact_Type_TenantedObjectType' => '\\StructType\\Business_Entity_Contact_Type_TenantedObjectType',
            'Credit_Card_Transaction_TypeObjectType' => '\\StructType\\Credit_Card_Transaction_TypeObjectType',
            'Internal_Service_DeliveryObjectType' => '\\StructType\\Internal_Service_DeliveryObjectType',
            'Internal_Service_ProviderObjectType' => '\\StructType\\Internal_Service_ProviderObjectType',
            'Internal_Service_Delivery_LineObjectType' => '\\StructType\\Internal_Service_Delivery_LineObjectType',
            'Internal_Service_Delivery_Line_SplitObjectType' => '\\StructType\\Internal_Service_Delivery_Line_SplitObjectType',
            'Shipping_TermsObjectType' => '\\StructType\\Shipping_TermsObjectType',
            'Shipping_MethodObjectType' => '\\StructType\\Shipping_MethodObjectType',
            'Transaction_Tax_StatusObjectType' => '\\StructType\\Transaction_Tax_StatusObjectType',
            'Withholding_Tax_StatusObjectType' => '\\StructType\\Withholding_Tax_StatusObjectType',
            'ManufacturerObjectType' => '\\StructType\\ManufacturerObjectType',
            'Item_LotObjectType' => '\\StructType\\Item_LotObjectType',
            'Item_SerialObjectType' => '\\StructType\\Item_SerialObjectType',
            'Abstract_Procurement_CatalogObjectType' => '\\StructType\\Abstract_Procurement_CatalogObjectType',
            'Internal_Service_CatalogObjectType' => '\\StructType\\Internal_Service_CatalogObjectType',
            'Supplier_Invoice_RequestObjectType' => '\\StructType\\Supplier_Invoice_RequestObjectType',
            'Supplier_Invoice_Request_LineObjectType' => '\\StructType\\Supplier_Invoice_Request_LineObjectType',
            'Supplier_Invoice_Request_Line_SplitObjectType' => '\\StructType\\Supplier_Invoice_Request_Line_SplitObjectType',
            'Project_Booking_StatusObjectType' => '\\StructType\\Project_Booking_StatusObjectType',
            'Serial_Control_MethodObjectType' => '\\StructType\\Serial_Control_MethodObjectType',
            'Item_TagObjectType' => '\\StructType\\Item_TagObjectType',
            'Project_Task_Resource_TemplateObjectType' => '\\StructType\\Project_Task_Resource_TemplateObjectType',
            'Advanced_Ship_NoticeObjectType' => '\\StructType\\Advanced_Ship_NoticeObjectType',
            'Advanced_Ship_Notice_LineObjectType' => '\\StructType\\Advanced_Ship_Notice_LineObjectType',
            'Goods_Delivery_LineObjectType' => '\\StructType\\Goods_Delivery_LineObjectType',
            'Purchase_Order_AcknowledgementObjectType' => '\\StructType\\Purchase_Order_AcknowledgementObjectType',
            'PO_Acknowledgement_LineObjectType' => '\\StructType\\PO_Acknowledgement_LineObjectType',
            'PO_Acknowledgement_StatusObjectType' => '\\StructType\\PO_Acknowledgement_StatusObjectType',
            'Document_Creation_MethodObjectType' => '\\StructType\\Document_Creation_MethodObjectType',
            'Worker_Travel_Profile_Listing_FileObjectType' => '\\StructType\\Worker_Travel_Profile_Listing_FileObjectType',
            'Location_Customer_Account_Number_DetailObjectType' => '\\StructType\\Location_Customer_Account_Number_DetailObjectType',
            'Email_ReferenceObjectType' => '\\StructType\\Email_ReferenceObjectType',
            'Project_Role_CategoryObjectType' => '\\StructType\\Project_Role_CategoryObjectType',
            'Invoice_TypeObjectType' => '\\StructType\\Invoice_TypeObjectType',
            'Tax_RecoverabilityObjectType' => '\\StructType\\Tax_RecoverabilityObjectType',
            'Custom_Supplier_ClassificationObjectType' => '\\StructType\\Custom_Supplier_ClassificationObjectType',
            'Custom_Supplier_Classification_FieldObjectType' => '\\StructType\\Custom_Supplier_Classification_FieldObjectType',
            'Supplier_Classification_TypeObjectType' => '\\StructType\\Supplier_Classification_TypeObjectType',
            'Supplier_Security_SegmentObjectType' => '\\StructType\\Supplier_Security_SegmentObjectType',
            'Phone_ReferenceObjectType' => '\\StructType\\Phone_ReferenceObjectType',
            'Custom_Supplier_Classification_Field_ChoiceObjectType' => '\\StructType\\Custom_Supplier_Classification_Field_ChoiceObjectType',
            'Reopen_Procurement_Documents_EventObjectType' => '\\StructType\\Reopen_Procurement_Documents_EventObjectType',
            'Catalog_Load_Item_Unit_of_MeasureObjectType' => '\\StructType\\Catalog_Load_Item_Unit_of_MeasureObjectType',
            'Receivable_RepaymentObjectType' => '\\StructType\\Receivable_RepaymentObjectType',
            'Additional_Reference_TypeObjectType' => '\\StructType\\Additional_Reference_TypeObjectType',
            'Resource_Pool_HierarchyObjectType' => '\\StructType\\Resource_Pool_HierarchyObjectType',
            'Resource_PoolObjectType' => '\\StructType\\Resource_PoolObjectType',
            'Abstract_Depreciation_MethodObjectType' => '\\StructType\\Abstract_Depreciation_MethodObjectType',
            'Lease_Accounting_MethodObjectType' => '\\StructType\\Lease_Accounting_MethodObjectType',
            'Project_StateObjectType' => '\\StructType\\Project_StateObjectType',
            'Abstract_Place_In_Service_Based_OnObjectType' => '\\StructType\\Abstract_Place_In_Service_Based_OnObjectType',
            'Order_TypeObjectType' => '\\StructType\\Order_TypeObjectType',
            'Tax_Point_Date_TypeObjectType' => '\\StructType\\Tax_Point_Date_TypeObjectType',
            'Consigned_Reorder_InitiationObjectType' => '\\StructType\\Consigned_Reorder_InitiationObjectType',
            'Transfer_Pricing_Rate_SheetObjectType' => '\\StructType\\Transfer_Pricing_Rate_SheetObjectType',
            'Order-From_Supplier_ConnectionObjectType' => '\\StructType\\Order_From_Supplier_ConnectionObjectType',
            'Workbook_Template_FieldObjectType' => '\\StructType\\Workbook_Template_FieldObjectType',
            'Web_Address_ReferenceObjectType' => '\\StructType\\Web_Address_ReferenceObjectType',
            'Instant_Messenger_ReferenceObjectType' => '\\StructType\\Instant_Messenger_ReferenceObjectType',
            'Worksheet_Template_TypeObjectType' => '\\StructType\\Worksheet_Template_TypeObjectType',
            'UOM_UsageObjectType' => '\\StructType\\UOM_UsageObjectType',
            'Supplier_Item_Details_AbstractObjectType' => '\\StructType\\Supplier_Item_Details_AbstractObjectType',
            'Supplier_ItemObjectType' => '\\StructType\\Supplier_ItemObjectType',
            'Revenue_CenterObjectType' => '\\StructType\\Revenue_CenterObjectType',
            'Patient_Charge_InformationObjectType' => '\\StructType\\Patient_Charge_InformationObjectType',
            'Travel_Journal_TypeObjectType' => '\\StructType\\Travel_Journal_TypeObjectType',
            'Project_Worker_Rate_Standard_Cost_Rate_PriorityObjectType' => '\\StructType\\Project_Worker_Rate_Standard_Cost_Rate_PriorityObjectType',
            'Supplier_Contract_Lease_Amendment_TypeObjectType' => '\\StructType\\Supplier_Contract_Lease_Amendment_TypeObjectType',
            'Credit_Card_CategoryObjectType' => '\\StructType\\Credit_Card_CategoryObjectType',
            'Supplier_Item_Advanced_PricingObjectType' => '\\StructType\\Supplier_Item_Advanced_PricingObjectType',
            'Template_Field_Valid_Values_BooleanObjectType' => '\\StructType\\Template_Field_Valid_Values_BooleanObjectType',
            'Supplier_Invoice_Work_Queue_TagObjectType' => '\\StructType\\Supplier_Invoice_Work_Queue_TagObjectType',
            'Utilization_Target_SheetObjectType' => '\\StructType\\Utilization_Target_SheetObjectType',
            'Utilization_Target_PriorityObjectType' => '\\StructType\\Utilization_Target_PriorityObjectType',
            'Supplier_Invoice_Assignment_RuleObjectType' => '\\StructType\\Supplier_Invoice_Assignment_RuleObjectType',
            'Project_PortfolioObjectType' => '\\StructType\\Project_PortfolioObjectType',
            'Customer_Contract_TemplateObjectType' => '\\StructType\\Customer_Contract_TemplateObjectType',
            'Supplier_Invoice_Work_Queue_Tag_Assignment_RuleObjectType' => '\\StructType\\Supplier_Invoice_Work_Queue_Tag_Assignment_RuleObjectType',
            'Item_Substitute_UsageObjectType' => '\\StructType\\Item_Substitute_UsageObjectType',
            'Worktag_Split_Template_CriteriaObjectType' => '\\StructType\\Worktag_Split_Template_CriteriaObjectType',
            'Worktag_Split_TemplateObjectType' => '\\StructType\\Worktag_Split_TemplateObjectType',
            'Worktag_Split_Template_SnapshotObjectType' => '\\StructType\\Worktag_Split_Template_SnapshotObjectType',
            'Worktag_Split_Template_ItemObjectType' => '\\StructType\\Worktag_Split_Template_ItemObjectType',
            'Reason_CodeObjectType' => '\\StructType\\Reason_CodeObjectType',
            'Template_Item_Display_OptionObjectType' => '\\StructType\\Template_Item_Display_OptionObjectType',
            'Patient_ChargeObjectType' => '\\StructType\\Patient_ChargeObjectType',
            'Receipt_AdjustmentObjectType' => '\\StructType\\Receipt_AdjustmentObjectType',
            'External_Transaction_Source__All_ObjectType' => '\\StructType\\External_Transaction_Source__All_ObjectType',
            'External_Transaction_SourceObjectType' => '\\StructType\\External_Transaction_SourceObjectType',
            'Fare_CategoryObjectType' => '\\StructType\\Fare_CategoryObjectType',
            'Purchase_Item_Request_TemplateObjectType' => '\\StructType\\Purchase_Item_Request_TemplateObjectType',
            'Purchase_Item_Request_Template__All_ObjectType' => '\\StructType\\Purchase_Item_Request_Template__All_ObjectType',
            'Ticket_TypeObjectType' => '\\StructType\\Ticket_TypeObjectType',
            'Purchase_Item_Request_TypeObjectType' => '\\StructType\\Purchase_Item_Request_TypeObjectType',
            'Purchase_Item_Request_Enrichment_TemplatesObjectType' => '\\StructType\\Purchase_Item_Request_Enrichment_TemplatesObjectType',
            'Commodity_Code_TypeObjectType' => '\\StructType\\Commodity_Code_TypeObjectType',
            'Commodity_CodeObjectType' => '\\StructType\\Commodity_CodeObjectType',
            'Project_Budget_TemplateObjectType' => '\\StructType\\Project_Budget_TemplateObjectType',
            'Netting_RuleObjectType' => '\\StructType\\Netting_RuleObjectType',
            'Netting_TransactionObjectType' => '\\StructType\\Netting_TransactionObjectType',
            'Configurable_AttributeObjectType' => '\\StructType\\Configurable_AttributeObjectType',
            'Supplier_Invoice_Document_Configurable_Attribute_ValueObjectType' => '\\StructType\\Supplier_Invoice_Document_Configurable_Attribute_ValueObjectType',
            'Supplier_Invoice_System_Validation_ConfigurationObjectType' => '\\StructType\\Supplier_Invoice_System_Validation_ConfigurationObjectType',
            'Supplier_Invoice_System_ValidationObjectType' => '\\StructType\\Supplier_Invoice_System_ValidationObjectType',
            'Expense_Item_Unit_of_MeasureObjectType' => '\\StructType\\Expense_Item_Unit_of_MeasureObjectType',
            'Inventory_Location_EnabledObjectType' => '\\StructType\\Inventory_Location_EnabledObjectType',
            'Supplier_RefundObjectType' => '\\StructType\\Supplier_RefundObjectType',
            'External_Transaction_Source_UsageObjectType' => '\\StructType\\External_Transaction_Source_UsageObjectType',
            'External_Sourceable_AbstractObjectType' => '\\StructType\\External_Sourceable_AbstractObjectType',
            'Requesting_EntityObjectType' => '\\StructType\\Requesting_EntityObjectType',
            'Restricted_Purchase_Item_ListObjectType' => '\\StructType\\Restricted_Purchase_Item_ListObjectType',
            'Spend_Item_StatusObjectType' => '\\StructType\\Spend_Item_StatusObjectType',
            'Requesting_Entity_AbstractObjectType' => '\\StructType\\Requesting_Entity_AbstractObjectType',
            'Capital_Project_Asset_Assignment_RuleObjectType' => '\\StructType\\Capital_Project_Asset_Assignment_RuleObjectType',
            'Tax_ID_Validation_ServiceObjectType' => '\\StructType\\Tax_ID_Validation_ServiceObjectType',
            'Custom_Supplier_Classification_Category__Workday_Owned_ObjectType' => '\\StructType\\Custom_Supplier_Classification_Category__Workday_Owned_ObjectType',
            'Custom_Supplier_Classification_Category__All_ObjectType' => '\\StructType\\Custom_Supplier_Classification_Category__All_ObjectType',
            'Dock_Carrier__Audited_ObjectType' => '\\StructType\\Dock_Carrier__Audited_ObjectType',
            'Attachment_CategoryObjectType' => '\\StructType\\Attachment_CategoryObjectType',
            'Inventory_Distribution_NetworkObjectType' => '\\StructType\\Inventory_Distribution_NetworkObjectType',
            'Payment_Purpose_CodeObjectType' => '\\StructType\\Payment_Purpose_CodeObjectType',
            'Invoice_Cancel_Reason__All_ObjectType' => '\\StructType\\Invoice_Cancel_Reason__All_ObjectType',
            'System_UserObjectIDType' => '\\StructType\\System_UserObjectIDType',
            'Relational_OperatorObjectIDType' => '\\StructType\\Relational_OperatorObjectIDType',
            'Rounding_OptionObjectIDType' => '\\StructType\\Rounding_OptionObjectIDType',
            'LocationObjectIDType' => '\\StructType\\LocationObjectIDType',
            'Job_ProfileObjectIDType' => '\\StructType\\Job_ProfileObjectIDType',
            'OrganizationObjectIDType' => '\\StructType\\OrganizationObjectIDType',
            'Organization_SubtypeObjectIDType' => '\\StructType\\Organization_SubtypeObjectIDType',
            'EmployeeObjectIDType' => '\\StructType\\EmployeeObjectIDType',
            'Instant_Messenger_TypeObjectIDType' => '\\StructType\\Instant_Messenger_TypeObjectIDType',
            'WorkerObjectIDType' => '\\StructType\\WorkerObjectIDType',
            'Contingent_WorkerObjectIDType' => '\\StructType\\Contingent_WorkerObjectIDType',
            'Position_Time_TypeObjectIDType' => '\\StructType\\Position_Time_TypeObjectIDType',
            'ContactObjectIDType' => '\\StructType\\ContactObjectIDType',
            'Integration_System__Audited_ObjectIDType' => '\\StructType\\Integration_System__Audited_ObjectIDType',
            'Financial_Report_GroupObjectIDType' => '\\StructType\\Financial_Report_GroupObjectIDType',
            'Item_DescriptorObjectIDType' => '\\StructType\\Item_DescriptorObjectIDType',
            'Supplier_GroupObjectIDType' => '\\StructType\\Supplier_GroupObjectIDType',
            'Revenue_CategoryObjectIDType' => '\\StructType\\Revenue_CategoryObjectIDType',
            'Spend_CategoryObjectIDType' => '\\StructType\\Spend_CategoryObjectIDType',
            'Purchase_Item_GroupObjectIDType' => '\\StructType\\Purchase_Item_GroupObjectIDType',
            'Sales_ItemObjectIDType' => '\\StructType\\Sales_ItemObjectIDType',
            'Purchase_ItemObjectIDType' => '\\StructType\\Purchase_ItemObjectIDType',
            'Supplier_CategoryObjectIDType' => '\\StructType\\Supplier_CategoryObjectIDType',
            'Payment_TermsObjectIDType' => '\\StructType\\Payment_TermsObjectIDType',
            'Tax_RateObjectIDType' => '\\StructType\\Tax_RateObjectIDType',
            'Tax_CodeObjectIDType' => '\\StructType\\Tax_CodeObjectIDType',
            'Tax_CategoryObjectIDType' => '\\StructType\\Tax_CategoryObjectIDType',
            'Accounting_CategoryObjectIDType' => '\\StructType\\Accounting_CategoryObjectIDType',
            'Business_DocumentObjectIDType' => '\\StructType\\Business_DocumentObjectIDType',
            'Business_Document_LineObjectIDType' => '\\StructType\\Business_Document_LineObjectIDType',
            'Supplier_Invoice_LineObjectIDType' => '\\StructType\\Supplier_Invoice_LineObjectIDType',
            'Supplier_InvoiceObjectIDType' => '\\StructType\\Supplier_InvoiceObjectIDType',
            'Supplier_Invoice_AdjustmentObjectIDType' => '\\StructType\\Supplier_Invoice_AdjustmentObjectIDType',
            'Supplier_Payment_for_InvoicesObjectIDType' => '\\StructType\\Supplier_Payment_for_InvoicesObjectIDType',
            'Payment_TypeObjectIDType' => '\\StructType\\Payment_TypeObjectIDType',
            'Audited_Accounting_WorktagObjectIDType' => '\\StructType\\Audited_Accounting_WorktagObjectIDType',
            'Document_Payment_StatusObjectIDType' => '\\StructType\\Document_Payment_StatusObjectIDType',
            'Customer_InvoiceObjectIDType' => '\\StructType\\Customer_InvoiceObjectIDType',
            'Customer_Invoice_AdjustmentObjectIDType' => '\\StructType\\Customer_Invoice_AdjustmentObjectIDType',
            'ImageObjectIDType' => '\\StructType\\ImageObjectIDType',
            'Phone_Device_TypeObjectIDType' => '\\StructType\\Phone_Device_TypeObjectIDType',
            'Data_Load_StatusObjectIDType' => '\\StructType\\Data_Load_StatusObjectIDType',
            'Tax_ApplicabilityObjectIDType' => '\\StructType\\Tax_ApplicabilityObjectIDType',
            'Unit_of_MeasureObjectIDType' => '\\StructType\\Unit_of_MeasureObjectIDType',
            'Invoice_Adjustment_ReasonObjectIDType' => '\\StructType\\Invoice_Adjustment_ReasonObjectIDType',
            'Arithmetic_OperatorObjectIDType' => '\\StructType\\Arithmetic_OperatorObjectIDType',
            'PeriodObjectIDType' => '\\StructType\\PeriodObjectIDType',
            'RequisitionObjectIDType' => '\\StructType\\RequisitionObjectIDType',
            'Purchase_OrderObjectIDType' => '\\StructType\\Purchase_OrderObjectIDType',
            'Item_Requisition_LineObjectIDType' => '\\StructType\\Item_Requisition_LineObjectIDType',
            'Item_Order_LineObjectIDType' => '\\StructType\\Item_Order_LineObjectIDType',
            'ReceiptObjectIDType' => '\\StructType\\ReceiptObjectIDType',
            'Supplier_Invoice_DocumentObjectIDType' => '\\StructType\\Supplier_Invoice_DocumentObjectIDType',
            'Customer_Invoice_LineObjectIDType' => '\\StructType\\Customer_Invoice_LineObjectIDType',
            'Expense_ReportObjectIDType' => '\\StructType\\Expense_ReportObjectIDType',
            'Expense_ItemObjectIDType' => '\\StructType\\Expense_ItemObjectIDType',
            'Expense_Item_GroupObjectIDType' => '\\StructType\\Expense_Item_GroupObjectIDType',
            'Requisition_SourceObjectIDType' => '\\StructType\\Requisition_SourceObjectIDType',
            'Business_Entity_ContactObjectIDType' => '\\StructType\\Business_Entity_ContactObjectIDType',
            'CustomerObjectIDType' => '\\StructType\\CustomerObjectIDType',
            'Tax_AuthorityObjectIDType' => '\\StructType\\Tax_AuthorityObjectIDType',
            'Financial_InstitutionObjectIDType' => '\\StructType\\Financial_InstitutionObjectIDType',
            'SupplierObjectIDType' => '\\StructType\\SupplierObjectIDType',
            'And_Or_OperatorsObjectIDType' => '\\StructType\\And_Or_OperatorsObjectIDType',
            'Business_AssetObjectIDType' => '\\StructType\\Business_AssetObjectIDType',
            'Expense_PayeeObjectIDType' => '\\StructType\\Expense_PayeeObjectIDType',
            'Condition_Entry_OptionObjectIDType' => '\\StructType\\Condition_Entry_OptionObjectIDType',
            'Budget_StructureObjectIDType' => '\\StructType\\Budget_StructureObjectIDType',
            'Requisition_LineObjectIDType' => '\\StructType\\Requisition_LineObjectIDType',
            'Communication_Usage_TypeObjectIDType' => '\\StructType\\Communication_Usage_TypeObjectIDType',
            'Communication_Usage_BehaviorObjectIDType' => '\\StructType\\Communication_Usage_BehaviorObjectIDType',
            'Supplier_ContractObjectIDType' => '\\StructType\\Supplier_ContractObjectIDType',
            'Supplier_Contract_Item_LineObjectIDType' => '\\StructType\\Supplier_Contract_Item_LineObjectIDType',
            'CountryObjectIDType' => '\\StructType\\CountryObjectIDType',
            'Country_RegionObjectIDType' => '\\StructType\\Country_RegionObjectIDType',
            'Purchase_Order_LineObjectIDType' => '\\StructType\\Purchase_Order_LineObjectIDType',
            'Country_Predefined_Person_Name_Component_ValueObjectIDType' => '\\StructType\\Country_Predefined_Person_Name_Component_ValueObjectIDType',
            'CurrencyObjectIDType' => '\\StructType\\CurrencyObjectIDType',
            'Currency_Rate_TypeObjectIDType' => '\\StructType\\Currency_Rate_TypeObjectIDType',
            'Project-Based_Requisition_LineObjectIDType' => '\\StructType\\Project_Based_Requisition_LineObjectIDType',
            'Project_Plan_TaskObjectIDType' => '\\StructType\\Project_Plan_TaskObjectIDType',
            'ProjectObjectIDType' => '\\StructType\\ProjectObjectIDType',
            'Condition_RuleObjectIDType' => '\\StructType\\Condition_RuleObjectIDType',
            'Depreciation_ProfileObjectIDType' => '\\StructType\\Depreciation_ProfileObjectIDType',
            'Frequency_BehaviorObjectIDType' => '\\StructType\\Frequency_BehaviorObjectIDType',
            'Bank_Account_TypeObjectIDType' => '\\StructType\\Bank_Account_TypeObjectIDType',
            'Acquisition_MethodObjectIDType' => '\\StructType\\Acquisition_MethodObjectIDType',
            'Accounting_TreatmentObjectIDType' => '\\StructType\\Accounting_TreatmentObjectIDType',
            'Depreciation_ConventionObjectIDType' => '\\StructType\\Depreciation_ConventionObjectIDType',
            'Depreciation_Posting_FrequencyObjectIDType' => '\\StructType\\Depreciation_Posting_FrequencyObjectIDType',
            'Tenanted_Security_GroupObjectIDType' => '\\StructType\\Tenanted_Security_GroupObjectIDType',
            'Resource_ProviderObjectIDType' => '\\StructType\\Resource_ProviderObjectIDType',
            'Security_GroupObjectIDType' => '\\StructType\\Security_GroupObjectIDType',
            'Requisition_TemplateObjectIDType' => '\\StructType\\Requisition_TemplateObjectIDType',
            'Time_Entry_CodeObjectIDType' => '\\StructType\\Time_Entry_CodeObjectIDType',
            'Spend_AuthorizationObjectIDType' => '\\StructType\\Spend_AuthorizationObjectIDType',
            'Supervisory_OrganizationObjectIDType' => '\\StructType\\Supervisory_OrganizationObjectIDType',
            'CompanyObjectIDType' => '\\StructType\\CompanyObjectIDType',
            'Cost_CenterObjectIDType' => '\\StructType\\Cost_CenterObjectIDType',
            'Time_ZoneObjectIDType' => '\\StructType\\Time_ZoneObjectIDType',
            'Accounting_WorktagObjectIDType' => '\\StructType\\Accounting_WorktagObjectIDType',
            'Settlement_Bank_AccountObjectIDType' => '\\StructType\\Settlement_Bank_AccountObjectIDType',
            'Accounting_Worktag_TypeObjectIDType' => '\\StructType\\Accounting_Worktag_TypeObjectIDType',
            'Transaction_Log_TypeObjectIDType' => '\\StructType\\Transaction_Log_TypeObjectIDType',
            'Event_Lite_TypeObjectIDType' => '\\StructType\\Event_Lite_TypeObjectIDType',
            'Credit_Card_TypeObjectIDType' => '\\StructType\\Credit_Card_TypeObjectIDType',
            'Worker_Credit_CardObjectIDType' => '\\StructType\\Worker_Credit_CardObjectIDType',
            'Credit_Card_TransactionObjectIDType' => '\\StructType\\Credit_Card_TransactionObjectIDType',
            'Supplier_LinkObjectIDType' => '\\StructType\\Supplier_LinkObjectIDType',
            'Expense_StatusObjectIDType' => '\\StructType\\Expense_StatusObjectIDType',
            'Credit_Card_Transaction_FileObjectIDType' => '\\StructType\\Credit_Card_Transaction_FileObjectIDType',
            'Merchant_CodeObjectIDType' => '\\StructType\\Merchant_CodeObjectIDType',
            'Corporate_Credit_Card_AccountObjectIDType' => '\\StructType\\Corporate_Credit_Card_AccountObjectIDType',
            'Business_Entity_Status_ValueObjectIDType' => '\\StructType\\Business_Entity_Status_ValueObjectIDType',
            'Unique_IdentifierObjectIDType' => '\\StructType\\Unique_IdentifierObjectIDType',
            'Accounting_Worktag_and_Aggregation_DimensionObjectIDType' => '\\StructType\\Accounting_Worktag_and_Aggregation_DimensionObjectIDType',
            'External_FieldObjectIDType' => '\\StructType\\External_FieldObjectIDType',
            'Asset_Disposal_TypeObjectIDType' => '\\StructType\\Asset_Disposal_TypeObjectIDType',
            'Business_Asset_Disposal_MethodObjectIDType' => '\\StructType\\Business_Asset_Disposal_MethodObjectIDType',
            'Document_StatusObjectIDType' => '\\StructType\\Document_StatusObjectIDType',
            'Catalog_ItemObjectIDType' => '\\StructType\\Catalog_ItemObjectIDType',
            'Catalog_Load_ItemObjectIDType' => '\\StructType\\Catalog_Load_ItemObjectIDType',
            'Alternate_Name_UsageObjectIDType' => '\\StructType\\Alternate_Name_UsageObjectIDType',
            'Taggable_TypeObjectIDType' => '\\StructType\\Taggable_TypeObjectIDType',
            'Procurement_ItemObjectIDType' => '\\StructType\\Procurement_ItemObjectIDType',
            'Project_GroupObjectIDType' => '\\StructType\\Project_GroupObjectIDType',
            'InitiativeObjectIDType' => '\\StructType\\InitiativeObjectIDType',
            'Supplier_Invoice_HistoryObjectIDType' => '\\StructType\\Supplier_Invoice_HistoryObjectIDType',
            'Reason_for_Supplier_Status_ChangeObjectIDType' => '\\StructType\\Reason_for_Supplier_Status_ChangeObjectIDType',
            'Purchase_Order_Change_OrderObjectIDType' => '\\StructType\\Purchase_Order_Change_OrderObjectIDType',
            'Recurring_Supplier_InvoiceObjectIDType' => '\\StructType\\Recurring_Supplier_InvoiceObjectIDType',
            'Supplier_Contract_BaseObjectIDType' => '\\StructType\\Supplier_Contract_BaseObjectIDType',
            'Travel_LocationObjectIDType' => '\\StructType\\Travel_LocationObjectIDType',
            'Business_PurposeObjectIDType' => '\\StructType\\Business_PurposeObjectIDType',
            'Project_RoleObjectIDType' => '\\StructType\\Project_RoleObjectIDType',
            'Project_Resource_Plan_DetailObjectIDType' => '\\StructType\\Project_Resource_Plan_DetailObjectIDType',
            'Project_Plan_PhaseObjectIDType' => '\\StructType\\Project_Plan_PhaseObjectIDType',
            'Project_PhaseObjectIDType' => '\\StructType\\Project_PhaseObjectIDType',
            'Project_TaskObjectIDType' => '\\StructType\\Project_TaskObjectIDType',
            'Project_Resource_PlanObjectIDType' => '\\StructType\\Project_Resource_PlanObjectIDType',
            'AirlineObjectIDType' => '\\StructType\\AirlineObjectIDType',
            'HotelObjectIDType' => '\\StructType\\HotelObjectIDType',
            'Car_Rental_AgencyObjectIDType' => '\\StructType\\Car_Rental_AgencyObjectIDType',
            'Travel_CityObjectIDType' => '\\StructType\\Travel_CityObjectIDType',
            'AirportObjectIDType' => '\\StructType\\AirportObjectIDType',
            'Expense_Item_Attribute_TypeObjectIDType' => '\\StructType\\Expense_Item_Attribute_TypeObjectIDType',
            'Success_RatingObjectIDType' => '\\StructType\\Success_RatingObjectIDType',
            'Schedule_Distribution_MethodObjectIDType' => '\\StructType\\Schedule_Distribution_MethodObjectIDType',
            'Project_Plan_TemplateObjectIDType' => '\\StructType\\Project_Plan_TemplateObjectIDType',
            'Project_Resource_Plan_TemplateObjectIDType' => '\\StructType\\Project_Resource_Plan_TemplateObjectIDType',
            'Project_TemplateObjectIDType' => '\\StructType\\Project_TemplateObjectIDType',
            'Purchase_Order_Issue_OptionObjectIDType' => '\\StructType\\Purchase_Order_Issue_OptionObjectIDType',
            'Project_HierarchyObjectIDType' => '\\StructType\\Project_HierarchyObjectIDType',
            'Business_Document_Line_SplitObjectIDType' => '\\StructType\\Business_Document_Line_SplitObjectIDType',
            'Corporate_Payment_ResponsibilityObjectIDType' => '\\StructType\\Corporate_Payment_ResponsibilityObjectIDType',
            'Class_of_ServiceObjectIDType' => '\\StructType\\Class_of_ServiceObjectIDType',
            'Project_AbstractObjectIDType' => '\\StructType\\Project_AbstractObjectIDType',
            'PositionObjectIDType' => '\\StructType\\PositionObjectIDType',
            'Vehicle_TypeObjectIDType' => '\\StructType\\Vehicle_TypeObjectIDType',
            'Vehicle_PlanObjectIDType' => '\\StructType\\Vehicle_PlanObjectIDType',
            'Engine_CapacityObjectIDType' => '\\StructType\\Engine_CapacityObjectIDType',
            'Expense_Policy_GroupObjectIDType' => '\\StructType\\Expense_Policy_GroupObjectIDType',
            'Expense_Rate_TableObjectIDType' => '\\StructType\\Expense_Rate_TableObjectIDType',
            'Expense_Rate_Table_TypeObjectIDType' => '\\StructType\\Expense_Rate_Table_TypeObjectIDType',
            'Payroll_Timesheet_Total_HoursObjectIDType' => '\\StructType\\Payroll_Timesheet_Total_HoursObjectIDType',
            'Project_TimesheetObjectIDType' => '\\StructType\\Project_TimesheetObjectIDType',
            'TimesheetObjectIDType' => '\\StructType\\TimesheetObjectIDType',
            'Expense_AccumulatorObjectIDType' => '\\StructType\\Expense_AccumulatorObjectIDType',
            'Behavior_Spend_DataObjectIDType' => '\\StructType\\Behavior_Spend_DataObjectIDType',
            'ActivityObjectIDType' => '\\StructType\\ActivityObjectIDType',
            'Payroll_Timesheet_Time_In_Time_OutObjectIDType' => '\\StructType\\Payroll_Timesheet_Time_In_Time_OutObjectIDType',
            'Spend_Category_HierarchyObjectIDType' => '\\StructType\\Spend_Category_HierarchyObjectIDType',
            'Project_Member_ResourceObjectIDType' => '\\StructType\\Project_Member_ResourceObjectIDType',
            'Job_RequisitionObjectIDType' => '\\StructType\\Job_RequisitionObjectIDType',
            'InvestorObjectIDType' => '\\StructType\\InvestorObjectIDType',
            'Cardholder_Listing_FileObjectIDType' => '\\StructType\\Cardholder_Listing_FileObjectIDType',
            'Tax_ID_TypeObjectIDType' => '\\StructType\\Tax_ID_TypeObjectIDType',
            'Importance_RatingObjectIDType' => '\\StructType\\Importance_RatingObjectIDType',
            'Credit_CardObjectIDType' => '\\StructType\\Credit_CardObjectIDType',
            'Expense_Item_Attribute_GroupObjectIDType' => '\\StructType\\Expense_Item_Attribute_GroupObjectIDType',
            'Fuel_TypeObjectIDType' => '\\StructType\\Fuel_TypeObjectIDType',
            'Condition_Rule_CategoryObjectIDType' => '\\StructType\\Condition_Rule_CategoryObjectIDType',
            'Expense_Item_Accumulator_BalanceObjectIDType' => '\\StructType\\Expense_Item_Accumulator_BalanceObjectIDType',
            'Project_Cost_Rate_RuleObjectIDType' => '\\StructType\\Project_Cost_Rate_RuleObjectIDType',
            'Hotel_Charge_TypeObjectIDType' => '\\StructType\\Hotel_Charge_TypeObjectIDType',
            'Balancing_WorktagObjectIDType' => '\\StructType\\Balancing_WorktagObjectIDType',
            'Asset_Cost_Adjustment_ReasonObjectIDType' => '\\StructType\\Asset_Cost_Adjustment_ReasonObjectIDType',
            'Spend_Category_or_HierarchyObjectIDType' => '\\StructType\\Spend_Category_or_HierarchyObjectIDType',
            'Business_Asset_Amount_BasisObjectIDType' => '\\StructType\\Business_Asset_Amount_BasisObjectIDType',
            'Work_PriorityObjectIDType' => '\\StructType\\Work_PriorityObjectIDType',
            'Risk_LevelObjectIDType' => '\\StructType\\Risk_LevelObjectIDType',
            'Supplier_CatalogObjectIDType' => '\\StructType\\Supplier_CatalogObjectIDType',
            'Supplier_Invoice_Line_SplitObjectIDType' => '\\StructType\\Supplier_Invoice_Line_SplitObjectIDType',
            'Supplier_Contract_AbstractObjectIDType' => '\\StructType\\Supplier_Contract_AbstractObjectIDType',
            'Supplier_Contract_AmendmentObjectIDType' => '\\StructType\\Supplier_Contract_AmendmentObjectIDType',
            'Purchase_Order_InstallmentObjectIDType' => '\\StructType\\Purchase_Order_InstallmentObjectIDType',
            'Supplier_Invoice_InstallmentObjectIDType' => '\\StructType\\Supplier_Invoice_InstallmentObjectIDType',
            'Supplier_Contract_TypeObjectIDType' => '\\StructType\\Supplier_Contract_TypeObjectIDType',
            'Depreciation_Rate_BasisObjectIDType' => '\\StructType\\Depreciation_Rate_BasisObjectIDType',
            'Purchase_Order_Line_SplitObjectIDType' => '\\StructType\\Purchase_Order_Line_SplitObjectIDType',
            'Purchase_Order_ScheduleObjectIDType' => '\\StructType\\Purchase_Order_ScheduleObjectIDType',
            'Supplier_Invoice_ScheduleObjectIDType' => '\\StructType\\Supplier_Invoice_ScheduleObjectIDType',
            'Asset_Impairment_ReasonObjectIDType' => '\\StructType\\Asset_Impairment_ReasonObjectIDType',
            'Installment_ItemObjectIDType' => '\\StructType\\Installment_ItemObjectIDType',
            'Supplier_Contract_LineObjectIDType' => '\\StructType\\Supplier_Contract_LineObjectIDType',
            'Supplier_Contract_Amendment_TypeObjectIDType' => '\\StructType\\Supplier_Contract_Amendment_TypeObjectIDType',
            'Credit_Card_Account_Usage_IndicatorObjectIDType' => '\\StructType\\Credit_Card_Account_Usage_IndicatorObjectIDType',
            'Asset_BookObjectIDType' => '\\StructType\\Asset_BookObjectIDType',
            'Abstract_Spend_Data_NameObjectIDType' => '\\StructType\\Abstract_Spend_Data_NameObjectIDType',
            'Payment_Handling_InstructionObjectIDType' => '\\StructType\\Payment_Handling_InstructionObjectIDType',
            'Asset_TypeObjectIDType' => '\\StructType\\Asset_TypeObjectIDType',
            'Asset_ClassObjectIDType' => '\\StructType\\Asset_ClassObjectIDType',
            'Asset_Location_or_Location_HierarchyObjectIDType' => '\\StructType\\Asset_Location_or_Location_HierarchyObjectIDType',
            'Tax_OptionObjectIDType' => '\\StructType\\Tax_OptionObjectIDType',
            'Procurement_Card_Transaction_VerificationObjectIDType' => '\\StructType\\Procurement_Card_Transaction_VerificationObjectIDType',
            'Tax_TypeObjectIDType' => '\\StructType\\Tax_TypeObjectIDType',
            'Abstract_Payee_Data_NameObjectIDType' => '\\StructType\\Abstract_Payee_Data_NameObjectIDType',
            'Asset_Removal_ReasonObjectIDType' => '\\StructType\\Asset_Removal_ReasonObjectIDType',
            'Project_Scenario_GroupObjectIDType' => '\\StructType\\Project_Scenario_GroupObjectIDType',
            'Billable_EntityObjectIDType' => '\\StructType\\Billable_EntityObjectIDType',
            'Procurement_Date_OptionObjectIDType' => '\\StructType\\Procurement_Date_OptionObjectIDType',
            'Project_AssetObjectIDType' => '\\StructType\\Project_AssetObjectIDType',
            'Prepaid_Spend_Amortization_ScheduleObjectIDType' => '\\StructType\\Prepaid_Spend_Amortization_ScheduleObjectIDType',
            'Address_ReferenceObjectIDType' => '\\StructType\\Address_ReferenceObjectIDType',
            'Job_ApplicationObjectIDType' => '\\StructType\\Job_ApplicationObjectIDType',
            'Prepaid_Spend_Amortization_InstallmentObjectIDType' => '\\StructType\\Prepaid_Spend_Amortization_InstallmentObjectIDType',
            'Web_Service_Background_Process_RuntimeObjectIDType' => '\\StructType\\Web_Service_Background_Process_RuntimeObjectIDType',
            'Supplier_Invoice_Line_AbstractObjectIDType' => '\\StructType\\Supplier_Invoice_Line_AbstractObjectIDType',
            'Prepaid_Amortization_TypeObjectIDType' => '\\StructType\\Prepaid_Amortization_TypeObjectIDType',
            'Spend_Category_or_Hierarchy_Display_OptionObjectIDType' => '\\StructType\\Spend_Category_or_Hierarchy_Display_OptionObjectIDType',
            'Payee_TypeObjectIDType' => '\\StructType\\Payee_TypeObjectIDType',
            'Industry_Code_TypeObjectIDType' => '\\StructType\\Industry_Code_TypeObjectIDType',
            'Communication_Usage_Behavior_TenantedObjectIDType' => '\\StructType\\Communication_Usage_Behavior_TenantedObjectIDType',
            'Hierarchy_LevelObjectIDType' => '\\StructType\\Hierarchy_LevelObjectIDType',
            'Tax_Authority_Form_TypeObjectIDType' => '\\StructType\\Tax_Authority_Form_TypeObjectIDType',
            'Return_to_Supplier_ReasonObjectIDType' => '\\StructType\\Return_to_Supplier_ReasonObjectIDType',
            'Asset_Pooling_RuleObjectIDType' => '\\StructType\\Asset_Pooling_RuleObjectIDType',
            'Return_to_SupplierObjectIDType' => '\\StructType\\Return_to_SupplierObjectIDType',
            'Procurement_Document_TypeObjectIDType' => '\\StructType\\Procurement_Document_TypeObjectIDType',
            'Procurement_Document_Mass_ActionObjectIDType' => '\\StructType\\Procurement_Document_Mass_ActionObjectIDType',
            'Travel_Booking_RecordObjectIDType' => '\\StructType\\Travel_Booking_RecordObjectIDType',
            'Travel_Booking_FileObjectIDType' => '\\StructType\\Travel_Booking_FileObjectIDType',
            'Booking_StatusObjectIDType' => '\\StructType\\Booking_StatusObjectIDType',
            'Travel_Booking_Record_TypeObjectIDType' => '\\StructType\\Travel_Booking_Record_TypeObjectIDType',
            'QuestionnaireObjectIDType' => '\\StructType\\QuestionnaireObjectIDType',
            'Requisition_TypeObjectIDType' => '\\StructType\\Requisition_TypeObjectIDType',
            'Unit_of_Time_for_ProcurementObjectIDType' => '\\StructType\\Unit_of_Time_for_ProcurementObjectIDType',
            'CommitteeObjectIDType' => '\\StructType\\CommitteeObjectIDType',
            'Project_Template_Date_Offset_TypeObjectIDType' => '\\StructType\\Project_Template_Date_Offset_TypeObjectIDType',
            'Unit_of_Measure_SetObjectIDType' => '\\StructType\\Unit_of_Measure_SetObjectIDType',
            'Event_Attachment_CategoryObjectIDType' => '\\StructType\\Event_Attachment_CategoryObjectIDType',
            'Request_for_Quote_Bid_Requirement_TypeObjectIDType' => '\\StructType\\Request_for_Quote_Bid_Requirement_TypeObjectIDType',
            'Request_for_Quote_Bid_Requirement_ClassificationObjectIDType' => '\\StructType\\Request_for_Quote_Bid_Requirement_ClassificationObjectIDType',
            'Request_for_Quote_Line_TypeObjectIDType' => '\\StructType\\Request_for_Quote_Line_TypeObjectIDType',
            'Request_for_QuoteObjectIDType' => '\\StructType\\Request_for_QuoteObjectIDType',
            'Abstract_Request_for_Quote_ParticipantObjectIDType' => '\\StructType\\Abstract_Request_for_Quote_ParticipantObjectIDType',
            'Request_for_Quote_LineObjectIDType' => '\\StructType\\Request_for_Quote_LineObjectIDType',
            'Request_for_Quote_TypeObjectIDType' => '\\StructType\\Request_for_Quote_TypeObjectIDType',
            'Abstract_Request_for_Quote_Bid_RequirementObjectIDType' => '\\StructType\\Abstract_Request_for_Quote_Bid_RequirementObjectIDType',
            'Order_Service_LineObjectIDType' => '\\StructType\\Order_Service_LineObjectIDType',
            'Item_Identifier_TypeObjectIDType' => '\\StructType\\Item_Identifier_TypeObjectIDType',
            'Supplier_Contract_Service_LineObjectIDType' => '\\StructType\\Supplier_Contract_Service_LineObjectIDType',
            'Project_StageObjectIDType' => '\\StructType\\Project_StageObjectIDType',
            'Service_Requisition_LineObjectIDType' => '\\StructType\\Service_Requisition_LineObjectIDType',
            'Request_for_Quote_ResponseObjectIDType' => '\\StructType\\Request_for_Quote_ResponseObjectIDType',
            'Request_for_Quote_Response_LineObjectIDType' => '\\StructType\\Request_for_Quote_Response_LineObjectIDType',
            'Abstract_Request_for_Quote_Bid_ResponseObjectIDType' => '\\StructType\\Abstract_Request_for_Quote_Bid_ResponseObjectIDType',
            'Remit-To_Supplier_ConnectionObjectIDType' => '\\StructType\\Remit_To_Supplier_ConnectionObjectIDType',
            'Request_for_Quote_Award_TypeObjectIDType' => '\\StructType\\Request_for_Quote_Award_TypeObjectIDType',
            'Request_for_Quote_AwardObjectIDType' => '\\StructType\\Request_for_Quote_AwardObjectIDType',
            'Request_for_Quote_Award_LineObjectIDType' => '\\StructType\\Request_for_Quote_Award_LineObjectIDType',
            'Country_CityObjectIDType' => '\\StructType\\Country_CityObjectIDType',
            'Replenishment_OptionObjectIDType' => '\\StructType\\Replenishment_OptionObjectIDType',
            'Replenishment_TypeObjectIDType' => '\\StructType\\Replenishment_TypeObjectIDType',
            'Expense_EligibilityObjectIDType' => '\\StructType\\Expense_EligibilityObjectIDType',
            'Universal_Item_Identifier_TypeObjectIDType' => '\\StructType\\Universal_Item_Identifier_TypeObjectIDType',
            'Requisition_Sourcing_RuleObjectIDType' => '\\StructType\\Requisition_Sourcing_RuleObjectIDType',
            'Guest_Listing_FileObjectIDType' => '\\StructType\\Guest_Listing_FileObjectIDType',
            'Resource_ForecastObjectIDType' => '\\StructType\\Resource_ForecastObjectIDType',
            'Resource_Forecast_LineObjectIDType' => '\\StructType\\Resource_Forecast_LineObjectIDType',
            'Inventory_ABC_ClassificationObjectIDType' => '\\StructType\\Inventory_ABC_ClassificationObjectIDType',
            'Cash_Advance_RepaymentObjectIDType' => '\\StructType\\Cash_Advance_RepaymentObjectIDType',
            'Procurement_Award_ReasonObjectIDType' => '\\StructType\\Procurement_Award_ReasonObjectIDType',
            'Project_ResourceObjectIDType' => '\\StructType\\Project_ResourceObjectIDType',
            'Project_Standard_Cost_Rate_SheetObjectIDType' => '\\StructType\\Project_Standard_Cost_Rate_SheetObjectIDType',
            'Inventory_Stock_Request_TypeObjectIDType' => '\\StructType\\Inventory_Stock_Request_TypeObjectIDType',
            'Abstract_Retainable_LineObjectIDType' => '\\StructType\\Abstract_Retainable_LineObjectIDType',
            'Delivery_TypeObjectIDType' => '\\StructType\\Delivery_TypeObjectIDType',
            'Business_Entity_Contact_TypeObjectIDType' => '\\StructType\\Business_Entity_Contact_TypeObjectIDType',
            'Business_Entity_Contact_Type_TenantedObjectIDType' => '\\StructType\\Business_Entity_Contact_Type_TenantedObjectIDType',
            'Credit_Card_Transaction_TypeObjectIDType' => '\\StructType\\Credit_Card_Transaction_TypeObjectIDType',
            'Internal_Service_DeliveryObjectIDType' => '\\StructType\\Internal_Service_DeliveryObjectIDType',
            'Internal_Service_ProviderObjectIDType' => '\\StructType\\Internal_Service_ProviderObjectIDType',
            'Internal_Service_Delivery_LineObjectIDType' => '\\StructType\\Internal_Service_Delivery_LineObjectIDType',
            'Internal_Service_Delivery_Line_SplitObjectIDType' => '\\StructType\\Internal_Service_Delivery_Line_SplitObjectIDType',
            'Shipping_TermsObjectIDType' => '\\StructType\\Shipping_TermsObjectIDType',
            'Shipping_MethodObjectIDType' => '\\StructType\\Shipping_MethodObjectIDType',
            'Transaction_Tax_StatusObjectIDType' => '\\StructType\\Transaction_Tax_StatusObjectIDType',
            'Withholding_Tax_StatusObjectIDType' => '\\StructType\\Withholding_Tax_StatusObjectIDType',
            'ManufacturerObjectIDType' => '\\StructType\\ManufacturerObjectIDType',
            'Item_LotObjectIDType' => '\\StructType\\Item_LotObjectIDType',
            'Item_SerialObjectIDType' => '\\StructType\\Item_SerialObjectIDType',
            'Abstract_Procurement_CatalogObjectIDType' => '\\StructType\\Abstract_Procurement_CatalogObjectIDType',
            'Internal_Service_CatalogObjectIDType' => '\\StructType\\Internal_Service_CatalogObjectIDType',
            'Supplier_Invoice_RequestObjectIDType' => '\\StructType\\Supplier_Invoice_RequestObjectIDType',
            'Supplier_Invoice_Request_LineObjectIDType' => '\\StructType\\Supplier_Invoice_Request_LineObjectIDType',
            'Supplier_Invoice_Request_Line_SplitObjectIDType' => '\\StructType\\Supplier_Invoice_Request_Line_SplitObjectIDType',
            'Project_Booking_StatusObjectIDType' => '\\StructType\\Project_Booking_StatusObjectIDType',
            'Serial_Control_MethodObjectIDType' => '\\StructType\\Serial_Control_MethodObjectIDType',
            'Item_TagObjectIDType' => '\\StructType\\Item_TagObjectIDType',
            'Project_Task_Resource_TemplateObjectIDType' => '\\StructType\\Project_Task_Resource_TemplateObjectIDType',
            'Advanced_Ship_NoticeObjectIDType' => '\\StructType\\Advanced_Ship_NoticeObjectIDType',
            'Advanced_Ship_Notice_LineObjectIDType' => '\\StructType\\Advanced_Ship_Notice_LineObjectIDType',
            'Goods_Delivery_LineObjectIDType' => '\\StructType\\Goods_Delivery_LineObjectIDType',
            'Purchase_Order_AcknowledgementObjectIDType' => '\\StructType\\Purchase_Order_AcknowledgementObjectIDType',
            'PO_Acknowledgement_LineObjectIDType' => '\\StructType\\PO_Acknowledgement_LineObjectIDType',
            'PO_Acknowledgement_StatusObjectIDType' => '\\StructType\\PO_Acknowledgement_StatusObjectIDType',
            'Document_Creation_MethodObjectIDType' => '\\StructType\\Document_Creation_MethodObjectIDType',
            'Worker_Travel_Profile_Listing_FileObjectIDType' => '\\StructType\\Worker_Travel_Profile_Listing_FileObjectIDType',
            'Location_Customer_Account_Number_DetailObjectIDType' => '\\StructType\\Location_Customer_Account_Number_DetailObjectIDType',
            'Email_ReferenceObjectIDType' => '\\StructType\\Email_ReferenceObjectIDType',
            'Project_Role_CategoryObjectIDType' => '\\StructType\\Project_Role_CategoryObjectIDType',
            'Invoice_TypeObjectIDType' => '\\StructType\\Invoice_TypeObjectIDType',
            'Tax_RecoverabilityObjectIDType' => '\\StructType\\Tax_RecoverabilityObjectIDType',
            'Custom_Supplier_ClassificationObjectIDType' => '\\StructType\\Custom_Supplier_ClassificationObjectIDType',
            'Custom_Supplier_Classification_FieldObjectIDType' => '\\StructType\\Custom_Supplier_Classification_FieldObjectIDType',
            'Supplier_Classification_TypeObjectIDType' => '\\StructType\\Supplier_Classification_TypeObjectIDType',
            'Supplier_Security_SegmentObjectIDType' => '\\StructType\\Supplier_Security_SegmentObjectIDType',
            'Phone_ReferenceObjectIDType' => '\\StructType\\Phone_ReferenceObjectIDType',
            'Custom_Supplier_Classification_Field_ChoiceObjectIDType' => '\\StructType\\Custom_Supplier_Classification_Field_ChoiceObjectIDType',
            'Reopen_Procurement_Documents_EventObjectIDType' => '\\StructType\\Reopen_Procurement_Documents_EventObjectIDType',
            'Catalog_Load_Item_Unit_of_MeasureObjectIDType' => '\\StructType\\Catalog_Load_Item_Unit_of_MeasureObjectIDType',
            'Receivable_RepaymentObjectIDType' => '\\StructType\\Receivable_RepaymentObjectIDType',
            'Additional_Reference_TypeObjectIDType' => '\\StructType\\Additional_Reference_TypeObjectIDType',
            'Resource_Pool_HierarchyObjectIDType' => '\\StructType\\Resource_Pool_HierarchyObjectIDType',
            'Resource_PoolObjectIDType' => '\\StructType\\Resource_PoolObjectIDType',
            'Abstract_Depreciation_MethodObjectIDType' => '\\StructType\\Abstract_Depreciation_MethodObjectIDType',
            'Lease_Accounting_MethodObjectIDType' => '\\StructType\\Lease_Accounting_MethodObjectIDType',
            'Project_StateObjectIDType' => '\\StructType\\Project_StateObjectIDType',
            'Abstract_Place_In_Service_Based_OnObjectIDType' => '\\StructType\\Abstract_Place_In_Service_Based_OnObjectIDType',
            'Order_TypeObjectIDType' => '\\StructType\\Order_TypeObjectIDType',
            'Tax_Point_Date_TypeObjectIDType' => '\\StructType\\Tax_Point_Date_TypeObjectIDType',
            'Consigned_Reorder_InitiationObjectIDType' => '\\StructType\\Consigned_Reorder_InitiationObjectIDType',
            'Transfer_Pricing_Rate_SheetObjectIDType' => '\\StructType\\Transfer_Pricing_Rate_SheetObjectIDType',
            'Order-From_Supplier_ConnectionObjectIDType' => '\\StructType\\Order_From_Supplier_ConnectionObjectIDType',
            'Workbook_Template_FieldObjectIDType' => '\\StructType\\Workbook_Template_FieldObjectIDType',
            'Web_Address_ReferenceObjectIDType' => '\\StructType\\Web_Address_ReferenceObjectIDType',
            'Instant_Messenger_ReferenceObjectIDType' => '\\StructType\\Instant_Messenger_ReferenceObjectIDType',
            'Worksheet_Template_TypeObjectIDType' => '\\StructType\\Worksheet_Template_TypeObjectIDType',
            'UOM_UsageObjectIDType' => '\\StructType\\UOM_UsageObjectIDType',
            'Supplier_Item_Details_AbstractObjectIDType' => '\\StructType\\Supplier_Item_Details_AbstractObjectIDType',
            'Supplier_ItemObjectIDType' => '\\StructType\\Supplier_ItemObjectIDType',
            'Revenue_CenterObjectIDType' => '\\StructType\\Revenue_CenterObjectIDType',
            'Patient_Charge_InformationObjectIDType' => '\\StructType\\Patient_Charge_InformationObjectIDType',
            'Travel_Journal_TypeObjectIDType' => '\\StructType\\Travel_Journal_TypeObjectIDType',
            'Project_Worker_Rate_Standard_Cost_Rate_PriorityObjectIDType' => '\\StructType\\Project_Worker_Rate_Standard_Cost_Rate_PriorityObjectIDType',
            'Supplier_Contract_Lease_Amendment_TypeObjectIDType' => '\\StructType\\Supplier_Contract_Lease_Amendment_TypeObjectIDType',
            'Credit_Card_CategoryObjectIDType' => '\\StructType\\Credit_Card_CategoryObjectIDType',
            'Supplier_Item_Advanced_PricingObjectIDType' => '\\StructType\\Supplier_Item_Advanced_PricingObjectIDType',
            'Template_Field_Valid_Values_BooleanObjectIDType' => '\\StructType\\Template_Field_Valid_Values_BooleanObjectIDType',
            'Supplier_Invoice_Work_Queue_TagObjectIDType' => '\\StructType\\Supplier_Invoice_Work_Queue_TagObjectIDType',
            'Utilization_Target_SheetObjectIDType' => '\\StructType\\Utilization_Target_SheetObjectIDType',
            'Utilization_Target_PriorityObjectIDType' => '\\StructType\\Utilization_Target_PriorityObjectIDType',
            'Supplier_Invoice_Assignment_RuleObjectIDType' => '\\StructType\\Supplier_Invoice_Assignment_RuleObjectIDType',
            'Project_PortfolioObjectIDType' => '\\StructType\\Project_PortfolioObjectIDType',
            'Customer_Contract_TemplateObjectIDType' => '\\StructType\\Customer_Contract_TemplateObjectIDType',
            'Supplier_Invoice_Work_Queue_Tag_Assignment_RuleObjectIDType' => '\\StructType\\Supplier_Invoice_Work_Queue_Tag_Assignment_RuleObjectIDType',
            'Item_Substitute_UsageObjectIDType' => '\\StructType\\Item_Substitute_UsageObjectIDType',
            'Worktag_Split_Template_CriteriaObjectIDType' => '\\StructType\\Worktag_Split_Template_CriteriaObjectIDType',
            'Worktag_Split_TemplateObjectIDType' => '\\StructType\\Worktag_Split_TemplateObjectIDType',
            'Worktag_Split_Template_SnapshotObjectIDType' => '\\StructType\\Worktag_Split_Template_SnapshotObjectIDType',
            'Worktag_Split_Template_ItemObjectIDType' => '\\StructType\\Worktag_Split_Template_ItemObjectIDType',
            'Reason_CodeObjectIDType' => '\\StructType\\Reason_CodeObjectIDType',
            'Template_Item_Display_OptionObjectIDType' => '\\StructType\\Template_Item_Display_OptionObjectIDType',
            'Patient_ChargeObjectIDType' => '\\StructType\\Patient_ChargeObjectIDType',
            'Receipt_AdjustmentObjectIDType' => '\\StructType\\Receipt_AdjustmentObjectIDType',
            'External_Transaction_Source__All_ObjectIDType' => '\\StructType\\External_Transaction_Source__All_ObjectIDType',
            'External_Transaction_SourceObjectIDType' => '\\StructType\\External_Transaction_SourceObjectIDType',
            'Fare_CategoryObjectIDType' => '\\StructType\\Fare_CategoryObjectIDType',
            'Purchase_Item_Request_TemplateObjectIDType' => '\\StructType\\Purchase_Item_Request_TemplateObjectIDType',
            'Purchase_Item_Request_Template__All_ObjectIDType' => '\\StructType\\Purchase_Item_Request_Template__All_ObjectIDType',
            'Ticket_TypeObjectIDType' => '\\StructType\\Ticket_TypeObjectIDType',
            'Purchase_Item_Request_TypeObjectIDType' => '\\StructType\\Purchase_Item_Request_TypeObjectIDType',
            'Purchase_Item_Request_Enrichment_TemplatesObjectIDType' => '\\StructType\\Purchase_Item_Request_Enrichment_TemplatesObjectIDType',
            'Commodity_Code_TypeObjectIDType' => '\\StructType\\Commodity_Code_TypeObjectIDType',
            'Commodity_CodeObjectIDType' => '\\StructType\\Commodity_CodeObjectIDType',
            'Project_Budget_TemplateObjectIDType' => '\\StructType\\Project_Budget_TemplateObjectIDType',
            'Netting_RuleObjectIDType' => '\\StructType\\Netting_RuleObjectIDType',
            'Netting_TransactionObjectIDType' => '\\StructType\\Netting_TransactionObjectIDType',
            'Configurable_AttributeObjectIDType' => '\\StructType\\Configurable_AttributeObjectIDType',
            'Supplier_Invoice_Document_Configurable_Attribute_ValueObjectIDType' => '\\StructType\\Supplier_Invoice_Document_Configurable_Attribute_ValueObjectIDType',
            'Supplier_Invoice_System_Validation_ConfigurationObjectIDType' => '\\StructType\\Supplier_Invoice_System_Validation_ConfigurationObjectIDType',
            'Supplier_Invoice_System_ValidationObjectIDType' => '\\StructType\\Supplier_Invoice_System_ValidationObjectIDType',
            'Expense_Item_Unit_of_MeasureObjectIDType' => '\\StructType\\Expense_Item_Unit_of_MeasureObjectIDType',
            'Inventory_Location_EnabledObjectIDType' => '\\StructType\\Inventory_Location_EnabledObjectIDType',
            'Supplier_RefundObjectIDType' => '\\StructType\\Supplier_RefundObjectIDType',
            'External_Transaction_Source_UsageObjectIDType' => '\\StructType\\External_Transaction_Source_UsageObjectIDType',
            'External_Sourceable_AbstractObjectIDType' => '\\StructType\\External_Sourceable_AbstractObjectIDType',
            'Requesting_EntityObjectIDType' => '\\StructType\\Requesting_EntityObjectIDType',
            'Restricted_Purchase_Item_ListObjectIDType' => '\\StructType\\Restricted_Purchase_Item_ListObjectIDType',
            'Spend_Item_StatusObjectIDType' => '\\StructType\\Spend_Item_StatusObjectIDType',
            'Requesting_Entity_AbstractObjectIDType' => '\\StructType\\Requesting_Entity_AbstractObjectIDType',
            'Capital_Project_Asset_Assignment_RuleObjectIDType' => '\\StructType\\Capital_Project_Asset_Assignment_RuleObjectIDType',
            'Tax_ID_Validation_ServiceObjectIDType' => '\\StructType\\Tax_ID_Validation_ServiceObjectIDType',
            'Custom_Supplier_Classification_Category__Workday_Owned_ObjectIDType' => '\\StructType\\Custom_Supplier_Classification_Category__Workday_Owned_ObjectIDType',
            'Custom_Supplier_Classification_Category__All_ObjectIDType' => '\\StructType\\Custom_Supplier_Classification_Category__All_ObjectIDType',
            'Dock_Carrier__Audited_ObjectIDType' => '\\StructType\\Dock_Carrier__Audited_ObjectIDType',
            'Attachment_CategoryObjectIDType' => '\\StructType\\Attachment_CategoryObjectIDType',
            'Inventory_Distribution_NetworkObjectIDType' => '\\StructType\\Inventory_Distribution_NetworkObjectIDType',
            'Payment_Purpose_CodeObjectIDType' => '\\StructType\\Payment_Purpose_CodeObjectIDType',
            'Invoice_Cancel_Reason__All_ObjectIDType' => '\\StructType\\Invoice_Cancel_Reason__All_ObjectIDType',
            'Instance_IDType' => '\\StructType\\Instance_IDType',
            'InstanceObjectType' => '\\StructType\\InstanceObjectType',
            'Workday_Common_HeaderType' => '\\StructType\\Workday_Common_HeaderType',
        );
    }
}
